# Generated by Makefile. Do not edit.

2021-07-19  Curtis Gedak <gedakc@gmail.com>

    ==========   gparted-1.3.1   ==========

2021-07-15  Philipp Kiemle <philipp.kiemle@gmail.com>

    Update German translation

2021-07-14  Wolfgang Stöggl <c72578@yahoo.de>

    Update German translation

2021-07-14  Claude Paroz <claude@2xlibre.net>

    Updated French translation

2021-07-14  Ngọc Quân Trần <vnwildman@gmail.com>

    Update Vietnamese translation

2021-07-13  Daniel Șerbănescu <daniel@serbanescu.dk>

    Update Romanian translation

2021-07-13  Daniel Mustieles <daniel.mustieles@gmail.com>

    Updated Spanish translation

2021-07-12  Enrico Nicoletto <liverig@gmail.com>

    Update Brazilian Portuguese translation

2021-07-12  Baurzhan Muftakhidinov <baurthefirst@gmail.com>

    Update Kazakh translation

2021-06-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Copy XFS UUID when copying the file system (!85)
    
    For the same reason as in the previous commit, the UUID is copied when
    copying every file system type except for XFS, where a new XFS is
    created with a new UUID.
    
    Again preview of the copy operation expects the UUID to be copied.
    (Look in Partition > Information of the source and pasted partitions
    before the operation is applied).
    
    Fix as before by specifying the desired file system UUID when creating
    the new XFS as part of the copy operation.
    
    However there is an extra complication.  The XFS kernel driver refuses
    to mount a file system with a duplicate UUID of an already mounted XFS.
    
        # mkfs.xfs -L xfs_copy /dev/sdb1
        # mount /dev/sdb1 /mnt/1
        # tail -2 /var/log/messages
        Jun  3 21:41:24 localhost kernel: XFS (sdb1): Mounting V5 Filesystem
        Jun  3 21:41:24 localhost kernel: XFS (sdb1): Ending clean mount
    
        # /dev/sdb1: LABEL="xfs_copy" UUID="d654fc7f-e417-4ec6-88e8-8a7d0d46b7d8" TYPE="xfs"
        # mkfs.xfs -L xfs_copy -m uuid="d654fc7f-e417-4ec6-88e8-8a7d0d46b7d8" /dev/sdb2
        # mount /dev/sdb2 /mnt/2
        mount: wrong fs type, bad option, bad superblock on /dev/sdb2,
               missing codepage or helper program, or other error.
    
               In some cases useful info is found in syslog - try
               dmesg | tail or so.
        # echo $?
        32
        # tail -1 /var/log/messages
        Jun  3 21:41:31 localhost kernel: XFS (sdb2): File system has duplicate UUID d654fc7f-e417-4ec6-88e8-8a7d0d46b7d8 - can't mount
    
    Handle this specifying the needed option [1] when mounting the second
    XFS during the copy.
    
        # mount -o nouuid /dev/sdb2 /mnt/2
        # mount | grep /dev/sdb
        /dev/sdb1 on /mnt/1 type xfs (rw,relatime,seclabel,attr2,inode64,noquota)
        /dev/sdb1 on /mnt/1 type xfs (rw,relatime,seclabel,nouuid,attr2,inode64,noquota)
    
    Duplicating the UUID may seem troublesome, but it is being done:
    1.  To make the GParted copied XFS be as much a clone as possible, to
        match what is does with other file systems.
    2.  It has a valid use case; of cloning a Linux installation to a new
        drive or restoring a partition image backup.  In these cases it is
        much simpler if the UUID of the copy remains the same because it
        avoids having to edit GRUB2 configuration and fstab file system
        mounting which is nearly always done via UUID.
    3.  GParted has the new UUID operation, to change the UUID for cases
        when a copied file system needs to be mounted at the same time as
        the source.
    
    [1] xfs(5) - xfs - layout, mount options, and supported file attributes
        for the XFS filesystem
        https://man7.org/linux/man-pages/man5/xfs.5.html
        "MOUNT OPTIONS
        ...
        nouuid Don't check for double mounted file systems using the file
               system uuid.
        "
    
    Closes !85 - Make XFS copy duplicate the file system label and UUID

2021-05-27  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Copy XFS label when copying the file system (!85)
    
    As GParted performs block copy of partitions then the label, which is
    stored in the file system superblock, is also copied.  This is true for
    copies performed using the GParted internal block copy and for EXT2/3/4
    and NTFS which are copied using the file system specific commands
    e2image and ntfsclone respectively.  However when an XFS file system is
    copied the label is not copied because a new file system is created
    using mkfs.xfs and the files copied using xfsdump | xfsrestore.
    
    Preview of the copy operation in GParted also reflects the fact that the
    label will be copied.
    
    Fix this by simply specifying the desired label when creating the new
    destination XFS.
    
    Closes !85 - Make XFS copy duplicate the file system label and UUID

2021-05-29  Curtis Gedak <gedakc@gmail.com>

    Handle change in path for udisks2-inhibit executable (!84)
    
    Debian (and derived) distros with the udisks2 [1] repository and the
    additional 'udisks2-inhibit' executable had the location changed from:
        /usr/lib/udisks2/
    to:
        /usr/libexec/udisks2/
    with udisks2 version 2.8.4-2 and the following commit:
    
        f6744a33 - Move the daemons to /usr/libexec now that's allowed in the policy
        https://salsa.debian.org/utopia-team/udisks2/-/commit/f6744a3364eafdb07e3e78e329f202394804c574
    
    Distros such as Fedora and openSUSE are unaffected as the udisks [2]
    repository does not contain 'udisks2-inhibit'.
    
    [1] udisks2 Debian (and derived) repository
        https://salsa.debian.org/utopia-team/udisks2
    
    [2] udisks repository
        https://github.com/storaged-project/udisks
    
    Closes !84 - Handle change in path for udisks2-inhibit executable

2021-05-31  Andika Triwidada <atriwidada@gnome.org>

    Update Indonesian translation

2021-05-23  Rafael Fontenelle <rafaelff@gnome.org>

    Update Brazilian Portuguese translation

2021-05-23  Piotr Drąg <piotrdrag@gmail.com>

    Update Polish translation

2021-05-18  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Fix recognition of SD/MMC device names (!83)
    
    User reported that GParted didn't detect their eMMC drive [1].  Not
    recognised device name was /dev/mmcblk0.  Confirmed that the regression
    was introduced by this commit [2].  Fix the code and regular expression
    used to recognise SD/MMC device names.
    
    [1] GParted forum thread: eMMC drive not detected...?
        http://gparted-forum.surf4.info/viewtopic.php?id=17994
    
    [2] 52930f30ae8dc2c9dd1f64d2df654d9f1a1afb8a
        Refactor load_proc_partitions_info_cache() a bit (#131)
    
    Closes !83 - Fix recognition of SD/MMC device names

2021-05-19  Yuri Chornoivan <yurchor@ukr.net>

    Update Ukrainian translation

2021-05-18  Anders Jonsson <anders.jonsson@norsjovallen.se>

    Update Swedish translation

2021-05-15  Curtis Gedak <gedakc@gmail.com>

    Replace deprecated gtk_show_uri() method for help window (!82)
    
    The gtk_show_uri() [1] method was deprecated as of gtk3 version 3.22 and
    has been replaced with gtk_show_uri_on_window [2].
    
    [1] https://developer.gnome.org/gtk3/stable/gtk3-Filesystem-utilities.html#gtk-show-uri
    [2] https://developer.gnome.org/gtk3/stable/gtk-migrating-2-to-3.html#id-1.6.3.3.7
    
    Note that AppInfo::launch_uris() has been removed because with
    glib/glibmm >= 2.58 AppInfo::launch_uris() always reports success even
    when yelp is not launched and in such cases prevents the dialog
    reporting the error from being displayed.
    
    Closes !82 - Replace deprecated gtk_show_uri() method for help window

2021-05-17  Seong-ho Cho <shcho@gnome.org>

    Update Korean translation

2021-05-11  Ask Hjorth Larsen <asklarsen@gmail.com>

    Updated Danish translation

2021-05-04  Hugo Carvalho <hugokarvalho@hotmail.com>

    Update Portuguese translation

2021-05-03  Curtis Gedak <gedakc@gmail.com>

    Append -git to version for continuing development

2021-05-03  Curtis Gedak <gedakc@gmail.com>

    ==========   gparted-1.3.0   ==========

2021-05-01  Jiri Grönroos <jiri.gronroos@iki.fi>

    Update Finnish translation

2021-05-01  Piotr Drąg <piotrdrag@gmail.com>

    Update Polish translation

2021-04-27  Ngọc Quân Trần <vnwildman@gmail.com>

    Update Vietnamese translation

2021-04-26  Fran Dieguez <frandieguez@gnome.org>

    Update Galician translation

2021-04-26  Kukuh Syafaat <kukuhsyafaat@gnome.org>

    Update Indonesian translation

2021-04-26  Fran Dieguez <frandieguez@gnome.org>

    Update Galician translation

2021-04-26  Hannie Dumoleyn <hannie@ubuntu-nl.org>

    Update Dutch translation

2021-04-26  Hannie Dumoleyn <hannie@ubuntu-nl.org>

    Update Dutch translation

2021-04-26  Daniel Mustieles <daniel.mustieles@gmail.com>

    Updated Spanish translation

2021-04-26  Daniel Mustieles <daniel.mustieles@gmail.com>

    Updated Spanish translation

2021-04-26  Baurzhan Muftakhidinov <baurthefirst@gmail.com>

    Update Kazakh translation

2021-04-25  Claude Paroz <claude@2xlibre.net>

    Updated French translation

2021-04-25  Rafael Fontenelle <rafaelff@gnome.org>

    Update Brazilian Portuguese translation

2021-04-25  Daniel Șerbănescu <daniel@serbanescu.dk>

    Update Romanian translation

2021-04-25  Yuri Chornoivan <yurchor@ukr.net>

    Update Ukrainian translation

2021-04-25  Daniel Șerbănescu <daniel@serbanescu.dk>

    Update Romanian translation

2021-04-25  Anders Jonsson <anders.jonsson@norsjovallen.se>

    Update Swedish translation

2021-04-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Mark remaining get_filesystem_*() methods as returning const strings

2021-04-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Comment differences between FileSystem::execute_command() methods

2021-04-02  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Report this LUKS passphrase request reason as resize (#59)
    
    So far when prompting for the LUKS passphrase the dialog always looks
    like this:
    
        +------------------------------------------------+
        |           LUKS Passphrase /dev/sdb1            |
        +------------------------------------------------+
        | Enter LUKS passphrase to open /dev/sdb1        |
        | Passphrase:    [                             ] |
        |                                                |
        |                                                |
        |                          [ Cancel ] [ Unlock ] |
        +------------------------------------------------+
    
    Specifically the first line of the dialog says the reason to provide the
    passphrase is to open the encryption mapping.  Now the passphrase may
    also be requested when resizing the encryption mapping, as part of a
    resize of check operation, show the appropriate reason in the password
    dialog.
    
    Closes #59 - Resize of LUKS2 encrypted file system fails with "Nothing
                 to read on input"

2021-04-07  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Also prompt for LUKS password as required for check operation (#59)
    
    A check operation involves (1) checking the file system, (2) growing the
    encryption volume and (3) growing the file system.  Therefore prompt for
    the LUKS passphrase as required when composing a check operation too.
    
    Closes #59 - Resize of LUKS2 encrypted file system fails with "Nothing
                 to read on input"

2021-04-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Pass LUKS password as needed when resizing open mapping (#59)
    
    This is the final piece which enables GParted to pass the LUKS
    passphrase when resizing an open LUKS encryption mapping when
    'cryptsetup resize' will prompt for it.
    
    Closes #59 - Resize of LUKS2 encrypted file system fails with "Nothing
                 to read on input"

2021-04-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add ability for small writes to stdin of operation tracked child processes (#59)
    
    This is the equivalent to what was previously done when adding opening
    of LUKS mappings.  Namely to add a way to pass the LUKS passphrase to
    'cryptsetup luksOpen' via standard input.  Previously the functionality
    was added to Utils::execute_command() [1].  Now it is also needed to
    pass the LUKS passphrase to 'cryptsetup resize', which is executed as
    part of applying resize and check operations to an encrypted file
    system.  So add this functionality to FileSystem::execute_command().
    
    For now writing to stdin is only needed for the one variant of
    FileSystem::execute_command() which doesn't have progress tracking
    callbacks.  Writing to stdin can easily be added to the other progress
    tracking callback variants of execute_command() when needed.
    
    [1] 8dff80edc65b2923b400ddadebacf9bcf378d09f
        Add ability for small writes to stdin of child processes (#795617)
    
    Closes #59 - Resize of LUKS2 encrypted file system fails with "Nothing
                 to read on input"

2021-04-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Extract common code into generate_encryption_mapping_name() (#59)
    
    Closes #59 - Resize of LUKS2 encrypted file system fails with "Nothing
                 to read on input"

2021-03-26  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Ask for LUKS passphrase for resize operation as required (#59)
    
    When composing a resize operation on an open encryption mapping, use the
    existing LUKS password dialog to prompt for the passphrase, if and only
    if 'cryptsetup resize' will prompt and GParted doesn't already have a
    password.  'cryptsetup resize' will prompt for a LUKS passphrase when
    the passphrase was stored in the kernel keyring service,
    key_loc == KEYLOC_KeyRing.  See the previous commit "Capture LUKS
    mapping master encryption key location (#59)" for more details.
    
    As commented in the code GParted specifically doesn't support the case
    where the LUKS passphrase is changed while GParted is running and it
    knew the old passphrase.  When resizing an open encryption mapping
    GParted will just pass the old out of date passphrase it knows and the
    resize will fail like this:
    
        # cryptsetup status sdb2_crypt | egrep 'type|key location'
          type:         LUKS2
          key location: keyring
        # dmsetup table --target crypt
        sdb2_crypt: 0 491520 crypt aes-xts-plain64 :64:logon:cryptsetup:3d040240-97ba-4559-af98-72c3be500498-d0 0 8:18 32768
    
        # echo -n oldpassword | cryptsetup -v --size 491520 resize sdb2_crypt
        No key available with this passphrase.
        Command failed with code -2 (no permission or bad passphrase).
        # echo $?
        2
    
    To work around this either close and restart GParted or close and reopen
    the encryption mapping.  The former because GParted doesn't save
    passwords across a restart so will prompt and the latter because GParted
    will use the wrong old passphrase to try to open the mapping and then
    prompt for the correct passphrase until successfully opened.
    
    Closes #59 - Resize of LUKS2 encrypted file system fails with "Nothing
                 to read on input"

2021-03-26  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Capture LUKS mapping master encryption key location (#59)
    
    ISSUE OVERVIEW
    
    When GParted tries to resize an open LUKS encryption mapping and the
    volume (master) key was stored in the kernel keyring service [1] it
    fails like this:
    
        Check and repair file system ([Encrypted] ext4) on /dev/...(ERROR)
        + calibrate /dev/sdd1                                      (SUCCESS)
        + check file system on /dev/mapper/sdd1_crypt for errors...(SUCCESS)
        + grow encryption volume to fill the partition             (ERROR)
          + cryptsetup -v resize 'sdd1_crypt'                      (ERROR)
              Command failed with code -1 (wrong or missing parameters).
              Nothing to read on input.
    
    This error occurs with cryptsetup >= 2.0, kernel >= 4.10 and LUKS2
    format because the crypt Device-Mapper target no longer has the volume
    key so cryptsetup resize prompts for a passphrase, but GParted doesn't
    provide it.
    
    THIS COMMIT
    
    Additionally capture the location of the volume (master) key location
    for active encryption mappings.  Do this the using the same method that
    cryptsetup uses [2][3].  Namely if the first character of the KEY is a
    ":" then the key *was* stored in the kernel keyring service, otherwise
    it *is* store in the Device-Mapper crypt target as previously.
    
        # echo -n badpassword | cryptsetup luksFormat --type luks1 /dev/sdb1 -
        # echo -n badpassword | cryptsetup luksOpen /dev/sdb1 sdb1_crypt
        # cryptsetup status sdb1_crypt | egrep 'type|key location'
          type:         LUKS1
          key location: dm-crypt
    
        # echo -n badpassword | cryptsetup luksFormat --type luks2 /dev/sdb2 -
        # echo -n badpassword | cryptsetup luksOpen /dev/sdb2 sdb2_crypt
        # cryptsetup status sdb2_crypt | egrep 'type|key location'
          type:         LUKS2
          key location: keyring
    
        # dmsetup table --target crypt
        sdb1_crypt: 0 520192 crypt aes-xts-plain64 00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000 0 8:17 4096
        sdb2_crypt: 0 491520 crypt aes-xts-plain64 :64:logon:cryptsetup:3d040240-97ba-4559-af98-72c3be500498-d0 0 8:18 32768
                                                   ^
    First character of the KEY field --------------'
    
    [1] Integration with the kernel keyring service
        https://gitlab.com/cryptsetup/cryptsetup/blob/v2.0.0/docs/Keyring.txt
        "
        Starting with cryptsetup 2.0 we load [Volume Key] VK in kernel
        keyring by default for LUKSv2 devices ...
    
        In summary, the key description visible in dm-crypt table line is a
        reference to VK that usually no longer exists in kernel keyring
        service if you used cryptsetup to for device activation.
        "
    
    [2] cryptsetup/v2.3.5/lib/libdevmapper.c:_dm_target_query_crypt()
        https://gitlab.com/cryptsetup/cryptsetup/-/blob/v2.3.5/lib/libdevmapper.c#L2031
            if (key_[0] == ':')
                *act_flags |= CRYPT_ACTIVATE_KEYRING_KEY;
    
    [3] cryptsetup/v2.3.5/src/cryptsetup.c:action_status()
        https://gitlab.com/cryptsetup/cryptsetup/-/blob/v2.3.5/src/cryptsetup.c#L839
            log_std("  key location: %s\n", (cad.flags & CRYPT_ACTIVATE_KEYRING_KEY) ? "keyring" : "dm-crypt");
    
    Closes #59 - Resize of LUKS2 encrypted file system fails with "Nothing
                 to read on input"

2021-04-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Ignore libparted unrecognised disk label message from encryption mappings (#152)
    
    When GParted probes an open encryption mapping which is either blank or
    contains a file system which libparted doesn't recognise, such as:
    exfat, f2fs, lvm2 pv, minix or reiser4, then the partition also gets
    this warning message:
        /dev/mapper/sdb11_crypt: unrecognised disk label
    
    Clear the message so that it isn't shown in the GUI.
    
    Note that the message is still written to stderr by GParted, like all
    libparted exceptions are.  This is done by GParted's libparted exception
    handler:
        GParted_Core::ped_exception_handler()
          _ped_exception_handler()
    
    Closes #152 - GParted crashed when trying to probe an encrypted
                  partition containing content that libparted doesn't
                  recognise

2021-04-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Reorder cases in set_device_and_disk() and use if fail return early (#152)
    
    The previous commit "Resolve empty drive displayed as blank minor logic
    issue (#152)" left the code in set_device_and_disk() some what
    unsightly.
    
    Refactor the whole function.  Use if fail return early pattern for
    failure of the get_device() call at the start of the function.  Reorder
    the 4 cases into a single depth if then else if chain.  Hopefully this
    is a little easier to follow.
    
    Closes #152 - GParted crashed when trying to probe an encrypted
                  partition containing content that libparted doesn't
                  recognise

2021-04-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Resolve empty drive displayed as blank minor logic issue (#152)
    
    The previous commit "Remove coding landmine in get_disk() (#152)" made
    an empty drive without a disk label (partition table) display as
    nothing, instead of the normal single unallocated partition with warning
    "unrecognised disk label".
    
    The previous commit said:
        3. The two remaining direct calls to get_disk() where the strict
           parameter is explicitly set to false, from set_device_from_disk()
           and detect_filesystem_in_encryption_mapping(), are when scanning.
           As the pass strict=false they don't allow the PedDevice deletion
           to occur if no recognised disk label is found.
    
    This is true, but get_disk(..., strict=false) additionally returned true
    even if there was no disk label.  And in set_device_from_disk() the
    empty drive case is inside the if branch of the get_disk() call
    returning true.
    
    Simply fix this by calling get_disk(), ignoring the return value.
    
    Closes #152 - GParted crashed when trying to probe an encrypted
                  partition containing content that libparted doesn't
                  recognise

2021-04-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove coding landmine in get_disk() (#152)
    
    get_disk() is the wrapper around libparted's ped_disk_new() which reads
    a disk label from the specified device and if successful creates the in
    memory PedDisk object to represent it.  In the case that libparted
    doesn't recognise a disk label or a file system, having get_disk() go
    and destroy the passed in PedDevice object via parameter lp_device is
    very unexpected behaviour hence describing it as a coding landmine.
    
    BACKGROUND
    
    1. Early on GParted only worked with devices with valid disk labels.
       FileSystem.h:open_device_and_disk() required both ped_device_get()
       and ped_disk_new() to succeed or neither to succeed.
    2. Commit [1] added support for devices which didn't yet have a disk
       label.  open_device_and_disk() had default parameter strict=true
       added.  While scanning strict=false was passed which allowed
       open_device_and_disk() to return success if only ped_device_get()
       succeeded and ped_disk_new() failed when the disk was empty.  All
       other times open_device_and_disk() was called with default
       strict=true, still requiring both or neither to succeed.
    3. Commit [2] added support for whole disk file systems.  The now named
       get_device_and_disk() had it's functionality split between
       get_device() and get_disk().  This result in the code landmine being
       left behind: get_disk() destroying the passed device object if
       default parameter strict=true and no disk label or file system was
       detected.
    
    ANALYSIS
    
    1. Since support for whole disk file systems [2] all current calls to
       get_device_and_disk() let the strict parameter default to true and
       are only called on known partitions within disk labels when applying
       a change to that partition.  Therefore they don't care about the
       behaviour of get_disk(), just that get_device_and_disk() maintains
       that both ped_device_get() and ped_disk_new() succeed or neither
       succeed.
    2. Two direct calls to get_disk() where the strict parameter defaults to
       true, from calibrate_partition() and erase_filesystem_signatures(),
       only do so on known partitions within disk labels as part of applying
       a change to that partition.  Therefore ped_disk_new() will succeed
       and so PedDevice isn't deleted when not wanted.
    3. The two remaining direct calls to get_disk() where the strict
       parameter is explicitly set to false, from set_device_from_disk() and
       detect_filesystem_in_encryption_mapping(), are when scanning.  As the
       pass strict=false they don't allow the PedDevice deletion to occur if
       no recognised disk label is found.
    
    FIX
    
    Remove the strict parameter from get_disk() and get_device_and_disk() as
    it's no longer needed.  Remove the code landmine by removing the side
    affect of destroying the PedDevice object if a disk label isn't found.
    Make sure get_device_and_disk() maintains the all or nothing behaviour.
    
    Also don't pass lp_device by reference to a pointer to get_disk() so the
    code can't change where lp_device points.
    
    [1] 038c5c5d99ad842f1a57f12222c884be29f4df4f
        P (special thanks to mantiena-baltix for bringing this issue to my
    
    [2] 51ac4d56489653854cd22787238a14bfa66a6ad4
        Split get_device_and_disk() into two (#743181)
    
    Closes #152 - GParted crashed when trying to probe an encrypted
                  partition containing content that libparted doesn't
                  recognise

2021-04-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Correctly const and assert detect_filesystem() parameters (#152)
    
    As discussed in the previous commit "Don't crash probing libparted
    unrecognised encrypted file system (#152)", detect_filesystem() accepted
    a NULL lp_device pointer and dereferenced it leading to the crash.
    Document the requirement for lp_device parameter to be non-NULL via an
    assert and also correctly const the parameters.
    
    This forces needing to const the lp_partition parameter to
    get_partition_path() too.  Also assert it's non-NULL requirement.
    
    Closes #152 - GParted crashed when trying to probe an encrypted
                  partition containing content that libparted doesn't
                  recognise

2021-04-08  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Don't crash probing libparted unrecognised encrypted file system (#152)
    
    Create a LUKS encrypted partition and open it.  Then either leave the
    contents blank or create a file system which libparted doesn't
    recognise, such as: exfat, f2fs, lvm2 pv, minix or reiser4.  When
    GParted probes the disk device it crashes.
    
        # echo -n badpassword | cryptsetup luksFormat /dev/sdb11
        # echo -n badpassword | cryptsetup luksOpen /dev/sdb11 sdb11_crypt
        # ./gpartedbin /dev/sdb
        GParted 1.2.0-git
        configuration (none)
        libparted 3.1
        /dev/mapper/sdb11_crypt: unrecognised disk label
        Segmentation fault (core dumped)
    
    Backtrace:
        #0  0x0000000000460f68 in GParted::GParted_Core::detect_filesystem(_PedDevice*, _PedPartition*, std::vector<Glib::ustring, std::allocator<Glib::ustring> >&)
            (lp_device=0x0, lp_partition=0x0, messages=std::vector of length 0, capacity 0)
            at GParted_Core.cc:1235
        #1  0x00000000004615a6 in GParted::GParted_Core::detect_filesystem_in_encryption_mapping(Glib::ustring const&, std::vector<Glib::ustring, std::allocator<Glib::ustring> >&)
            (path=..., messages=std::vector of length 0, capacity 0)
            at GParted_Core.cc:1096
        #2  0x00000000004647c8 in GParted::GParted_Core::set_luks_partition(GParted::PartitionLUKS&)
            (this=this@entry=0x7fff43f974e0, partition=...)
            at GParted_Core.cc:1011
        #3  0x000000000046511b in GParted::GParted_Core::set_device_partitions(GParted::Device&, _PedDevice*, _PedDisk*)
            (this=this@entry=0x7fff43f974e0, device=..., lp_device=0x7efc780008c0, lp_disk=0x7efc78000d10)
            at GParted_Core.cc:883
        #4  0x00000000004658e3 in GParted::GParted_Core::set_device_from_disk(GParted::Device&, Glib::ustring const&)
            (this=this@entry=0x7fff43f974e0, device=..., device_path=...)
            at GParted_Core.cc:704
        #5  0x0000000000465fff in GParted::GParted_Core::set_devices_thread(std::vector<GParted::Device, std::allocator<GParted::Device> >*)
            (this=0x7fff43f974e0, pdevices=0x7fff43f96bc8)
            at GParted_Core.cc:266
        #6  0x00007efc99ba413d in call_thread_entry_slot ()
            at /lib64/libglibmm-2.4.so.1
        #7  0x00007efc97dc8555 in g_thread_proxy ()
            at /lib64/libglib-2.0.so.0
        #8  0x00007efc96ab4ea5 in start_thread () at /lib64/libpthread.so.0
        #9  0x00007efc967dd9fd in clone () at /lib64/libc.so.6
    
    The relevant sequence of events goes like this:
        detect_filesystem_in_encryption_mapping(path, ...)
          lp_device = NULL
          get_device(path, lp_device)
            lp_device = ped_device_get(path.c_str())
            return true
          lp_disk = NULL
          lp_partition = NULL
          get_disk(lp_device, lp_disk)  // + default parameter strict=true
            lp_disk = ped_disk_new(lp_device)
              // No libparted recognised disk label or file system found, so
              // NULL returned.
            destroy_device_and_disk(lp_device, lp_disk)
              ped_device_destroy(lp_device)
              lp_device = NULL
            return false
          detect_filesystem(lp_device, lp_partition, ...)
            path = lp_device->path
    
    The key points are:
    1. get_device() created a PedDevice object pointed to by lp_device;
    2. get_disk() didn't find a libparted recognised disk label or file
       system but also unexpectedly destroyed the PedDevice object and
       assigned NULL to lp_device;
    3. detect_filesystem() dereferenced lp_device assuming it was still
       valid.
    
    Implement the simplest possible fix by telling get_disk() to not
    destroy the needed PedDevice object when there's no recognised content.
    This is the same as how get_disk() is called in set_device_from_disk().
    
    Closes #152 - GParted crashed when trying to probe an encrypted
                  partition containing content that libparted doesn't
                  recognise

2021-04-14  Hugo Carvalho <hugokarvalho@hotmail.com>

    Update Portuguese translation

2021-03-29  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Also use libparted to probe for encrypted file systems (#148)
    
    Even though blkid is considered mandatory [1] GParted should still
    perform reasonably when blkid is not available, provided that is not too
    onerous a task.  Also use libparted file system identification inside
    encryption mappings.
    
    [1] 749a2495716a82a7287fad943109b6cfb927245c
        Document blkid command as a mandatory requirement (#753436)
    
    Closes 148 - Encrypted file systems are no longer recognised

2021-03-29  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Probe encryption mappings as needed using blkid (#148)
    
    GParted no longer recognises file systems inside LUKS encryption, apart
    from the few recognised by GParted's internal detection.  Bisected to
    this commit:
        8b35892ea59958aa1eec596a48a36b0fa7950dca
        Pass device and partition names to blkid (#131)
    
    Prior to this commit blkid was run querying all known block devices
    including active encryption mappings, hence prior recognition.  With
    this commit blkid was run only for named or found disk devices and
    associated found partitions from /proc/partitions, so no more
    recognition of encrypted file systems.
    
    Fix by running blkid on the encryption mapping just before querying for
    the file system.  This restores the level of functionality that existed
    before.
    
    Closes 148 - Encrypted file systems are no longer recognised

2021-03-29  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Extract some code into detect_filesystem_in_encryption_mapping() (#148)
    
    To avoid making set_luks_partition() more complicated extract the file
    system detection portion into a new function.
    
    Closes 148 - Encrypted file systems are no longer recognised

2021-03-29  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Make FS_Info (blkid) cache incrementally loadable (#148)
    
    Since changes for issue #131 "GParted hangs when non-named device is
    hung" FS_Info cache is initialised, cleared and loaded via one call to
    load_cache_for_paths().  It runs blkid for named or found disk devices
    and associated found partitions from /proc/partitions, rather than
    running blkid and letting it report for all block devices.
    
    To avoid the possibility of using blkid on an encryption mapping on a
    non-specified and possibly hung block device GParted can't just specify
    all encryption mappings.  Instead only encryption mappings which belong
    to the above identified block devices should be probed.  That requires
    identifying LUKS encryption data in the block devices first so will
    require subsequently loading additional data into the FS_Info cache and
    running blkid again.
    
    To accommodate this make the FS_Info cache incrementally loadable,
    rather than doing everything in a single call to load_cache_for_paths().
    Have a separate clear_cache() call which initialises and clears the
    cache and make load_cache_for_paths() just run blkid and insert data for
    the named paths.
    
    Closes 148 - Encrypted file systems are no longer recognised

2021-04-02  Nathan Follens <nfollens@gnome.org>

    Update Dutch translation

2021-03-27  Anders Jonsson <anders.jonsson@norsjovallen.se>

    Update Swedish translation

2021-03-25  Hugo Carvalho <hugokarvalho@hotmail.com>

    Update Portuguese translation

2021-03-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Update HACKING file with coding style hints and tips

2021-03-20  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Explicitly read the reiser4 volume UUID when present
    
    Reiser4 has introduced new disk format which includes support for
    spanning the file system over multiple block devices (subvolumes)
    [1][2].  As such the output of the debugfs.reiser4 for the UUID has
    changed slightly.  So far the new reiser4progs package (version 2.0.x)
    is only available as a Debian experimental package.
    
    Using reiser4progs 1.2.1 the old output was like this:
    
        $ debugfs.reiser4 test.img
        debugfs.reiser4 1.2.1
        Format release: 4.0.2
        Copyright (C) 2001-2005 by Hans Reiser, licensing governed by reiser4progs/COPYING.
    
        Master super block (16):
        magic:          ReIsEr4
        blksize:        4096
        format:         0x0 (format40)
        uuid:           1116afce-99fd-4a6e-94cb-2d9f19c91d67
        label:          <none>
    
        ...
    
    With reiser4progs 2.0.4 the new output is like this:
    
        $ debugfs.reiser4 test.img
        debugfs.reiser4
        Package Version: 2.0.4
        Software Framework Release: 5.1.3
        Copyright (C) 2001-2005 by Hans Reiser, licensing governed by reiser4progs/COPYING.
        Master super block (16):
        magic:          ReIsEr4
        blksize:        4096
        volume:         0x1 (asym)
        distrib:        0x1 (fsx32m)
        format:         0x1 (format41)
        description:    Standard layout for logical volumes.
        stripe bits:    14
        mirror id:      0
        replicas:       0
        volume uuid:    9538bfa3-5694-4abe-864c-edc288a9d801
        subvol uuid:    d841c692-2042-49e6-ac55-57e454691782
        label:          <none>
    
        ...
    
    GParted happens to read the correct UUID just because the first matching
    "uuid" string in the output is the volume UUID.  Make the code more
    robust by explicitly reading the volume uuid when labelled as such.
    
    [1] Logical Volumes Howto
        https://reiser4.wiki.kernel.org/index.php/Logical_Volumes_Howto
    [2] Logical Volumes Background
        https://reiser4.wiki.kernel.org/index.php/Logical_Volumes_Background

2021-03-20  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Refactor reiser4::read_uuid() into if fail return early pattern

2021-03-18  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Ignore test failure when reiser4 reports null UUID (#145)
    
    The GitLab CI ubuntu_test job has occasionally been failing like this,
    perhaps once every few weeks or so.
    
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUUID/reiser4
        test_SupportedFileSystems.cc:569: Failure
        Expected: (m_partition.uuid.size()) >= (9U), actual: 0 vs 9
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/reiser4, where GetParam() = 24 (17 ms)
        [----------] 1 test from My/SupportedFileSystemsTest (17 ms total)
    
    Turns out there are 2 bugs in resier4progs.  One causes debugfs.reiser4
    to report a null UUID if the first byte of the UUID happens to be zero
    [1], and the other cases mkfs.resier4 to write a corrupted UUID,
    sometimes a null (all zeros) UUID [2].
    
    There is a 1 in 256 chance of getting a null UUID [2] when creating and
    reading a reiser4 file system, hence the occasional failure of the CI
    job.  The centos_test job isn't affected because CentOS doesn't have the
    reiser4progs package.
    
    Fix this by detecting when reiser4 reports a null UUID and assign a
    dummy UUID to make the test pass.  This does mean that there is a 1 in
    256 chance of not detecting a true failure.  However that still means
    there is a 255 in 256 chance of detecting a true failure.  That's good
    odds.  When a null UUID is detected for a reiser4 file system the test
    output looks like this:
    
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUUID/reiser4
        test_SupportedFileSystems.cc:580: Ignore test failure of a null UUID.
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUUID/reiser4 (46 ms)
    
    [1] https://github.com/edward6/reiser4progs/commit/4802cdb18ae03031d0e51a58b6655f3b99021ec2
        Fix up repair_master_print()
    
    [2] https://github.com/edward6/reiser4progs/commit/44cc024f398f60adef1519426d65f3f081ee826a
        Stop occasionally making file systems with null UUIDs
    
    Closes #145 - Sporadic failure of test case
                  My/SupportedFileSystemsTest.CreateAndReadUUID/reiser4

2021-03-13  Jordi Mas <jmas@softcatala.org>

    Update Catalan translation

2021-03-08  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Print kernel version, etc in GitLab CI (#147)
    
    Print the kernel version and supported file systems inside the GNOME
    GitLab CI jobs as a debugging aid.  Kernel version helps identify the
    CI job runner's distribution to identify kernel features.  Supported
    file systems identifies which ones can be mounted, should that be
    possible in future.  Print supported file systems before and after the
    tests because checking for support may load additional modules.  See
    calls to Utils::kernel_supports_fs() for: btrfs, jfs, nilfs2 and xfs.
    
    Closes #147 - GitLab CI test failure from *.CreateAndGrow/jfs

2021-03-08  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Exclude more GitLab CI file system tests needing loop devices (#147)
    
    For the first time ever the ubuntu_test GitLab CI job failed running the
    JFS grow test like this.  Fragment from tests/test-suite.log:
    
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndGrow/jfs
        test_SupportedFileSystems.cc:387: Failure
        Failed
        create_loopdev(): Execute: losetup --find --show 'test_SupportedFileSystems.img'
        losetup: cannot find an unused loop device
        create_loopdev(): Losetup failed with exit status 1
        create_loopdev(): Failed to create required loop device
        Error: Could not stat device  - No such file or directory.
        test_SupportedFileSystems.cc:446: Failure
        Value of: lp_device != NULL
          Actual: false
        Expected: true
        test_SupportedFileSystems.cc:649: Failure
        Value of: m_fs_object->create(m_partition, m_operation_detail)
          Actual: false
        Expected: true
        Operation details:
        mkfs.jfs -q -L '' ''    00:00:00  (ERROR)
        mkfs.jfs version 1.1.15, 04-Mar-2011
    
        The system cannot find the specified device.
    
        detach_loopdev(): Execute: losetup --detach ''
        losetup: : failed to use device: No such device
        detach_loopdev(): Losetup failed with exit status 1
        detach_loopdev(): Failed to detach loop device.  Test NOT affected
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndGrow/jfs, where GetParam() = 17 (24 ms)
    
    JFS can only be grown when mounted by the kernel and GParted only
    enables JFS grow support when, among other things, kernel support is
    detected.
    
    Unknowingly the JFS grow test had always previously been skipped, even
    in the ubuntu_test CI job which installs jfsutils, because the kernel
    didn't support JFS.  Capture of this test from another run of the
    ubuntu_test CI job:
    
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndGrow/jfs
        test_SupportedFileSystems.cc:641: Skip test.  grow not supported or support not found
        [       OK ] My/SupportedFileSystemsTest.CreateAndGrow/jfs (0 ms)
    
    Plus additional debug added into the job based on what
    Utils::kernel_supports_fs() does to identify kernel support:
    
        $ fgrep jfs /proc/filesystems || true
        $ modprobe jfs || true
        modprobe: FATAL: Module jfs not found in directory /lib/modules/3.10.0-1160.11.1.el7.x86_64
        $ fgrep jfs /proc/filesystems || true
    
    Therefore until now every GitLab job runner machine kernel didn't
    support JFS, but for the first time ever this ubuntu_test job ran on a
    runner machine where the kernel did support JFS, hence the attempt to
    use losetup.
    
    Examining test_SupportFileSystems.cc there are 24 file system tests
    which specify SKIP_IF_NOT_ROOT_FOR_REQUIRED_LOOPDEV_FOR_FS(), but only
    17 exclusions in .gitlab-ci.yaml [1].  The 7 tests without exclusions
    are:
    
        *.CreateAndReadLabel/lvm2pv
        *.CreateAndReadUUID/lvm2pv
        *.CreateAndWriteLabel/lvm2pv
        *.CreateAndWriteUUID/lvm2pv
        *.CreateAndGrow/jfs
        *.CreateAndGrow/nilfs2
        *.CreateAndShrink/nilfs2
    
    For LVM2 PVs reading and writing of labels and UUIDs aren't implemented
    (only reading of UUIDs could be supported as the others are impossible)
    so those tests are always skipped.  Add unit test exclusions just for
    completeness.
    
    JFS grow is this case.  NILFS2 grow and shrink are more cases where
    kernel support is needed.  Add unit test exclusions to stop attempting
    to run JFS and NILFS2 resizing tests, which don't currently work because
    losetup doesn't work in the GitLab CI docker images [1].
    
    [1] 39fdfe51da4bddecb2c99a9b544b270130423e72
        Exclude unit tests needing losetup in Docker CI image (!59)
    
    Closes #147 - GitLab CI job failure from *.CreateAndGrow/jfs

2021-03-06  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Pass constant string by reference to lvm2_pv_size_to_num()
    
    It is common C++ practice to pass a constant object by reference to
    avoid constructing a duplicate object for pass by value [1].
    
    [1] How to pass objects to functions in C++?
        https://stackoverflow.com/questions/2139224/how-to-pass-objects-to-functions-in-c/2139254#2139254

2021-03-01  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Install gpartedbin into @libexecdir@ (#85)
    
    Executables which are not intended for execution by users, but by other
    programs, should be installed into /usr/libexec [1][2].  gpartedbin
    falls into this category.  Update it's installation accordingly.
    
    Standard Autotools details: gpartedbin will be installed into
    EPREFIX/libexec by default.  To install gpartedbin into a different
    directory set libexecdir when configuring the build system.  Like this
    from git:
        ./autogen.sh --libexecdir=DIR
    or like this from tar release:
        ./configure --libexecdir=DIR
    
    [1] Filesystem Hierarchy Standard, version 3.0,
        4.7. /usr/libexec : Binaries run by other programs (optional)
        https://refspecs.linuxfoundation.org/FHS_3.0/fhs/ch04s07.html
        "/usr/libexec includes internal binaries that are not intended to be
        executed directly by users or shell scripts.
        "
    
    [2] GNU Coding Standards, June 12, 2020,
        7.2.5 Variables for Installation Directories
        https://www.gnu.org/prep/standards/html_node/Directory-Variables.html
        "libexecdir
        The directory for installing executable programs to be run by other
        programs rather than by users.  This directory should normally be
        /usr/local/libexec, but write it as $(exec_prefix)/libexec.  (If you
        are using Autoconf, write it as '@libexecdir@'.)
        "
    
    Closes #85 - Please install gpartedbin under /usr/libexec instead of
                 /usr/sbin

2021-03-08  Aurimas Černius <aurisc4@gmail.com>

    Updated Lithuanian translation

2021-03-05  Kukuh Syafaat <kukuhsyafaat@gnome.org>

    Update Indonesian translation

2021-02-23  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Update "Detecting BitLocker" URL code comment
    
    The document has moved on the Microsoft website.  Update the URL
    accordingly, and add an Internet Archive URL too, for good measure.

2021-02-28  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename member variable to default_fs
    
    ... in class Dialog_Partition_New and slightly refactor the code in
    build_filesystems_combo() method which sets it.
    
    Change the name from first_creatable_fs to default_fs to be more
    immediately obvious what the variable represents.  As default_fs is used
    to index the items in the combo_filesystem derived ComboBox, make it's
    type an int to match the type of the parameter passed to
    Gtk::ComboBox::set_active() [1].  Initialise default_fs to -1 (no
    selection) in the class constructor [2], which also allows removal of
    local variable set_first just used to track whether first_creatable_fs
    had been assigned yet or not.
    
    [1] gtkmm: Gtk::ComboBox Class Reference, set_active()
        https://developer.gnome.org/gtkmm/stable/classGtk_1_1ComboBox.html#a4f23cf08e85733d23f120935b235096d
    
    [2] C++ FAQ / Should my constructors use "initialization lists" or
        "assignment"?
        https://isocpp.org/wiki/faq/ctors#init-lists

2021-02-28  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Don't rely on unformatted being the last file system type
    
    ... in Dialog_Partition_New::build_filesystems_combo().  set_data()
    populates this->FILESYSTEMS[] vector with supported file systems with
    cleared, unformatted and extended added to the end.  Then
    build_filesystems_combo() adds those items to combo_filesystem, skipping
    extended.  It then makes the last item in the combobox sensitive,
    relying on the fact that it is unformatted.
    
    Refactor the code so build_filesystems_combo() no longer relies on
    unformatted being the last item in combo_filesystem to always enable it.

2021-02-28  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove unnecessary call to combobox_changed(false)
    
    ... in Dialog_Partition_New::set_data().  As the change signal for
    combo_filesystem has already been connected, combo_changed(false) is
    automatically called by setting the active selection.  Therefore remove
    the unnecessary call.

2021-02-28  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename combobox_change() parameter to combo_type_changed
    
    "Type" was rather a generic name.  Use "combo_type_changed" which makes
    it clear that the boolean parameter indicates whether a change to
    combo_type or one of the other ComboBoxes triggered this callback.

2021-02-28  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Fix crash in Create New Partition dialog when changing type (#101)
    
    On an MSDOS partitioned drive, open the Create New Partition dialog and
    change "created as" from Primary Partition to Extended Partition and
    back to Primary Partition.  On Fedora and RHEL/CentOS 8, which builds
    packages with FORTIFY_SOURCE [1][2] and GLIBXX_Assertions [3][4]
    enabled, GParted will crash.
    
    Run GParted built with the default compilation options under valgrind
    and repeat the test.  Multiple out of bounds reads are reported like
    this:
      # valgrind --track-origins=yes ./gpartedbin
      ...
      ==232613== Invalid read of size 8
      ==232613==    at 0x441AF6: GParted::Dialog_Partition_New::combobox_changed(bool) (Dialog_Partition_New.cc:354)
      ==232613==    by 0x443DBD: sigc::bound_mem_functor1<void, GParted::Dialog_Partition_New, bool>::operator()(bool const&) const (mem_fun.h:2066)
    
    Coming from Dialog_Partition_New.cc:
      328  void Dialog_Partition_New::combobox_changed(bool type)
      329  {
      ...
      351      // combo_filesystem and combo_alignment
      352      if ( ! type )
      353      {
    > 354          fs = FILESYSTEMS[combo_filesystem.get_active_row_number()];
    
    When the partition type is changed to Extended the file system is forced
    to be "Extended" too.  This is done in ::combobox_changed() method by
    modifying combo_filesystem to add "Extended", making that the selected
    item and setting the widget as inactive.
    
    Then when the partition type is changed back to primary the file system
    combobox is returned to it's previous state.  This is done by first
    removing the last "Extended" item, making the widget active and setting
    the selected item.  However as "Extended" is the currently selected
    item, removing it forces their to be no selected item and triggers a
    change to combo_filesystem triggering a recursive call to
    ::combobox_changed() where combo_filesystem.get_active_row_number()
    returns -1 (no selection) [5] and on line 354 the code accesses item -1
    of the FILESYSTEMS[] vector.
    
    Fix by setting the new combo_filesystem selection before removing the
    currently selected "Extended" item.  This has the added benefit of only
    triggering a change to combo_filesystem once when the default item is
    selected rather than twice when the currently "Extended" item is removed
    and again when the default item is selected.
    
    [1] [Fedora] Security Features, Compile Time Buffer Checks
        (FORTIFY_SOURCE)
        https://fedoraproject.org/wiki/Security_Features#Compile_Time_Buffer_Checks_.28FORTIFY_SOURCE.29
    
    [2] Enhance application security with FORTIFY_SOURCE
        https://access.redhat.com/blogs/766093/posts/1976213
    
    [3] Security Features Matrix (GLIBXX_Assertions)
        https://fedoraproject.org/wiki/Security_Features_Matrix
    
    [4] GParted 1.2.0-1.fc33 package build.log for Fedora 33
        https://kojipkgs.fedoraproject.org/packages/gparted/1.2.0/1.fc33/data/logs/x86_64/build.log
        CXXFLAGS='-O2 -g ... -Wp,-D_FORTIFY_SOURCE=2
        -Wp,-D_GLIBCXX_ASSERTIONS ...'
    
    [5] gtkmm: Gtk::ComboBox Class Reference, get_active_row_number()
        https://developer.gnome.org/gtkmm/stable/classGtk_1_1ComboBox.html#a53531bc041b5a460826babb8496c363b
    
    Closes #101 - Crash changing Partition type in "Create new partition"
                  dialog

2021-02-20  Yuri Chornoivan <yurchor@ukr.net>

    Fix minor typos in comments (!71)
    
    Closes !71 - Fix minor typos in comments

2021-02-23  Anders Jonsson <anders.jonsson@norsjovallen.se>

    Update Swedish translation

2021-02-22  Yuri Chornoivan <yurchor@ukr.net>

    Update Ukrainian translation

2021-02-16  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Update SystemRescue name and URL in the GParted Manual
    
    SystemRescue have dropped CD from their name and URL.  Update the
    GParted Manual to reflect this.

2021-02-21  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Re-enable PipeCapture read NUL byte unit tests in GitLab CI jobs (#136)
    
    This reverts commit:
        e9223207e6b5224259716f05f84f80ca426acc42.
        Exclude PipeCapture read NUL byte unit tests in GitLab CI jobs (!60)
    now that PipeCapture has been fixed to read NUL characters again.
    
    Closes #136 - 1.2.0: test suite is failing in test_PipeCapture

2021-02-20  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Accept NUL as a valid UTF-8 character again (#136)
    
    On newer distributions the PipeCapture tests have been failing like
    this:
        $ ./test_PipeCapture
        ...
        [ RUN      ] PipeCaptureTest.ReadEmbeddedNULCharacter
        test_PipeCapture.cc:336: Failure
              Expected: inputstr
             Of length: 6
        To be equal to: capturedstr.raw()
             Of length: 5
        With first binary difference:
        < 0x00000000  "ABC.EF"            41 42 43 00 45 46
        --
        > 0x00000000  "ABCEF"             41 42 43 45 46
        [  FAILED  ] PipeCaptureTest.ReadEmbeddedNULCharacter (0 ms)
        [ RUN      ] PipeCaptureTest.ReadNULByteInMiddleOfMultiByteUTF8Character
        test_PipeCapture.cc:353: Failure
              Expected: expectedstr
             Of length: 7
        To be equal to: capturedstr.raw()
             Of length: 6
        With first binary difference:
        < 0x00000000  "._45678"           00 5F 34 35 36 37 38
        --
        > 0x00000000  "_45678"            5F 34 35 36 37 38
        [  FAILED  ] PipeCaptureTest.ReadNULByteInMiddleOfMultiByteUTF8Character (0 ms)
        ...
    
    Found that test_PipeCapture succeeds on Fedora 31 and fails on
    Fedora 32.  Also test_PipeCapture binary from Fedora 31 and 32 both pass
    on Fedora 31 and both fail on Fedora 32.  So something outside of the
    GParted code and tests is the cause.
    
    Confirmed that this GLib change "Add a missing check to
    g_utf8_get_char_validated()" [1], first released in GLib 2.63.0, made
    the difference.  On Fedora 32 with GLib 2.64.6, rebuilt GLib with that
    change reverted and the tests passed.  Anyway fix the wrapper GParted
    has around g_utf8_get_char_validated() to also handle this case of
    reading a NUL character.
    
    [1] https://gitlab.gnome.org/GNOME/glib/-/commit/568720006cd1da3390c239915337ed0a56a23f2e
        Add a missing check to g_utf8_get_char_validated()
    
    Closes #136 - 1.2.0: test suite is failing in test_PipeCapture

2021-02-20  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Refactor ::OnReadable() creating get_utf8_char_validated() (#136)
    
    Extract call to GLib's g_utf8_get_char_validated() and the associated
    workaround to also read NUL characters into a separate function to make
    PipeCapture::OnReadable() a little smaller and simpler, so easier to
    understand.
    
    Add max_len > 0 clause into get_utf8_char_validated() like this:
        if (uc == UTF8_PARTIAL && max_len > 0)
    so that the NUL character reading workaround is only applied when
    max_len specifies the maximum number of bytes to read, rather than
    when -1 specifies reading a NUL termination string.  This makes
    get_utf8_char_validated() a complete wrapper of
    g_utf8_get_char_validated() [1], even though GParted always specifies
    the maximum number of bytes to read.
    
    No longer describe the inability to read NUL characters as a bug [2]
    since the GLib author's said it wasn't [3].
    
    [1] GLib Reference Manual, Unicode Manipulation Functions,
        g_utf8_get_char_validated ()
        https://developer.gnome.org/glib/stable/glib-Unicode-Manipulation.html#g-utf8-get-char-validated
    
    [2] 8dbbb47ce2db0ee733ff909c1ead2f4de9475596
        Workaround g_utf8_get_char_validate() bug with embedded NUL bytes
        (#777973)
    
    [3] Bug 780095 - g_utf8_get_char_validated() stopping at nul byte even
        for length specified buffers
        https://bugzilla.gnome.org/show_bug.cgi?id=780095#18
            "If g_utf8_get_char_validated() encounters a nul byte in the
            middle of a string of given longer length, it returns -2,
            indicating a partial gunichar.  That is not the obvious
            behaviour, but since g_utf8_get_char_validated() has been API
            for a long time, the behaviour cannot be changed.
            "
    
    Closes #136 - 1.2.0: test suite is failing in test_PipeCapture

2021-02-18  Yuri Chornoivan <yurchor@ukr.net>

    Add Ukrainian screenshot (!70)
    
    Closes !70 - Add Ukrainian screenshot

2021-02-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename SupportedFileSystemsTest method to create_image_file()
    
    ... from extra_setup() to provide a more meaningful description of what
    it does.

2021-02-07  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Update allow partition deletion comment in set_valid_operations()
    
    This previous commit [1] suggested that in future partition deletion
    might be allowed even while a LUKS mapping was active in that partition.
    To allow deletion of a partition while it has active content is wrong.
    That is a significant reason GParted has busy detection of otherwise
    unrecognised file systems [2] and recognition and busy detection of, but
    otherwise not controllable support for, Linux Software RAID [3] and
    ATARAID [4][5] arrays.
    
    To automatically close the LUKS partition first would be against the
    pattern of behaviour that GParted has established, of requiring explicit
    deactivation of file systems, swap and volume groups before allowing
    deletion.  Therefore update the comment accordingly.
    
    [1] f1e3d42b5604d93dc954f5f218ef489649f11284
        Prevent deletion of open LUKS mappings (#774818)
    
    [2] 49a2e19462fdbe4b28a53cc21a2ddd29d256ff41
        Restore busy detection of unknown mounted file systems (#723842)
    
    [3] d2e1130ad22eb3f52db4dc7f645ed4d5bf119d24
        Detect busy status of Linux Software RAID members (#709640)
    
    [4] 6e990ea48ad4177fbf1a26b5f6d9dd60b218874d
        Detect busy status of mdadm started ATARAID members (#75)
    
    [5] caec22871e2fa869db85831c625f30d70738906e
        Detect busy status of dmraid started ATARAID members (#75)

2021-02-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add support for updating the exFAT UUID (!67)
    
    Also with exfatprogs 1.1.0 [1], tune.exfat and exfatlabel gained the
    capability to report and set the exFAT Volume Serial Number [2][3][4].
    This is what blkid and therefore GParted reports as the UUID.
    
    Report serial number:
    
        # tune.exfat -i /dev/sdb1
        exfatprogs version : 1.1.0
        volume serial : 0x772ffe5d
        # echo $?
        0
    
        # blkid /dev/sdb1
        /dev/sdb1: LABEL="test exfat" UUID="772F-FE5D" TYPE="exfat" PTTYPE="dos"
    
    Set serial number:
    
        # tune.exfat -I 0xf96ef190 /dev/sdb1
        exfatprogs version : 1.1.0
        New volume serial : 0xf96ef190
        # echo $?
        0
    
    tune.exfat exists in earlier releases of exfatprogs so check it has the
    capability by searching for "Set volume serial" in the help output
    before enabling this capability.
    
        # tune.exfat
        exfatprogs version : 1.1.0
        Usage: tune.exfat
                -l | --print-label                    Print volume label
                -L | --set-label=label                Set volume label
                -i | --print-serial                   Print volume serial
                -L | --set-serial=value               Set volume serial
                -V | --version                        Show version
                -v | --verbose                        Print debug
                -h | --help                           Show help
    
    (Note the cut and paste error reporting the set volume serial flag as
    '-L' rather than actually '-S').
    
    [1] exfatprogs-1.1.0 version released
        http://github.com/exfaoprogs/exfatprogs/releases/tag/1.1.0
    
    [2] [tools][feature request] Allow To Change Volume Serial Number ("ID")
        #138
        https://github.com/exfatprogs/exfatprogs/issues/138
    
    [3] exfatlabel:add get/set volume serial option
        https://github.com/exfatprogs/exfatprogs/commit/b4d9c9eeb5c28b503e103e2c4ec22bc146446d9f
    
    [4] exFAT file system specification, 3.1.11 VolumeSerialNumber Field
        https://docs.microsoft.com/en-us/windows/win32/fileio/exfat-specification#3111-volumeserialnumber-field
    
    Closes !67 - Add support for reading exFAT usage and updating the UUID

2021-02-08  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add exFAT file system usage reporting (!67)
    
    exfatprogs 1.1.0 released 2021-02-09 [1] has gained support for
    reporting file system usage [2][3] so add that capability to GParted.
    It works like this:
    
        # dump.exfat /dev/sdb1 | egrep 'Volume Length\(sectors\):|Sector Size Bits:|Sector per Cluster bits:|Free Clusters:'
        Volume Length(sectors):                 524288
        Sector Size Bits:                       9
        Sector per Cluster bits:                3
        Free Clusters:                          23585
    
    Unfortunately dump.exfat returns a non-zero status on success so that
    can't be used to check for failure:
    
        # dump.exfat /dev/sdb1
        exfatprogs version : 1.1.0
        -------------- Dump Boot sector region --------------
        Volume Length(sectors):                 524288
        ...
        # echo $?
        192
    
    dump.exfat only writes errors to stderr, so use this to identify failure:
    
        # dump.exfat /dev/sdb1 1> /dev/null
        # echo $?
        192
    
        # dump.exfat /dev/zero 1> /dev/null
        invalid block device size(/dev/zero)
        bogus sector size bits : 0
        # echo $?
        234
    
    [1] exfatprogs-1.1.0 version released
        http://github.com/exfaoprogs/exfatprogs/releases/tag/1.1.0
    
    [2] [feature request] File system usage reporting
        https://github.com/exfatprogs/exfatprogs/issues/139
    
    [3] exfatprogs: add dump.exfat
        https://github.com/exfatprogs/exfatprogs/commit/7ce9b2336b06e76521f7e041d8f0712b2d98a15b
    
    Closes !67 - Add support for reading exFAT usage and updating the UUID

2021-02-16  Anders Jonsson <anders.jonsson@norsjovallen.se>

    Update Swedish translation

2021-02-16  Yuri Chornoivan <yurchor@ukr.net>

    Update Ukrainian translation

2021-02-15  Yuri Chornoivan <yurchor@ukr.net>

    Add Ukrainian translation of docs (!69)
    
    Closes !69 - Add Ukrainian translation of docs

2021-02-15  Yuri Chornoivan <yurchor@ukr.net>

    Fix minor typos in docs (!68)
    
    Closes !68 - Fix minor typos in docs

2021-02-15  Balázs Úr <balazs@urbalazs.hu>

    Update Hungarian translation

2021-02-02  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Avoid detecting exfat-utils commands as exfatprogs commands (#137)
    
    A user had exfat-utils installed and tried to use GParted to create an
    exfat file system.  GParted ran this command but it failed:
        # mkfs.exfat -L '' '/dev/sdb1'
        mkexfatfs 1.3.0
        mkfs.exfat: invalid option -- 'L'
        Usage: mkfs.exfat [-i volume-id] [-n label] [-p partition-first-sector] [-s sectors-per-cluster] [-V] <device>
    
    The problem is that both exfat-utils and exfatprogs packages provide
    mkfs.exfat and fsck.exfat commands but they have incompatible command
    line options and GParted is programmed for exfatprogs.  So far GParted
    just checks the executable exists, hence the mis-identification.
    
    Reported version of exfat-utils commands:
        $ mkfs.exfat -V 2> /dev/null
        mkexfatfs 1.3.0
        Copyright (C) 2011-2018  Andrew Nayenko
        $ fsck.exfat -V 2> /dev/null
        exfatfsck 1.3.0
        Copyright (C) 2011-2018  Andrew Nayenko
    
    Reported versions of exfatprogs commands:
        $ mkfs.exfat -V 2> /dev/null
        exfatprogs version : 1.0.4
        $ fsck.exfat -V 2> /dev/null
        exfatprogs version : 1.0.4
    
    Fix this by only enabling exfat support also when the version string of
    each command starts "exfatprogs version".  Note that this extra checking
    is not needed for tune.exfat because only exfatprogs provides that
    executable.
    
    Closes #137 - Creating exfat partition with a label fails with error

2021-01-16  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Make gparted shell wrapper report exit status from gpartedbin
    
    gparted shell wrapper always exits with a 0 status even if gpartedbin
    fails.  For example make gpartedbin fail with a non-zero exit status
    like this:
        $ (unset DISPLAY; unset XAUTHORITY; /usr/sbin/gpartedbin)
    
        (gpartedbin:3936): Gtk-WARNING **: 16:36:06.263: cannot open display:
        $ echo $?
        1
    
    However the gparted shell wrapper instead exits with successful status
    0:
        $ (unset DISPLAY; unset XAUTHORITY; gparted)
    
        (gpartedbin:4282): Gtk-WARNING **: 16:39:23.514: cannot open display:
        $ echo $?
        0
    
    Fix this.

2020-01-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Replace Win_GParted::hbox member with local variables
    
    hbox is a very generic name for a member variable and used as a local
    variable in two methods.  Change to local variables instead.

2021-01-31  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove now unused return value from run_blkid_load_cache() (#131)
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-31  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove now superfluous load_fs_info_cache() (#131)
    
    This method is now only called from one location in the code so put it's
    two lines of code there.
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-31  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Ensure FS_Info (blkid) cache is populated before first use (#131)
    
    Now we always want to run blkid naming all paths, ensure the FS_Info
    cache is explicitly loaded first.  Report an error if not done so and
    remove the cache loading code from running blkid without naming all
    paths.  Fewer code paths to consider and reason about.
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-27  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove extra execution of blkid for any unreported paths (#131)
    
    Again on Fedora 31 with a slightly different disk layout to the previous
    commit.  sdb is partitioned with 1 empty partition and sdc remains
    completely empty:
        # lsblk -o name,maj:min,rm,size,ro,type,fstype,label,mountpoint
        NAME            MAJ:MIN RM  SIZE RO TYPE FSTYPE      LABEL MOUNTPOINT
        sda               8:0    0   20G  0 disk
        |-sda1            8:1    0    1G  0 part ext4              /boot
        \-sda2            8:2    0   19G  0 part LVM2_member
          |-fedora-root 253:0    0   17G  0 lvm  ext4              /
          \-fedora-swap 253:1    0    2G  0 lvm  swap              [SWAP]
        sdb               8:16   0    8G  0 disk
        \-sdb1            8:17   0    1G  0 part
        sdc               8:32   0    8G  0 disk
        sr0              11:0    1 1024M  0 rom
        # blkid -v
        blkid from util-linux 2.34  (libblkid 2.34.0, 14-Jun-2019)
        # blkid /dev/sda /dev/sda1 /dev/sda2 /dev/sdb /dev/sdb1 /dev/sdc
        /dev/sda: PTUUID="5012fb1f" PTTYPE="dos"
        /dev/sda1: UUID="3cd48816-7817-4636-9fec-5f1afe76c1b2" TYPE="ext4" PARTUUID="5012fb1f-01"
        /dev/sda2: UUID="PH94ej-C8xU-bnMJ-UIh8-ZimI-4B7f-dHlZxh" TYPE="LVM2_member" PARTUUID="5012fb1f-02"
        /dev/sdb: PTUUID="1d120b57" PTTYPE="dos"
        /dev/sdb1: PARTUUID="1d120b57-01"
    
    Stracing GParted shows these executions of blkid:
        # strace -f -q -bexecve -eexecve ./gpartedbin 2>&1 1> /dev/null | egrep -v 'ENOENT|SIGCHLD'
        ...
        [pid 160040] execve("/usr/sbin/blkid", ["blkid", "/dev/sda", "/dev/sda1", "/dev/sda2", "/dev/sdb", "/dev/sdb1", "/dev/sdc"], 0xa4e1b0 /* 32 vars */ <detached ...>
        [pid 160041] execve("/usr/sbin/blkid", ["blkid", "/dev/sdc"], 0xa4e1b0 /* 32 vars */ <detached ...>
        ...
    
    On Fedora 31 with blkid from util-linux 2.34 it reports information for
    sdb (partitioned drive) and sdb1 (empty partition) with only no
    information for sdc (empty whole disk drive).  Hence no FS_Info cache
    entry and re-execution of blkid just for sdc.
    
    On older CentOS 7 with the same disk layout blkid reports this:
        # blkid -v
        blkid from util-linux 2.23.2  (libblkid 2.23.0, 25-Apr-2013)
        # blkid /dev/sda /dev/sda1 /dev/sda2 /dev/sdb /dev/sdb1 /dev/sdc
        /dev/sda: PTTYPE="dos"
        /dev/sda1: UUID="e7d559e4-3e1d-4fbc-b034-3fdeb498f44d" TYPE="xfs"
        /dev/sda2: UUID="B7ODFx-BfTE-hq7N-UlrF-f5ML-CPRe-klSy26" TYPE="LVM2_member"
        /dev/sdb: PTTYPE="dos"
    
    And stracing GParted shows these executions of blkid:
        # strace -f -q -bexecve -eexecve ./gpartedbin 2>&1 1> /dev/null | egrep -v 'ENOENT|SIGCHLD'
        ...
        [pid  1889] execve("/sbin/blkid", ["blkid", "/dev/sda", "/dev/sda1", "/dev/sda2", "/dev/sdb", "/dev/sdb1", "/dev/sdc"], 0x10b8b10 /* 26 vars */ <detached ...>
        [pid  1890] execve("/sbin/blkid", ["blkid", "/dev/sdb1"], 0x10b8b10 /* 26 vars */ <detached ...>
        [pid  1891] execve("/sbin/blkid", ["blkid", "/dev/sdc"], 0x10b8b10 /* 26 vars */ <detached ...>
    ...
    
    This time on CentOS 7 with blkid from util-linux 2.23.2 it reports
    information for only sdb (partitioned drive), but not sdb1 (empty
    partition) or sdc (empty whole disk drive).  Hence no FS_info cache
    entries and re-execution of blkid for both sdb1 and sdc.
    
    GParted needs blkid identification of file system images, LVM Logical
    Volumes or any other partitions named on the command line which it
    wouldn't normally scan [1].  Now every name of interest is passed to
    blkid, additional executions of blkid won't get any extra information
    and are redundant.  Therefore remove this unnecessary code.
    
    Note that these last 2 commits remove creation of "blank" cache entries
    (just block special with blank fstype and other attributes) when blkid
    reports no information for a particular path.  Those entry were needed
    to suppress unnecessary additional execution of blkid.  However now that
    blkid is only executed once (excluding querying the label) this is no
    longer necessary.  All the getter functions return suitable blank values
    when no cache entry is found.
    
    [1] e8f0504b13d98e23e70021f70638184daab228ec
        Make sure that FS_Info cache is loaded for all named paths (#787181)
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove extra execution of blkid for whole disk devices (#131)
    
    On Fedora 31 with this simple disk layout where both sdb and sdc are
    completely empty:
        # lsblk -o name,maj:min,rm,size,ro,type,fstype,label,mountpoint
        NAME            MAJ:MIN RM  SIZE RO TYPE FSTYPE      LABEL MOUNTPOINT
        sda               8:0    0   20G  0 disk
        |-sda1            8:1    0    1G  0 part ext4              /boot
        \-sda2            8:2    0   19G  0 part LVM2_member
          |-fedora-root 253:0    0   17G  0 lvm  ext4              /
          \-fedora-swap 253:1    0    2G  0 lvm  swap              [SWAP]
        sdb               8:16   0    8G  0 disk
        sdc               8:32   0    8G  0 disk
        sr0              11:0    1 1024M  0 rom
        # blkid /dev/sda /dev/sda1 /dev/sda2 /dev/sdb /dev/sdc
        /dev/sda: PTUUID="5012fb1f" PTTYPE="dos"
        /dev/sda1: UUID="3cd48816-7817-4636-9fec-5f1afe76c1b2" TYPE="ext4" PARTUUID="5012fb1f-01"
        /dev/sda2: UUID="PH94ej-C8xU-bnMJ-UIh8-ZimI-4B7f-dHlZxh" TYPE="LVM2_member" PARTUUID="5012fb1f-02"
    
    Stracing GParted shows extra executions of blkid:
        # strace -f -q -bexecve -eexecve ./gpartedbin 2>&1 1> /dev/null | egrep -v 'ENOENT|SIGCHLD'
        ...
        [pid  7659] execve("/usr/sbin/blkid", ["blkid", "/dev/sda", "/dev/sda1", "/dev/sda2", "/dev/sdb", "/dev/sdc"], 0x1d300f0 /* 32 vars */ <detached ...>
        [pid  7660] execve("/usr/sbin/blkid", ["blkid", "/dev/sdb"], 0x1d300f0 /* 32 vars */ <detached ...>
        [pid  7661] execve("/usr/sbin/blkid", ["blkid", "/dev/sdc"], 0x1d300f0 /* 32 vars */ <detached ...>
        ...
    
    blkid is only run again for sdb and sdc, not sda, because blkid didn't
    report anything for them from the first execution.  GParted needs blkid
    identification of whole disk devices to ensure that ISO9660 images on
    whole disk devices are correctly identified [1].  Now the first run of
    blkid passes all the device names, so this additional execution of blkid
    won't get any extra information and is redundant.  Therefore remove this
    unnecessary code.
    
    [1] b2190372d04f09bd38a7395b38e43034f1733d81
        Ensure blkid FS_Info cache has entries for all whole disk devices
        (#771244)
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Pass device and partition names to blkid (#131)
    
    A user reported that GParted would hang at "scanning all devices...",
    when a fully working disk was named on the command line, but another
    device on the machine was hung.
    
    This can be replicated like this:
    (on Ubuntu 20.04 LTS for it's NBD support)
    
    1. Export and import NBD:
        # truncate -s 1G /tmp/disk-1G.img
        # nbd-server -C /dev/null 9000 /tmp/disk-1G.img
        # nbd-client localhost 9000 /dev/nbd0
    
    2. Hang the NBD server and therefore /dev/nbd0:
        # killall -STOP nbd-server
    
    3. Run GParted:
        $ gparted /dev/sda
    
    Tracing GParted shows that execution of blkid never returns.
    
        # strace -f -tt -q -bexecve -eexecve ./gpartedbin 2>&1 1> /dev/null | fgrep -v ENOENT
        ...
        [pid 37823] 13:56:24.814139 execve("/usr/sbin/mkudffs", ["mkudffs", "--help"], 0x55e2a3f2d230 /* 20 vars */ <detached ...>
        [pid 37814] 13:56:24.829246 --- SIGCHLD {si_signo=SIGCHLD, si_code=CLD_EXITED, si_pid=37823, si_uid=0, si_status=1, si_utime=0, si_stime=0} ---
        [pid 37825] 13:56:25.376796 execve("/usr/sbin/blkid", ["blkid", "-v"], 0x55e2a3f2d230 /* 20 vars */ <detached ...>
        [pid 37824] 13:56:25.380824 --- SIGCHLD {si_signo=SIGCHLD, si_code=CLD_EXITED, si_pid=37825, si_uid=0, si_status=0, si_utime=0, si_stime=0} ---
        [pid 37826] 13:56:25.402512 execve("/usr/sbin/blkid", ["blkid"], 0x55e2a3f2d230 /* 20 vars */ <detached ...>
    
    Tracking of blkid shows that it hangs on either the open of or first
    read from /dev/nbd0.
    
        # strace blkid
        ...
        lstat("/dev", {st_mode=S_IFDIR|0755, st_size=4560, ...}) = 0
        lstat("/dev/nbd0", {st_mode=S_IFBLK|0660, st_rdev=makedev(0x2b, 0), ...}) = 0
        stat("/dev/nbd0", {st_mode=S_IFBLK|0660, st_rdev=makedev(0x2b, 0), ...}) = 0
        lstat("/dev", {st_mode=S_IFDIR|0755, st_size=4560, ...}) = 0
        lstat("/dev/nbd0", {st_mode=S_IFBLK|0660, st_rdev=makedev(0x2b, 0), ...}) = 0
        access("/dev/nbd0", F_OK)               = 0
        stat("/dev/nbd0", {st_mode=S_IFBLK|0660, st_rdev=makedev(0x2b, 0), ...}) = 0
        openat(AT_FDCWD, "/sys/dev/block/43:0", O_RDONLY|O_CLOEXEC) = 4
        openat(4, "dm/uuid", O_RDONLY|O_CLOEXEC) = -1 ENOENT (No such file or directory)
        close(4)                                = 0
        openat(AT_FDCWD, "/dev/nbd0", O_RDONLY|O_CLOEXEC
    
    Clean up:
    
    1. Resume NBD server:
        # killall -CONT nbd-server
    
    2. Delete NBD setup:
        # nbd-client -d /dev/nbd0
        # killall nbd-server
        # rm /tmp/disk-1G.img
    
    Fix this by making GParted specify the whole disk device and partition
    names that it is interested in to blkid, rather than letting blkid scan
    and report all block devices.  Do this both when GParted determines the
    devices for itself and when they are named on the command line.
    
    Also update example blkid command output being parsed and cache value
    with this change to how blkid is executed.
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Refactor run_blkid_load_cache() into if fail return early (#131)
    
    ... code pattern.  Simplifies the code a little.
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-23  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Read partition names from /proc/partitions too (#131)
    
    GParted already always reads /proc/partitions for whole disk device
    names no matter whether it uses whole disk devices named on the command
    line, from /proc/partitions or from libparted.  As /proc/partitions
    lists all the block devices that the kernel knows about, and therefore
    all the possible ones blkid could probe, so use it to provide partition
    names and device to partition mapping.  See code comments for more
    details about the assumptions the /proc/partition parsing code makes and
    the fact that these are confirmed by examining the Linux kernel source.
    
    This commit just adds debugging to print the existing vector of
    validated devices GParted shows in the UI and the vector with all
    partitions added, ready for but not yet passed to blkid.
        # ./gpartedbin
        ...
        DEBUG: device_paths=["/dev/sda","/dev/sdb"]
        DEBUG: device_and_partition_paths=["/dev/sda","/dev/sda1","/dev/sda2","/dev/sdb","/dev/sdb1"]
    
    Also demonstrating that this continues to support named devices,
    including file system image files [1].
        # truncate -s 256M /tmp/ext4.img
        # mkfs.ext4 /tmp/ext4.img
        # ./gpartedbin /dev/sda /tmp/ext4.img
        ...
        DEBUG: device_paths=["/dev/sda","/tmp/ext4.img"]
        DEBUG: device_and_partition_paths=["/dev/sda","/dev/sda1","/dev/sda2","/tmp/ext4.img"]
    
    [1] e8f0504b13d98e23e70021f70638184daab228ec
        Make sure that FS_Info cache is loaded for all named paths (#787181)
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-21  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Refactor load_proc_partitions_info_cache() a bit (#131)
    
    Put whole disk device name matching code into a helper function to make
    the /proc/partition parsing code easier to understand.
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Merge FS_Info load cache calls (#131)
    
    Now FS_Info::load_cache() and ::load_cache_for_paths() are nearly next
    to each other, merge them together to simplify the code a little.  This
    makes the special case to ensure that file system images named on the
    command line were queried by blkid and loaded into the FS_Info cache [1]
    become the normal cache loading method.  Already passing all discovered
    or named devices to load_cache_for_paths() is also a step on the way to
    doing it for all devices and partitions of interest.
    
    Just need to ensure that load_cache_for_paths() always loads the cache
    as load_cache() did, rather than only when it hadn't already been
    loaded.  Otherwise GParted will only ever run blkid and load the cache
    once at startup and not on each refresh.
    
    [1] e8f0504b13d98e23e70021f70638184daab228ec
        Make sure that FS_Info cache is loaded for all named paths (#787181)
    
    Closes #131 - GParted hangs when non-named device is hung

2021-01-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Initialise partition content discovery caches a bit later (#131)
    
    PATCHSET OVERVIEW
    
    A user reported that GParted would hang at "scanning all devices...",
    when a fully working disk was named on the command line, but another
    device on the machine was hung.
    
    This can be replicated like this:
    (on Ubuntu 20.04 LTS for it's NBD support)
    
    1. Export and import NBD:
        # truncate -s 1G /tmp/disk-1G.img
        # nbd-server -C /dev/null 9000 /tmp/disk-1G.img
        # nbd-client localhost 9000 /dev/nbd0
    
    2. Hang the NBD server and therefore /dev/nbd0:
        # killall -STOP nbd-server
    
    3. Run GParted:
        $ gparted /dev/sda
    
    Tracing GParted shows that execution of blkid never returns.
    
        # strace -f -tt -q -bexecve -eexecve /usr/sbin/gpartedbin 2>&1 1> /dev/null | fgrep -v ENOENT
        ...
        [pid 37823] 13:56:24.814139 execve("/usr/sbin/mkudffs", ["mkudffs", "--help"], 0x55e2a3f2d230 /* 20 vars */ <detached ...>
        [pid 37814] 13:56:24.829246 --- SIGCHLD {si_signo=SIGCHLD, si_code=CLD_EXITED, si_pid=37823, si_uid=0, si_status=1, si_utime=0, si_stime=0} ---
        [pid 37825] 13:56:25.376796 execve("/usr/sbin/blkid", ["blkid", "-v"], 0x55e2a3f2d230 /* 20 vars */ <detached ...>
        [pid 37824] 13:56:25.380824 --- SIGCHLD {si_signo=SIGCHLD, si_code=CLD_EXITED, si_pid=37825, si_uid=0, si_status=0, si_utime=0, si_stime=0} ---
        [pid 37826] 13:56:25.402512 execve("/usr/sbin/blkid", ["blkid"], 0x55e2a3f2d230 /* 20 vars */ <detached ...>
    
    Tracing of blkid shows that it hangs on either the open of or first
    read from /dev/nbd0.
    
        # strace blkid
        ...
        lstat("/dev", {st_mode=S_IFDIR|0755, st_size=4560, ...}) = 0
        lstat("/dev/nbd0", {st_mode=S_IFBLK|0660, st_rdev=makedev(0x2b, 0), ...}) = 0
        stat("/dev/nbd0", {st_mode=S_IFBLK|0660, st_rdev=makedev(0x2b, 0), ...}) = 0
        lstat("/dev", {st_mode=S_IFDIR|0755, st_size=4560, ...}) = 0
        lstat("/dev/nbd0", {st_mode=S_IFBLK|0660, st_rdev=makedev(0x2b, 0), ...}) = 0
        access("/dev/nbd0", F_OK)               = 0
        stat("/dev/nbd0", {st_mode=S_IFBLK|0660, st_rdev=makedev(0x2b, 0), ...}) = 0
        openat(AT_FDCWD, "/sys/dev/block/43:0", O_RDONLY|O_CLOEXEC) = 4
        openat(4, "dm/uuid", O_RDONLY|O_CLOEXEC) = -1 ENOENT (No such file or directory)
        close(4)                                = 0
        openat(AT_FDCWD, "/dev/nbd0", O_RDONLY|O_CLOEXEC
    
    Clean up:
    
    1. Resume NBD server:
        # killall -CONT nbd-server
    
    2. Delete NBD setup:
        # nbd-client -d /dev/nbd0
        # killall nbd-server
        # rm /tmp/disk-1G.img
    
    Going to fix this by making GParted specify the device and partition
    names that it is interested in to blkid, rather than letting blkid scan
    and report all block devices.  Do this both when GParted determines the
    devices for itself and when they are named on the command line.
    
    THIS PATCH
    
    Move the loading and initialising of caches used during content
    discovery to after device and partition discovery and just before
    content discovery.  Just makes the code ready for the next change.
    
    Closes #131 - GParted hangs when non-named device is hung

2021-02-06  Dušan Kazik <prescott66@gmail.com>

    Update Slovak translation

2021-01-25  Curtis Gedak <gedakc@gmail.com>

    Append -git to version for continuing development

2021-01-25  Curtis Gedak <gedakc@gmail.com>

    ==========   gparted-1.2.0   ==========

2021-01-25  Curtis Gedak <gedakc@gmail.com>

    Update copyright years

2021-01-24  Rūdolfs Mazurs <rudolfs.mazurs@gmail.com>

    Update Latvian translation

2021-01-23  Fabio Tomat <f.t.public@gmail.com>

    Update Friulian translation

2021-01-22  Philipp Kiemle <philipp.kiemle@gmail.com>

    Update German translation

2021-01-21  Marek Černocký <marek@manet.cz>

    Updated Czech translation

2021-01-20  Thibault Martin <mail@thibaultmart.in>

    Update French translation

2021-01-19  Мирослав Николић <miroslavnikolic@rocketmail.com>

    Update Serbian translation

2021-01-19  Daniel Mustieles <daniel.mustieles@gmail.com>

    Updated Spanish translation

2021-01-18  Rafael Fontenelle <rafaelff@gnome.org>

    Update Brazilian Portuguese translation

2021-01-18  Rafael Fontenelle <rafaelff@gnome.org>

    Update Brazilian Portuguese translation

2021-01-18  Daniel Șerbănescu <daniel@serbanescu.dk>

    Update Romanian translation

2021-01-17  Piotr Drąg <piotrdrag@gmail.com>

    Update Polish translation

2021-01-16  Anders Jonsson <anders.jonsson@norsjovallen.se>

    Update Swedish translation

2021-01-16  Yuri Chornoivan <yurchor@ukr.net>

    Update Ukrainian translation

2021-01-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    White space tidy-up of Utils::get_filesystem_software()
    
    Put colon directly after case value and list cases in enumeration order.

2021-01-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add unit testing of GParted exFAT interface (!30)
    
    Install exfatprogs into the CentOS 7 GitLab CI image, enabling unit
    testing of GParted's use of exFAT programs.  Exfatprogs is not yet
    available for Ubuntu 20.04 as used in the Ubuntu GitLab CI image, only
    for Ubuntu 20.10 so far.
    
    Closes !30 - Add exFAT support

2021-01-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Set the partition type for exFAT correctly (!30)
    
    Libparted only allows selection of the partition type indirectly by
    specifying the type of the file system it will contain [1] and so far
    doesn't know about the exFAT file system.  Therefore when GParted is
    creating a new exFAT partition, it gets the GParted default of 83
    (Linux file system) on MBR partition tables.
    
    Example operation details:
        Create Primary Partition #1 (exfat, 512.00 MiB) on /dev/sdb
        * create empty partition
        * clear old file system signatures in /dev/sdb1
        * set partition type on /dev/sdb1
            new partition type: ext2
        * create new exfat file system
    
    fdisk report:
        # fdisk -l /dev/sdb
        Disk /dev/sdb: 8 GiB, 8589934592 bytes, 16777216 sectors
        Disk model: VBOX HARDDISK
        Units: sectors of 1 * 512 = 512 bytes
        Sector size (logical/physical): 512 bytes / 512 bytes
        I/O size (minimum/optimal): 512 bytes / 512 bytes
        Disklabel type: dos
        Disk identifier: 0xa2aab629
    
        Device     Boot Start     End Sectors  Size Id Type
        /dev/sdb1        2048 1050623 1048576  512M 83 Linux
    
    However the "exFAT file system specification" says:
        https://docs.microsoft.com/en-us/windows/win32/fileio/exfat-specification
        "10.2 Partition Tables
    
        To ensure interoperability of exFAT volumes in a broad set of usage
        scenarios, implementations should use partition type 07h for MBR
        partitioned storage and partition GUID
        {EBD0A0A2-B9E5-4433-87C0-68B6B72699C7} for GPT partitioned storage.
        "
    
    Fix this.
    
    [1] ped_partition_new(..., const PedFileSystemType* fs_type, ...)
        https://www.gnu.org/software/parted/api/group__PedPartition.html#g2f94ca75880f9e0c3ce57f7a4b72faf5
        ped_partition_set_system(..., const PedFileSystemType* fs_type)
        https://www.gnu.org/software/parted/api/group__PedPartition.html#g2f94ca75880f9e0c3ce57f7a4b72faf5
    
    Closes !30 - Add exFAT support

2021-01-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add exFAT support (!30)
    
    With exfatprogs (https://github.com/exfatprogs/exfatprogs) installed the
    following operations on exFAT file systems are supported:
    - Creation
    - Checking
    - Labelling
    As of the current exfatprogs 1.0.4 the following are not supported:
    - Reading usage
    - Resizing
    - Updating the UUID
    
    Closes !30 - Add exFAT support

2021-01-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Exclude snap /dev/loop file system image mounts (#129)
    
    On Ubuntu the gparted shell wrapper still attempts to mask lots of
    non-block device based file systems.  Remove the --quiet option from the
    systemctl --runtime mask command to see:
        $ gparted
        Created symlink /run/systemd/system/snap-gnome\x2d3\x2d34\x2d1804-66.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-core-10583.mount -> /dev/null.
        Created symlink /run/systemd/system/boot-efi.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-gtk\x2dcommon\x2dthemes-1514.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-core-10577.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-core18-1944.mount -> /dev/null.
        Created symlink /run/systemd/system/run-user-1000-doc.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-gtk\x2dcommon\x2dthemes-1506.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-gnome\x2d3\x2d28\x2d1804-128.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-snap\x2dstore-518.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-gnome\x2d3\x2d28\x2d1804-145.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-core18-1932.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-snap\x2dstore-467.mount -> /dev/null.
        Created symlink /run/systemd/system/snap-gnome\x2d3\x2d34\x2d1804-60.mount -> /dev/null.
        Created symlink /run/systemd/system/-.mount -> /dev/null.
        GParted 1.0.0
        configuration --enable-libparted-dmraid --enable-online-resize
        libparted 3.3
    
    The gparted shell wrapper is currently looking for non-masked Systemd
    mount units where the 'What' property starts "/dev/".  However Ubuntu
    also uses snap packages which are mounted file images via loop devices:
        $ grep '^/dev/' /proc/mounts | sort
        /dev/fuse /run/user/1000/doc fuse rw,nosuid,nodev,relatime,user_id=1000,group_id=1000 0 0
        /dev/loop0 /snap/core/10583 squashfs ro,nodev,relatime 0 0
        /dev/loop10 /snap/snap-store/518 squashfs ro,nodev,relatime 0 0
        /dev/loop11 /snap/snap-store/467 squashfs ro,nodev,relatime 0 0
        /dev/loop12 /snap/gtk-common-themes/1506 squashfs ro,nodev,relatime 0 0
        /dev/loop1 /snap/core/10577 squashfs ro,nodev,relatime 0 0
        /dev/loop3 /snap/core18/1944 squashfs ro,nodev,relatime 0 0
        /dev/loop4 /snap/core18/1932 squashfs ro,nodev,relatime 0 0
        /dev/loop5 /snap/gnome-3-34-1804/66 squashfs ro,nodev,relatime 0 0
        /dev/loop6 /snap/gnome-3-28-1804/128 squashfs ro,nodev,relatime 0 0
        /dev/loop7 /snap/gnome-3-34-1804/60 squashfs ro,nodev,relatime 0 0
        /dev/loop8 /snap/gnome-3-28-1804/145 squashfs ro,nodev,relatime 0 0
        /dev/loop9 /snap/gtk-common-themes/1514 squashfs ro,nodev,relatime 0 0
        /dev/sda1 /boot/efi vfat rw,relatime,fmask=0077,dmask=0077,codepage=437,iocharset=iso8859-1,shortname=mixed,errors=remount-ro 0 0
        /dev/sda5 / ext4 rw,relatime,errors=remount-ro 0 0
    
    Fix by excluding:
    1. Device name "/dev/fuse" because it's a character not a block device
       and the mount point is associated with snap,
    2. Device names starting "/dev/loop" and where the mount point starts
       "/snap/" [1].  This is to allow for use of GParted with explicitly
       named loop devices.
    
    [1] The system /snap directory
        https://snapcraft.io/docs/system-snap-directory
    
    Closes #129 - Unit \xe2\x97\x8f.service does not exist, proceeding
                  anyway

2021-01-04  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Only mask Systemd mounts on block devices (#129)
    
    The gparted shell wrapper masks Systemd mount units to prevent it
    automounting file systems while GParted is running [1], excluding
    virtual file system which GParted isn't interested in [2].  The problem
    is that there are a lot of virtual file systems and they have changed
    between Fedora 19 and 33 so now the exclusion list is out of date.
    
    Run GParted on Fedora 33 and query the mount units while it is running:
        $ systemctl list-units -t mount --full --all
          UNIT                          LOAD   ACTIVE   SUB     DESCRIPTION
          -.mount                       loaded active   mounted Root Mount
        * boot.mount                    masked active   mounted /boot
          dev-hugepages.mount           loaded active   mounted Huge Pages File System
          dev-mqueue.mount              loaded active   mounted POSIX Message Queue File System
        * home.mount                    masked active   mounted /home
        * proc-fs-nfsd.mount            masked inactive dead    proc-fs-nfsd.mount
          proc-sys-fs-binfmt_misc.mount loaded inactive dead    Arbitrary Executable File Formats File System
          run-user-1000-gvfs.mount      loaded active   mounted /run/user/1000/gvfs
        * run-user-1000.mount           masked active   mounted /run/user/1000
        * run-user-42.mount             masked active   mounted /run/user/42
          sys-fs-fuse-connections.mount loaded active   mounted FUSE Control File System
          sys-kernel-config.mount       loaded active   mounted Kernel Configuration File System
          sys-kernel-debug.mount        loaded active   mounted Kernel Debug File System
        * sys-kernel-tracing.mount      masked active   mounted /sys/kernel/tracing
        * sysroot.mount                 masked inactive dead    sysroot.mount
        * tmp.mount                     masked active   mounted /tmp
        * var-lib-machines.mount        masked inactive dead    var-lib-machines.mount
        * var-lib-nfs-rpc_pipefs.mount  masked active   mounted /var/lib/nfs/rpc_pipefs
        * var.mount                     masked inactive dead    var.mount
    
        LOAD   = Reflects whether the unit definition was properly loaded.
        ACTIVE = The high-level unit activation state, i.e. generalization of SUB.
        SUB    = The low-level unit activation state, values depend on unit type.
    
        19 loaded units listed.
        To show all installed unit files use 'systemctl list-unit-files'.
    
    So it masked these virtual file systems which didn't need to be masked:
        * proc-fs-nfsd.mount            masked inactive dead    proc-fs-nfsd.mount
        * run-user-1000.mount           masked active   mounted /run/user/1000
        * run-user-42.mount             masked active   mounted /run/user/42
        * sys-kernel-tracing.mount      masked active   mounted /sys/kernel/tracing
        * var-lib-machines.mount        masked inactive dead    var-lib-machines.mount
        * var-lib-nfs-rpc_pipefs.mount  masked active   mounted /var/lib/nfs/rpc_pipefs
    
    Lines from /proc/partitions for some of these virtual file systems:
        $  egrep '/run/user|/sys/kernel/tracing|/var/lib/nfs/rpc_pipefs' /proc/mounts
        tmpfs /run/user/42 tmpfs rw,seclabel,nosuid,nodev,relatime,size=202656k,nr_inodes=50664,mode=700,uid=42,gid=42,inode64 0 0
        tmpfs /run/user/1000 tmpfs rw,seclabel,nosuid,nodev,relatime,size=202656k,nr_inodes=50664,mode=700,uid=1000,gid=1000,inode64 0 0
        none /sys/kernel/tracing tracefs rw,seclabel,relatime 0 0
        sunrpc /var/lib/nfs/rpc_pipefs rpc_pipefs rw,relatime 0 0
        gvfsd-fuse /run/user/1000/gvfs fuse.gvfsd-fuse rw,nosuid,nodev,relatime,user_id=1000,group_id=1000 0 0
    
    And for contrast the lines from /proc/mounts for disk backed file systems:
        $ egrep '^/dev/' /proc/mounts
        /dev/sda1 /boot ext4 rw,seclabel,relatime 0 0
        /dev/sda2 / btrfs rw,seclabel,relatime,space_cache,subvolid=258,subvol=/root 0 0
        /dev/sda2 /home btrfs rw,seclabel,relatime,space_cache,subvolid=256,subvol=/home 0 0
    
    Going back to first principles GParted cares that Systemd doesn't
    automount file systems on block devices.  So instead only mask mount
    units which are on block devices.  Where the 'What' property starts
    "/dev/".
    
    Systemd maintains hundreds of properties for each unit.
        $ systemctl show boot.mount | wc -l
        221
    
    The properties of interest for all mount units can be queries like this:
        $ systemctl show --all --property=What,Id,LoadState '*.mount'
        ...
    
        What=sunrpc
        Id=var-lib-nfs-rpc_pipefs.mount
        LoadState=masked
    
        What=/dev/sda1
        Id=boot.mount
        LoadState=masked
    
        ...
    
    [1] 4c109df9b59e55699bd42023cf4007ee359793e9
        Use systemctl runtime mask to prevent automounting (#701676)
    
    [2] 43de8e326a9f6f099e5274619f16039bdc20c1a4
        Do not mask virtual file systems when using systemctl (#708378)
    
    Closes #129 - Unit \xe2\x97\x8f.service does not exist, proceeding
                  anyway

2021-01-04  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Don't try to mask non-existent Systemd \xe2\x97\x8f.service (#129)
    
    With Systemd 246 on Fedora 33, running GParted reports this error and no
    longer masks the system mount units:
    
        $ gparted
        Unit \xe2\x97\x8f.service does not exist, proceeding anyway.
        Unit \xe2\x97\x8f.service does not exist, proceeding anyway.
        GParted 1.1.0
        configuration --enable-libparted-dmraid --enable-online-resize
        libparted 3.3
    
        $ systemctl list-units -t mount --full --all --no-legend
          -.mount                       loaded    active   mounted Root Mount
          boot.mount                    loaded    active   mounted /boot
          dev-hugepages.mount           loaded    active   mounted Huge Pages File System
          dev-mqueue.mount              loaded    active   mounted POSIX Message Queue File System
          home.mount                    loaded    active   mounted /home
          proc-fs-nfsd.mount            loaded    inactive dead    NFSD configuration filesystem
          proc-sys-fs-binfmt_misc.mount loaded    inactive dead    Arbitrary Executable File Formats File System
          run-user-1000-gvfs.mount      loaded    active   mounted /run/user/1000/gvfs
          run-user-1000.mount           loaded    active   mounted /run/user/1000
          run-user-42.mount             loaded    active   mounted /run/user/42
          sys-fs-fuse-connections.mount loaded    active   mounted FUSE Control File System
          sys-kernel-config.mount       loaded    active   mounted Kernel Configuration File System
          sys-kernel-debug.mount        loaded    active   mounted Kernel Debug File System
          sys-kernel-tracing.mount      loaded    active   mounted Kernel Trace File System
        * sysroot.mount                 not-found inactive dead    sysroot.mount
          tmp.mount                     loaded    active   mounted Temporary Directory (/tmp)
          var-lib-machines.mount        loaded    inactive dead    Virtual Machine and Container Storage (Compatibility)
          var-lib-nfs-rpc_pipefs.mount  loaded    active   mounted RPC Pipe File System
        * var.mount                     not-found inactive dead    var.mount
    
        ^
       [Unicode Black Circle character (U+25CF) replaced with star to avoid
       making this this commit message Unicode.]
    
    Currently the gparted shell wrapper lists the Systemd mount units and
    takes the first space separated column as the unit name.  If the LOAD
    status of the unit is not "loaded" then Systemd prefixes the name with
    an optional Black Circle.  Prior to Systemd 246 these extra 2 characters
    at the start of the line, including the optional Black Circle, were
    suppressed by the --no-legend option, but with Systemd 246 this no
    longer happens.  As the mount unit names no longer start in the first
    character of the line no units are masked.  Instead the Unicode Black
    Circle character, UTF-8 byte sequence E2 97 8F, is found at the start of
    highlighted lines which results in this error:
        Unit \xe2\x97\x8f.service does not exist, proceeding anyway.
    
    Fix by adding the --plain option to suppress the optional Black Circle
    in the systemctl output.  Confirmed this option is available in the
    oldest supported distributions with Systemd.
        RedHat / CentOS 7   Systemd 219   systemctl has --plain option.
        Ubuntu 16.04 LTS    Systemd 229   systemctl has --plain option.
    
    Closes #129 - Unit \xe2\x97\x8f.service does not exist, proceeding
                  anyway

2021-01-10  Jordi Mas <jmas@softcatala.org>

    Update Catalan translation

2021-01-01  Jordi Mas <jmas@softcatala.org>

    Update Catalan translation

2020-11-28  Аляксей <alexey_razumov@tutanota.com>

    Update Belarusian translation

2020-11-13  Curtis Gedak <gedakc@gmail.com>

    Set default partition alignment to cylinder for amiga partition table (#116)
    
    Closes #116 - Fails to create partitions on disks with Amiga partition
                  tables using default settings

2020-11-02  Jordi Mas <jmas@softcatala.org>

    Update Catalan translation

2020-10-13  Dušan Kazik <prescott66@gmail.com>

    Update Slovak translation

2019-12-23  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove unneeded #include <vector> from TreeView_Detail.h
    
    std::vector<> is no longer used in TreeView_Detail.h since this commit
    replaced them:
        fae909897e92b55aed0624ec8ccf221806e23ef4
        Use PartitionVector class throughout the code (#759726)

2020-09-17  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Fix CentOS 7 CI test job failures from empty /etc/machine-id (!62)
    
    Since August 2020, GitLab Continuous Integration test jobs have been
    failing on the CentOS 7 image like this from
    tests/test_SupportedFileSystems.log:
    
        process 6319: D-Bus library appears to be incorrectly set up; failed to read machine uuid: UUID file '/etc/machine-id' should contain a hex string of length 32, not length 0, with no other text
        See the manual page for dbus-uuidgen to correct this issue.
          D-Bus not built with -rdynamic so unable to print a backtrace
        Running main() from test_SupportedFileSystems.cc
        DISPLAY=":99"
        /usr/bin/xvfb-run: line 181:  6319 Aborted                 (core dumped) DISPLAY=:$SERVERNUM XAUTHORITY=$AUTHFILE "$@" 2>&1
    
    Not sure why this has just started failing in the CentOS 7 CI image now,
    but the error is widely known [1][2][3][4].  Use
    systemd-machine-id-setup to generate a machine ID [5][6]; rather than
    dbus-uuidgen [7] as it's designed to integrate into VMs and does the
    right thing if a valid machine ID already exists.
    
    [1] Red Hat Bug 598200 - D-Bus library appears to be incorrectly set up;
        failed to read machine uuid: UUID file '/var/lib/dbus/machine-id'
        https://bugzilla.redhat.com/show_bug.cgi?id=598200
    [2] Free Desktop Bug 13194 - When machine-id not found, dbus should not
        abort
        https://bugs.freedesktop.org/show_bug.cgi?id=13194
    [3] D-Bus library appears to be incorrectly set up
        https://unix.stackexchange.com/questions/117741/d-bus-library-appears-to-be-incorrectly-set-up
    [4] Generate uuid for container
        https://xpra.org/trac/wiki/Usage/Docker/CentOS
    [5] CentOS / RHEL 7 : How to Change the machine-id
        https://www.thegeekdiary.com/centos-rhel-7-how-to-change-the-machine-id/
    [6] man systemd-machine-id-setup
        https://man7.org/linux/man-pages/man1/systemd-machine-id-setup.1.html
    [7] man dbus-uuidgen
        https://dbus.freedesktop.org/doc/dbus-uuidgen.1.html
    
    Closes !62 - Fix CentOS 7 CI test job failures because of zero sized
                 /etc/machine-id

2020-09-11  Fabio Tomat <f.t.public@gmail.com>

    Update Friulian translation

2020-09-06  Aurimas Černius <aurisc4@gmail.com>

    Updated Lithuanian translation

2020-08-30  Boyuan Yang <073plan@gmail.com>

    Update Chinese (China) translation

2020-07-12  Piotr Drąg <piotrdrag@gmail.com>

    Update Polish translation
    
    Fixes https://gitlab.gnome.org/Teams/Translation/pl/-/issues/8

2020-06-26  Baurzhan Muftakhidinov <baurthefirst@gmail.com>

    Update Kazakh translation

2020-05-31  Daniel Șerbănescu <daniel@serbanescu.dk>

    Update Romanian translation

2019-12-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add missing includes into Devices module

2020-05-23  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Exclude PipeCapture read NUL byte unit tests in GitLab CI jobs (!60)
    
    These PipeCapture unit tests are also failing, preventing the
    ubuntu_test CI job passing:
        PipeCaptureTest.ReadEmbeddedNULCharacter
        PipeCaptureTest.ReadNULByteInMiddleOfMultiByteUTF8Character
    
    These tests are also failing locally in both Ubuntu 20.04 LTS and
    Fedora 32 VMs, but not in Ubuntu 18.04 LTS or Fedora 31 VMs.  As this is
    not specifically a Ubuntu docker image update related issue, temporarily
    exclude these failing tests.
    
    Closes !60 - Fix GitLab CI job failures following Ubuntu docker image
                 updates

2020-05-23  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add C++ compiler into GitLab CI Ubuntu image (!60)
    
    Next the Ubuntu image CI job is failing without a C++ compiler like
    this:
    
        checking whether to enable maintainer-specific portions of Makefiles... yes
        checking for g++... no
        checking for c++... no
        checking for gpp... no
        checking for aCC... no
        checking for CC... no
        checking for cxx... no
        checking for cc++... no
        checking for cl.exe... no
        checking for FCC... no
        checking for KCC... no
        checking for RCC... no
        checking for xlC_r... no
        checking for xlC... no
        checking whether the C++ compiler works... no
        configure: error: in `/builds/mfleetwo/gparted':
        configure: error: C++ compiler cannot create executables
        See `config.log' for more details
        ...
        ERROR: Job failed: exit code 1
    
    The published "Ubuntu" docker image has been updated to Ubuntu 20.04 LTS
    and must no longer include the build tools by default, or not be a
    dependency of any of the other installed packages.  Explicitly install
    build-essential to get the C++ compiler [1].  Also don't list make as
    build-essential includes it.
    
    [1] Installing the GNU C compiler and GNU C++ compiler
        https://help.ubuntu.com/community/InstallingCompilers
    
    Closes !60 - Fix GitLab CI job failures following Ubuntu docker image
                 updates

2020-05-22  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Prevent tzdata install hang in GitLab CI Ubuntu image (!60)
    
    The Ubuntu based GitLab CI jobs have recently started being terminated
    after the default 1 hour timeout.  Installing / updating packages in the
    image is updating the tzdata package which is prompting for input which
    it will never receive, hence the hang.  The end of output from the job
    looks like this:
    
        Setting up tzdata (2020a-0ubuntu0.20.04) ...
        debconf: unable to initialize frontend: Dialog
        debconf: (TERM is not set, so the dialog frontend is not usable.)
        debconf: falling back to frontend: Readline
        Configuring tzdata
        ------------------
        Please select the geographic area in which you live. Subsequent configuration
        questions will narrow this down by presenting a list of cities, representing
        the time zones in which they are located.
          1. Africa      4. Australia  7. Atlantic  10. Pacific  13. Etc
          2. America     5. Arctic     8. Europe    11. SystemV
          3. Antarctica  6. Asia       9. Indian    12. US
        Geographic area:
        ...
        ERROR: Job failed: execution took longer than 1h0m0s seconds
    
    This is a well known issue [1][2][3].  Probably occurring now because of
    a new release of tzdata not included in the base Ubuntu image we are
    using.  Fix by telling the underlying dpkg tools this installation is
    non-interactive.
    
    [1] Avoiding user interaction with tzdata when installing certbot in a
        docker container
        https://askubuntu.com/questions/909277/avoiding-user-interaction-with-tzdata-when-installing-certbot-in-a-docker-contai
    [2] How to install tzdata on a ubuntu docker image?
        https://serverfault.com/questions/949991/how-to-install-tzdata-on-a-ubuntu-docker-image
    [3] apt-get install tzdata noninteractive
        https://stackoverflow.com/questions/44331836/apt-get-install-tzdata-noninteractive
    
    Closes !60 - Fix GitLab CI job failures following Ubuntu docker image
                 updates

2020-05-24  Yi-Jyun Pan <pan93412@gmail.com>

    Update Chinese (Taiwan) translation

2020-05-04  Dušan Kazik <prescott66@gmail.com>

    Update Slovak translation

2020-03-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Replace TRUE #define with C++ true literal
    
    Everywhere else in the code the lower case true C++ boolean literal is
    used.  Change this one place where upper case TRUE #define was used to
    match.

2020-03-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add /dev/disk/by-id/ symlink in CI for test_BlockSpecial
    
    This previous commit [1] excluded unit test
    BlockSpecialTest.NamedBlockSpecialObjectBySymlinkMatches because GNOME
    GitLab Docker CI images don't have /dev/disk hierarchy and so no
    symbolic links to block devices.
    
    Create the /dev/disk/by-id directory and a symlink for this unit test to
    use in the new tests/makedev.sh script.
    
    [1] fe2fc33e67980f0b4a5bba958d257be54715f301
        Exclude unit test which fails in Docker CI image (!4)

2020-03-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Exclude unit tests needing losetup in Docker CI image (!59)
    
    test_SupportedFileSystems is another unit test that has been failing
    since 23-Feb-2020 in GNOME GitLab Continuous Integration test jobs.
    Fragments from tests/test-suite.log from a failed test CI job:
    
        FAIL: test_SupportedFileSystems
        ===============================
        ...
        [ RUN      ] My/SupportedFileSystemsTest.Create/lvm2pv
        test_SupportedFileSystems.cc:387: Failure
        Failed
        create_loopdev(): Execute: losetup --find --show 'test_SupportedFileSystems.img'
        losetup: test_SupportedFileSystems.img: failed to set up loop device: No such file or directory
        create_loopdev(): Losetup failed with exit status 1
        create_loopdev(): Failed to create required loop device
        Error: Could not stat device  - No such file or directory.
        test_SupportedFileSystems.cc:446: Failure
        Value of: lp_device != NULL
          Actual: false
        Expected: true
        test_SupportedFileSystems.cc:490: Failure
        Value of: m_fs_object->create(m_partition, m_operation_detail)
          Actual: false
        Expected: true
        Operation details:
        lvm pvcreate -M 2 ''    00:00:00  (ERROR)
    
          WARNING: Failed to connect to lvmetad. Falling back to device scanning.
          Device  not found.
    
        detach_loopdev(): Execute: losetup --detach ''
        losetup: /dev/: detach failed: Inappropriate ioctl for device
        detach_loopdev(): Losetup failed with exit status 1
        detach_loopdev(): Failed to detach loop device.  Test NOT affected
        [  FAILED  ] My/SupportedFileSystemsTest.Create/lvm2pv, where GetParam() = 20 (64 ms)
        ...
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUsage/btrfs
        test_SupportedFileSystems.cc:387: Failure
        Failed
        create_loopdev(): Execute: losetup --find --show 'test_SupportedFileSystems.img'
        losetup: test_SupportedFileSystems.img: failed to set up loop device: No such file or directory
        create_loopdev(): Losetup failed with exit status 1
        create_loopdev(): Failed to create required loop device
        Error: Could not stat device  - No such file or directory.
        test_SupportedFileSystems.cc:446: Failure
        Value of: lp_device != NULL
          Actual: false
        Expected: true
        test_SupportedFileSystems.cc:503: Failure
        Value of: m_fs_object->create(m_partition, m_operation_detail)
          Actual: false
        Expected: true
        Operation details:
        mkfs.btrfs -L '' ''    00:00:00  (ERROR)
        btrfs-progs v4.9.1
        See http://btrfs.wiki.kernel.org for more information.
    
        ERROR: failed to check size for : No such file or directory
    
        detach_loopdev(): Execute: losetup --detach ''
        losetup: /dev/: detach failed: Inappropriate ioctl for device
        detach_loopdev(): Losetup failed with exit status 1
        detach_loopdev(): Failed to detach loop device.  Test NOT affected
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/btrfs, where GetParam() = 7 (11 ms)
    
    All the test_SupportedFileSystems unit tests which need a loop device
    are failing when running losetup like this:
        losetup: <IMAGE_NAME>: failed to setup loop device: No such file or directory
    
    losetup uses /dev/loop-control [1][2] which no longer exists in the
    Docker image.  However even after creating /dev/loop-control in the
    image, losetup continues to fail.  Also tried stracing losetup but that
    fails like this, presumably because it is not allowed inside the Docker
    image:
        $ strace losetup --find --show /tmp/disk.img
        strace: ptrace(PTRACE_TRACEME, ...): Operation not permitted
        +++ exited with 1 +++
    
    For now I have run out of ways to investigate and resolve this, so just
    exclude the 12 tests which required loop devices.  All the tests still
    execute when run locally outside the restricted GNOME GitLab CI Docker
    setup.
    
    Closes !59 - Fix GNOME GitLab CI test job failures because of missing
                 /dev entries

2020-03-08  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Create block special devices needed by test_BlockSpecial in GitLab CI jobs (!59)
    
    From 23-Feb-2020 onwards, GNOME GitLab Continuous Integration test jobs
    have been failing running unit tests which previously succeeded.  With
    some extra debugging added into test_BlockSpecial to print 'bname' and
    'bs' values in the failing tests, here are fragments from
    tests/test-suite.log for the the test_BlockSpecial failures in a test CI
    job:
    
        FAIL: test_BlockSpecial
        =======================
        ...
        [ RUN      ] BlockSpecialTest.NamedBlockSpecialObjectBlockDevice
        bname="/dev/sr0"
        bs=BlockSpecial{"/dev/sr0",0,0}
        test_BlockSpecial.cc:218: Failure
        Value of: bs.m_major > 0 || bs.m_minor > 0
          Actual: false
        Expected: true
        [  FAILED  ] BlockSpecialTest.NamedBlockSpecialObjectBlockDevice (0 ms)
        ...
        [ RUN      ] BlockSpecialTest.TwoNamedBlockSpecialObjectBlockDevices
        bname1="/dev/sr0"
        bname2="/dev/sda"
        bs1=BlockSpecial{"/dev/sr0",0,0}
        bs2=BlockSpecial{"/dev/sda",0,0}
        test_BlockSpecial.cc:250: Failure
        Value of: bs1.m_major != bs2.m_major || bs1.m_minor != bs2.m_minor
          Actual: false
        Expected: true
        [  FAILED  ] BlockSpecialTest.TwoNamedBlockSpecialObjectBlockDevices (1 ms)
    
    Contents of /proc/partitions inside the Docker image when this test CI
    job failed:
    
        $ cat /proc/partitions
        major minor  #blocks  name
          11        0    1048575 sr0
           8        0  573367448 sda
           8        1  573366407 sda1
    
    And the listing of /dev/:
    
        $ ls -l /dev/
        total 0
        lrwxrwxrwx 1 root root   11 Mar  3 09:00 core -> /proc/kcore
        lrwxrwxrwx 1 root root   13 Mar  3 09:00 fd -> /proc/self/fd
        crw-rw-rw- 1 root root 1, 7 Mar  3 09:00 full
        drwxrwxrwt 2 root root   40 Mar  3 09:00 mqueue
        crw-rw-rw- 1 root root 1, 3 Mar  3 09:00 null
        lrwxrwxrwx 1 root root    8 Mar  3 09:00 ptmx -> pts/ptmx
        drwxr-xr-x 2 root root    0 Mar  3 09:00 pts
        crw-rw-rw- 1 root root 1, 8 Mar  3 09:00 random
        drwxrwxrwt 2 root root   40 Mar  3 09:00 shm
        lrwxrwxrwx 1 root root   15 Mar  3 09:00 stderr -> /proc/self/fd/2
        lrwxrwxrwx 1 root root   15 Mar  3 09:00 stdin -> /proc/self/fd/0
        lrwxrwxrwx 1 root root   15 Mar  3 09:00 stdout -> /proc/self/fd/1
        crw-rw-rw- 1 root root 5, 0 Mar  3 09:00 tty
        crw-rw-rw- 1 root root 1, 9 Mar  3 09:00 urandom
        crw-rw-rw- 1 root root 1, 5 Mar  3 09:00 zero
    
    See how the test_BlockSpecial fixtures are getting major=0 and minor=0
    for the block special devices they are testing with.  This is happening
    because there aren't any entries in /dev for those disks and partitions
    listed in /proc/partitions.  Assume that Docker in GNOME GitLab has
    changed and that unneeded and unwanted devices in /dev are no longer
    being created inside images.
    
    In the test CI jobs execute new script, tests/makedev.sh, to create just
    the first two block special devices mentioned in /proc/partitions needed
    by test_BlockSpecial.
    
    Closes !59 - Fix GNOME GitLab CI test job failures because of missing
                 /dev entries

2020-01-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Delete old Fill txtview_device_info_buffer comment
    
    Seems to be referring to how Fill_Label_Device_Info() worked in the
    past, but from history before the beginning of the GIT repository.
    Remove out of date comment.

2020-02-29  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Reliably detect running gpartedbin using pidof (!54)
    
    Debian user reported a bug [1] that when they had PS_FORMAT environment
    variable set it prevented GParted running:
    
        # export PS_FORMAT='ruser,uid,pid,ppid,pri,ni,%cpu,%mem,vsz,rss,stat,tty,start,time,command'
        # gparted
        The process gpartedbin is already running.
        Only one gpartedbin process is permitted.
        # echo $?
        1
    
    Using ps column 'command' includes the command and all it's arguments,
    rather than just the command name as ps displays by default.  Thus the
    shell wrapper finds the grep command it's using when searching for the
    gpartedbin executable.
    
        # ps -e | grep gpartedbin
        root         0 26114 14777  19   0  0.0  0.0 112712   940 S+   pts/0    10:42:02 00:00:00 grep --color=auto gpartedbin
    
    Fix by searching for running processes using pidof.  pgrep does regular
    expression matching where as pidof checks program name is the same [2].
    Therefore use of pidof is preferred over pgrep [3].
    
    [1] Debian bug #864932 - gparted fails if PS_FORMAT options are
                             specified
        https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=864932
    
    [2] Difference between pidof and pgrep?
        https://stackoverflow.com/questions/52151698/difference-between-pidof-and-pgrep
    
    [3] [PATCH] gparted.in: Use reliable way of detecting gpartedbin process
        existence
        https://git.alpinelinux.org/aports/tree/community/gparted/gparted.in-Use-reliable-way-of-detecting-gpartedbin-.patch
    
    Closes !54 - Fix gparted not launching when PS_FORMAT environment
                 variable set

2020-02-16  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename local variables to mke2fs_*_ver
    
    To better reflect that they represent the version of mke2fs executable
    from the e2fsprogs package, even though the executable is called as
    mkfs.ext4.
    
        $ ls -il /sbin/mke2fs /sbin/mkfs.ext*
        1978670 -rwxr-xr-x. 4 root root 96384 Aug  9  2019 /sbin/mke2fs
        1978670 -rwxr-xr-x. 4 root root 96384 Aug  9  2019 /sbin/mkfs.ext2
        1978670 -rwxr-xr-x. 4 root root 96384 Aug  9  2019 /sbin/mkfs.ext3
        1978670 -rwxr-xr-x. 4 root root 96384 Aug  9  2019 /sbin/mkfs.ext4
        $ mkfs.ext4 -V
        mke2fs 1.42.9 (28-Dec-2013)
                Using EXT2FS Library version 1.42.9
        $ mke2fs -V
        mke2fs 1.42.9 (28-Dec-2013)
                Using EXT2FS Library version 1.42.9

2020-02-14  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Simplify sscanf("mke2fs ...") text match
    
    With removal of support for RHEL / CentOS 5 and it's e4fsprogs package
    [1][2] it is no longer necessary to accept:
        mke4fs 1.41.12 (17-May-2010)
    only:
        mke2fs 1.42.9 (28-Dec-2013)
    
    [1] 6c4ab5dc28a14f3bef2d1c1a24da219381d513f0
        Remove checks for e4fsprogs commands (#794253)
    
    [2] de6e70d933286f3c65187470c9852fb6d8a60a7d
        Simplify ext2::get_filesystem_support() with regard ext4 support (#794253)

2020-02-16  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Raise minimum supported dosfstools to 3.0.18 (!57)
    
    This earlier commit [1] from 2013 recognised the new names for programs
    in dosfstools >= 3.0.18, specifically mkfs.fat and fsck.fat.  Now that
    the oldest supported distributions use dosfstools >= 3.0.18 it is no
    longer necessary to support using the old names of mkdosfs and dosfsck,
    so remove that code.
    
        Oldest supported   Dosfstools
        distributions      Version
    
        Debian 8           3.0.27
        RHEL / CentOS 7    3.0.20
        SLES 12            3.0.26
        Ubuntu 14.04 LTS   3.0.26
    
    [1] 1ae03dee953f512c0c664369db2d5e5db80b4058
        Recognise new dosfstools program names (#704629)
    
    Closes !57 - Raise minimum support dosfstools to 3.0.18 released
                 2013-06-06

2020-02-04  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove unused udevinfo from README
    
    Missed removing mention of udevinfo from README when this earlier commit
    removed it's use by GParted.
        3f15a66291af1f2db142edfe2a9219da219a29d5
        Drop use of long ago removed udevinfo

2020-02-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Wait for udev change on /dev/DISK when erasing signatures (#83)
    
    A user reported that formatting a whole disk device with a file system
    failed like this:
    
        Format /dev/sdd as ext4                                    (ERROR)
        + calibrate /dev/sdd                                       (SUCCESS)
            path: /dev/sdd (device)
            start: 0
            end: 15633407
            size: 15633408 (7.45 GiB)
        + clear old file system signatures in /dev/sdd             (SUCCESS)
          + write 512.00 KiB of zeros at byte offset 0             (SUCCESS)
          + write 4.00 KiB of zeros at byte offset 67108864        (SUCCESS)
          + write 512.00 KiB of zeros at byte offset 8003780608    (SUCCESS)
          + write 4.00 KiB of zeros at byte offset 8004239360      (SUCCESS)
          + write 8.00 KiB of zeros at byte offset 8004296704      (SUCCESS)
          + flush operating system cache of /dev/sdd               (SUCCESS)
        + create new ext4 file system                              (ERROR)
          + mkfs.ext4 -F -O ^64bit -L '' '/dev/sdd'                (ERROR)
            mke2fs 1.44.1 (24-Mar-2018)
            /dev/sdd is apparently in use by the system; will not make a filesystem here!
    
    Opening the whole disk block device exclusively causes mkfs.ext4 to
    report that error like this:
    
        # python
        >>> import os
        >>> f = os.open('/dev/sdb',os.O_RDONLY|os.O_EXCL)
        >>> ^Z
        [1]+  Stopped                 python
        # mkfs.ext4 -F -O ^64bit -L '' '/dev/sdb'
        mke2fs 1.42.9 (28-Dec-2013)
        /dev/sdb is apparently in use by the system; will not make a filesystem here!
        # echo $?
        1
    
    I have not been able to reproduce this error, but with debugging and
    sleeping in GParted, stracing GParted and using 'udevadm monitor' to
    watch udev events the following sequence of events is seen:
    
      gparted    |format(partition, operationdetail)
      gparted    |  erase_filesystem_signatures(partition, operationdetail)
      gparted    |    get_device(device_path="/dev/sdb", lp_device, flush=false)
      gparted    |      ped_device_get("/dev/sdb")
      libparted  |        open("/dev/sdb", O_RDONLY) = 11
      libparted  |        close(11)
      gparted    |    ped_device_open(lp_device)
      libparted  |      open("/dev/sdb", O_RDWR) = 11
      gparted    |    ped_device_sync(lp_device)
      libparted  |      ioctl(11, BLKFLSBUF)
      gparted    |    ped_device_close()
      libparted  |      close(11)
      udev(async)|        KERNEL change /devices/.../sdb (block)
      udev(async)|        UDEV   change /devices/.../sdb (block)
      gparted    |  set_partition_type(partition, operationdetail)
      gparted    |  create_filesystem(partition, operationdetail)
      gparted    |    ext2::create(partition, operationdetail)
      gparted    |      FileSystem::execute_command("mkfs.ext4 -F -O ^64bit -L '' '/dev/sdb')
    
    So it is assumed that the processing of the udev change rule after
    closing the block device in erase_filesystem_signatures() overlaps with
    the execution mkfs.ext4 and causes the seen error.  Fix by waiting for
    those udev events to complete as was previously done by commits [1][2]
    [3].
    
    Also note that this is specific to creating file systems on and
    formatting unpartitioned whole disk devices because set_partition_type()
    is a no-operation.  Where as on a partitioned device
    set_partition_type() calls commit() which already waits for udev rules
    to complete [3].
    
    [1] 50c8924a8e4d9cc96a2ea45f13291114402affee
        Wait for udev to recreate /dev/PTN entries when querying partition
        FSs (!46)
    [2] 4f6c312e3bc68cafb5e6035fd4a5b5bbbfcea992
        Wait for udev change on /dev/DISK when querying whole device FS
        (!46)
    [3] 2f53876c0fc8bceddabe739c298e19e7939d9ad7
        Wait for the kernel and udev to settle partitions for a second time
        (#790418)
    
    Closes #83 - /dev/sdd is apparently in use by the system; will not make
                 a filesystem here!

2020-02-25  Daniele Forsi <dforsi@gmail.com>

    Fix formatting directive in it.po (!58)
    
    Fixes:
        (gpartedbin:78003): glibmm-WARNING **: 22:55:05.465: invalid
        substitution "%s" in fmt string "percorso: %1 (%s)"
    
    Closes !58 - Fix formatting directive in it.po (!58)

2020-02-26  Nathan Follens <nfollens@gnome.org>

    Update Dutch translation

2020-02-23  Daniel Korostil <ted.korostiled@gmail.com>

    Update Ukrainian translation

2020-02-04  Daniel Mustieles <daniel.mustieles@gmail.com>

    Updated Spanish translation

2020-01-29  Dušan Kazik <prescott66@gmail.com>

    Update Slovak translation

2020-01-20  Curtis Gedak <gedakc@gmail.com>

    Append -git to version for continuing development
    
    Also fix minor whitespace mistake in NEWS

2020-01-20  Curtis Gedak <gedakc@gmail.com>

    ==========   gparted-1.1.0   ==========

2020-01-20  Curtis Gedak <gedakc@gmail.com>

    Update copyright years

2020-01-19  A S Alam <amanpreet.alam@gmail.com>

    Update Punjabi translation

2020-01-15  Rūdolfs Mazurs <rudolfs.mazurs@gmail.com>

    Update Latvian translation

2020-01-14  Kukuh Syafaat <kukuhsyafaat@gnome.org>

    Update Indonesian translation

2020-01-12  Bruce Cowan <bruce@bcowan.me.uk>

    Update British English translation

2020-01-12  Wolfgang Stöggl <c72578@yahoo.de>

    Update German translation

2020-01-11  Claude Paroz <claude@2xlibre.net>

    Updated French translation

2020-01-11  Trần Ngọc Quân <vnwildman@gmail.com>

    Updated Vietnamese translation
    
    Signed-off-by: Trần Ngọc Quân <vnwildman@gmail.com>

2020-01-10  Sveinn í Felli <sv1@fellsnet.is>

    Update Icelandic translation

2019-12-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Save all files on CI job failure for investigation
    
    Since patchset !49 "Add file system interface tests" was merged the
    GitLab Continuous Integration jobs have sometimes failed executing
    test_SupportedFilesystems.  So on failure save all files from the docker
    image for 1 week for investigation.
    
    Documentation:
    * Introduction to job artifacts
      https://gitlab.gnome.org/help/user/project/pipelines/job_artifacts.md
    
    * GitLab CI/CD Pipeline Configuration Reference, artifacts
      https://gitlab.gnome.org/help/ci/yaml/README.md#artifacts

2019-12-02  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename TreeView_Detail::treeview_filesystems_Columns member to fsname (!52)
    
    Closes !52 - Rename members and variables currently named 'filesystem'

2019-12-02  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename DialogFeatures::treeview_filesystems_Columns member to fsname (!52)
    
    Name the structure member to 'fsname' used to store strings like "ext2"
    etc.  This is equivalent to what was previously done in this commit:
        a9f08ddc7dd615b0ce4eb62098439514605fc998
        Rename local variable to fsname in get_filesystem() (#741430)
    
    Closes !52 - Rename members and variables currently named 'filesystem'

2019-06-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename create_format_menu_add_item() parameter of type FSType (!52)
    
    Closes !52 - Rename members and variables currently named 'filesystem'

2019-06-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename set_device_partitions() local variable of type FSType (!52)
    
    Closes !52 - Rename members and variables currently named 'filesystem'

2019-06-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename Utils method parameters of type FSType (!52)
    
    Closes !52 - Rename members and variables currently named 'filesystem'

2019-06-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Also rename FS.filesystem member to fstype (!52)
    
    Closes !52 - Rename members and variables currently named 'filesystem'

2019-06-12  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename Partition.filesystem member to fstype (!52)
    
    Previously made this change:
        175d27c55d44b87ec873a0b09847e8022011d51f
        Rename enum FILESYSTEM to FSType
    
    Now complete the renaming exercise of members and variables currently
    named 'filesystem'.
    
    Closes !52 - Rename members and variables currently named 'filesystem'

2019-11-25  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Stop requesting partition paths of free space and metadata
    
    In GParted_Core::set_device_partitions() the partition path is being
    queried from libparted.  However this is done before the switch
    statement on the type of the partition, so is called for all libparted
    partition objects including PED_PARTITION_FREESPACE and
    PED_PARTITION_METADATA ones.  As libparted numbers these partition
    objects as -1, it returns paths like "/dev/sda-1".
    
    Additionally when using GParted, with it's default DMRaid handling, on a
    dmraid started array this results in paths like
    "/dev/mapper/isw_ecccdhhiga_MyArray-1" being passed to
    is_dmraid_device() and make_path_dmraid_compatible().  Fortunately
    make_path_dmraid_compatible() does nothing and returns the same name.
    Call chain looks like:
    
        GParted_Core::set_device_partitions()
          get_partition_path(lp_partition)
            // where:
            // lp_partition->disk->dev->path = "/dev/mapper/isw_ecccdhhiga_MyArray"
            // lp_partition->type == PED_PARTITION_FREESPACE |
            //                       PED_PARTITION_METADATA
            //              ->num == -1
            ped_partition_get_path(lp_partition)
              return "/dev/mapper/isw_ecccdhhiga_MyArray-1"
            dmraid.is_dmraid_supported()
            dmraid.is_dmraid_device("/dev/mapper/isw_ecccdhhiga_MyArray-1")
              return true
            dmraid.make_path_dmraid_compatible("/dev/mapper/isw_ecccdhhiga_MyArray-1")
              return "/dev/mapper/isw_ecccdhhiga_MyArray-1"
    
    Fix by moving the get_partition_path() call inside the switch statement
    so that it is only called for PED_PARTITION_NORMAL,
    PED_PARTITION_LOGICAL and PED_PARTITION_EXTENDED partition types.
    
    Relevant commits:
    *   53c49349f71693873805e87856b4c56f2860e6d8
        Simplify logic in set_device_partitions method
    
    *   81986c0990eef65593ef23397074cf61cdca415f
        Ensure partition path name is compatible with dmraid (#622217)

2019-11-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Make 4 internally used only DMRaid methods private

2019-11-20  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Recognise ATARAID members started by dmraid (#75)
    
    This is not strictly necessary as members are already recognised using
    blkid since this commit earlier in the sequence "Recognise ATARAID
    members (#75)".  However it makes sure active members are recognised
    even if blkid is not available and matches how file system detection
    queries the SWRaid_Info module.
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-20  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Display array device as mount point of dmraid started ATARAID members (#75)
    
    This matches how the array device is displayed as the mount point for
    mdadm started ATARAID members by "Display array device as mount point of
    mdadm started ATARAID members (#75)" earlier in this patchset.
    
    Extend the DMRaid module member cache to save the array device name and
    use as needed to display as the mount point.
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Detect busy status of dmraid started ATARAID members (#75)
    
    Again this is to stop GParted allowing overwrite operations being
    performed on an ATARAID member while the array is actively using the
    member.  This time for dmraid started arrays using the kernel DM (Device
    Mapper) driver.
    
    The DMRaid module already uses dmraid to report active array names:
    
        # dmraid -sa -c
        isw_ecccdhhiga_MyArray
    
    To find active members in this array, (1) use udev to lookup the kernel
    device name:
    
        # udevadm info --query=name /dev/mapper/isw_ecccdhhiga_MyArray
        dm-0
    
    (2) list the member names exposed by the kernel DM driver through the
    /sys file system.
    
        # ls /sys/block/dm-0/slaves
        sdc  sdd
        # ls -l /sys/block/dm-0/slaves
        lrwxrwxrwx 1 root root 0 Nov 24 09:52 sdc -> ../../../../pci0000:00/0000:00:0d.0/ata3/host2/target2:0:0/2:0:0:0/block/sdc
        lrwxrwxrwx 1 root root 0 Nov 24 09:52 sdc -> ../../../../pci0000:00/0000:00:0d.0/ata4/host3/target3:0:0/3:0:0:0/block/sdd
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-21  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Enable basic supported actions for ATARAID members (#75)
    
    When an ATARAID member is inactive allow basic supported actions of
    copy and move to be performed like with other recognised but only basic
    supported types.
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Prevent unmount of busy ATARAID members (#75)
    
    Since earlier commit "Display array device as mount point of mdadm
    started ATARAID members (#75)" GParted allows attempting to unmout a
    busy ATARAID member as if it was a file system.  This is not a valid
    thing to do, so disallow it.
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-17  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Display array uuid of mdadm recognised ATARAID members (#75)
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-17  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Display array device as mount point of mdadm started ATARAID members (#75)
    
    This matches how other non-file systems are handled, by displaying the
    access reference in the mount point column.  For LVM Physical Volumes
    the Volume Group name is displayed [1] and for an active Linux Software
    RAID array the array device is displayed [2].
    
    [1] 8083f11d84dbd4f186271a3cdbf5170db259f8b8
        Display LVM2 VGNAME as the PV's mount point (#160787)
    
    [2] f6c2f00df7858a7f4b97e699b9bcf1023bba850a
        Populate member mount point with SWRaid array device (#756829)
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-17  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Detect busy status of mdadm started ATARAID members (#75)
    
    This stops GParted allowing overwrite operations (such as create
    partition table or format with a whole device file system) being
    performed on an ATARAID member while the array is actively using the
    member.
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-17  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Display correct type of mdadm recognised ATARAID members (#75)
    
    The previous commit, made mdadm recognised IMSM and DDF type ATARAID
    members get displayed as "linux-raid" (Linux Software RAID array
    member).  This was because of query method 1 in detect_filesystems().
    
    Fix this now by exposing and using the fstype of the member from the
    SWRaid_Info cache.
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-17  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Parse ATARAID members from mdadm output and /proc/mdstat (#75)
    
    Since mdadm release 3.0 (2009-06-02) [1] it has also supported external
    metadata formats IMSM (Intel Matrix Storage Manager) and DDF, previously
    only managed by dmraid.
    
    A number of distributions have switched to use mdadm and kernel MD
    (Multiple Devices) driver for managing these Firmware / BIOS / ATARAID
    arrays.  These include: Fedora >= 14 [2], RHEL / CentOS >= 6 [3],
    SLES >= 12 [4], Ubuntu >= 16.04 LTS.
    
    Therefore additionally parse members in these ATARAID arrays included in
    mdadm output, and when activated using the kernel MD driver, in file
    /proc/mdstat.  Add fstype to the SWRaid_Info cache records to
    distinguish members apart.  So far the rest of the GParted code
    continues to treat all members as FS_LINUX_SWRAID.  This will be
    resolved in following commits.
    
    Note that this in no way affects how GParted shows and partitions the
    array device itself, even those managed by dmraid and use the GParted
    DMRaid module.  It only affects how GParted shows the member drives
    themselves.
    
    [1] mdadm ANNOUNCE-3.0 file
        https://git.kernel.org/pub/scm/utils/mdadm/mdadm.git/tree/ANNOUNCE-3.0?h=mdadm-3.0
    
    [2] Fedora 14, Storage Administration Guide, 12.5. Linux RAID Subsystem
        https://docs.fedoraproject.org/en-US/Fedora/14/html/Storage_Administration_Guide/raid-subsys.html
        "...  Fedora 14 uses mdraid with external metadata to access ISW /
        IMSM (Intel firmware RAID) sets.  mdraid sets are configured and
        controlled through the mdadm utility."
    
    [3] RHEL 6, Storage Administration Guide, 17.3. Linux RAID Subsystem
        https://access.redhat.com/documentation/en-us/red_hat_enterprise_linux/6/html/storage_administration_guide/raid-subsys
        "mdraid also supports other metadata formats, known as external
        metadata.  Red Hat Enterprise Linux 6 uses mdraid with external
        metadata to access ISW / IMSM (Intel firmware RAID) sets.  mdraid
        sets are configured and controlled through the mdadm utility."
    
    [4] SUSE Linux Enterprise Server 12 Release Notes, 7.2.3 Driver for IMSM
        and DDF
        https://www.suse.com/releasenotes/x86_64/SUSE-SLES/12/#fate-316007
        "For IMSM and DDF RAIDs the mdadm driver is used unconditionally."
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-11-02  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Recognise ATARAID members (#75)
    
    PATCHSET OVERVIEW
    
    A user had a Firmware / BIOS / ATARAID array of 2 devices configured as
    a RAID 0 (stripe) set.  On top of that was a GPT with the OS partitions.
    GParted displays the following errors on initial load and subsequent
    refresh:
    
            Libparted Error
        (-) Invalid argument during seek for read on /dev/sda
                              [ Retry ] [ Cancel ] [ Ignore ]
    
            Libparted Error
        (-) The backup GPT table is corrupt, but the
            primary appears OK, so that will be used.
                                  [  Ok  ] [ Cancel ]
    
    This is an Intel Software RAID array which stores metadata at the end of
    each member device, and so the first 128 KiB stripe of the set is stored
    in the first 128 KiB of the first member device /dev/sda which includes
    the GPT for the whole RAID 0 device.  Hence when libparted reads member
    device /dev/sda it finds a GPT describing a block device twice it's
    size and in results the above errors when trying to read the backup GPT.
    
    A more dangerous scenario occurs when using 2 devices configured in an
    Intel Software RAID 1 (mirrored) set with GPT on top.  On refresh
    GParted display this error for both members, /dev/sda and /dev/sdb:
    
            Libparted Warning
        /!\ Not all of the space available to /dev/sda appears to be used,
            you can fix the GPT to use all of the space (an extra 9554
            blocks) or continue with the current setting?
                                                      [  Fix  ] [ Ignore ]
    
    Selecting [Fix] gets libparted to re-write the backup GPT to the end of
    the member device, overwriting the ISW metadata!  Do that twice and both
    copies of the metadata are gone!
    
    Worked example of this more dangerous mirrored set case.  Initial setup:
    
        # dmraid -s
        *** Group superset isw_caffbiaegi
        --> Subset
        name   : isw_caffbiaegi_MyMirror
        size   : 16768000
        stride : 128
        type   : mirror
        status : ok
        subsets: 0
        devs   : 2
        spares : 0
    
        # dmraid -r
        /dev/sda: isw, "isw_caffbiaegi", GROUP, ok, 16777214 sectors, data@ 0
        /dev/sdb: isw, "isw_caffbiaegi", GROUP, ok, 16777214 sectors, data@ 0
    
        # wipefs /dev/sda
        offset               type
        ---------------------------------------------
        0x200                gpt   [partition table]
        0x1fffffc00          isw_raid_member   [raid]
    
    Run GParted and click [Fix] on /dev/sda.  Now the first member has gone:
    
        # dmraid -s
        *** Group superset isw_caffbiaegi
        --> *Inconsistent* Subset
        name   : isw_caffbiaegi_MyMirror
        size   : 16768000
        stride : 128
        type   : mirror
        status : inconsistent
        subsets: 0
        devs   : 1
        spares : 0
    
        # dmraid -r
        /dev/sdb: isw, "isw_caffbiaegi", GROUP, ok, 16777214 sectors, data@ 0
    
        # wipefs /dev/sda
        offset               type
        ---------------------------------------------
        0x200                gpt   [partition table]
    
    Click [Fix] on /dev/sdb.  Now all members of the array are gone:
    
        # dmraid -s
        no raid disks
    
        # dmraid -r
        no raid disks
    
        # wipefs /dev/sdb
        offset               type
        ---------------------------------------------
        0x200                gpt   [partition table]
    
    So GParted must not run libparted partition table scanning on the member
    devices in ATARAID arrays.  Only on the array device itself.
    
    In terms of the UI GParted must show disks which are ATARAID members as
    whole disk devices with ATARAID member content and detect array busy
    status to avoid allowing active members from being overwritten while in
    use.
    
    THIS COMMIT
    
    Recognise ATARAID member devices and display in GParted as whole device
    "ataraid" file systems.  Because they are recognised as whole device
    content ("ataraid" file systems) this alone stops GParted running the
    libparted partition table scanning and avoids the above errors.
    
    The list of dmraid supported formats is matched by the signatures
    recognised by blkid:
    
        $ dmraid -l
        asr     : Adaptec HostRAID ASR (0,1,10)
        ddf1    : SNIA DDF1 (0,1,4,5,linear)
        hpt37x  : Highpoint HPT37X (S,0,1,10,01)
        hpt45x  : Highpoint HPT45X (S,0,1,10)
        isw     : Intel Software RAID (0,1,5,01)
        jmicron : JMicron ATARAID (S,0,1)
        lsi     : LSI Logic MegaRAID (0,1,10)
        nvidia  : NVidia RAID (S,0,1,10,5)
        pdc     : Promise FastTrack (S,0,1,10)
        sil     : Silicon Image(tm) Medley(tm) (0,1,10)
        via     : VIA Software RAID (S,0,1,10)
        dos     : DOS partitions on SW RAIDs
    
        $ fgrep -h _raid_member util-linux/libblkid/src/superblocks/*.c
                .name           = "adaptec_raid_member",
                .name           = "ddf_raid_member",
                .name           = "hpt45x_raid_member",
                .name           = "hpt37x_raid_member",
                .name           = "isw_raid_member",
                .name           = "jmicron_raid_member",
                .name           = "linux_raid_member",
                .name           = "lsi_mega_raid_member",
                .name           = "nvidia_raid_member",
                .name           = "promise_fasttrack_raid_member",
                .name           = "silicon_medley_raid_member",
                .name           = "via_raid_member",
    
    As they are all types of Firmware / BIOS / ATARAID arrays, report all
    members as a single "ataraid" file system type.  (Except for
    "linux_raid_member" in the above blkid source listing which is Linux
    Software RAID).
    
    Closes #75 - Errors with GPT on RAID 0 ATARAID array

2019-12-01  Andre Klapper <a9016009@gmx.de>

    Fix an incorrect translation in the Spanish user help
    
    See #80

2019-12-01  Andre Klapper <a9016009@gmx.de>

    Fix typo in Spanish translation of user help
    
    Fixes #80

2019-11-28  Daniel Mustieles <daniel.mustieles@gmail.com>

    Updated Spanish translation

2019-11-09  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add missing includes into jfs.cc

2019-11-08  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove unallocated space comment from HACKING file (!50)
    
    The HACKING file should be hints for making changes to the code base and
    associated processes.  A overview of how GParted handled unallocated
    space was not that.  Also now the size of a JFS is accurately calculated
    using JFS as an example of a file system with intrinsic unallocated
    space is no longer valid.  Therefore removed from the HACKING file.
    Instead add the original commit message as an extended comment to method
    calc_significant_unallocated_sectors().
    
    Closes !50 - Calculate JFS size accurately

2019-11-08  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Calculate mounted JFS size accurately (!50)
    
    With the same minimum sized 16 MiB JFS used in the previous commit, now
    mounted, GParted once again reports 1.20 MiB of unallocated space.  This
    is because the kernel JFS driver is also just reporting the size of the
    Aggregate Disk Map (dmap) as the size of the file system [1].
    
    Fix by reading the on disk JFS superblock to calculate the size of the
    file system, but query the free space from the kernel using statvfs().
    Need to query mounted JFS free space from the kernel because the on disk
    dmap is not updated immediately so doesn't reflect recently used or
    freed disk space.
    
    For example, start with the 16 MiB JFS empty and mounted.
    
        # echo -e 'dmap\nx\nquit' | jfs_debugfs /dev/sdb1 | fgrep dn_nfree
        [2] dn_nfree:           0x00000000eaa   [10] dn_agwidth:        1
        # df -k /mnt/1
        Filesystem     1K-blocks  Used Available Use% Mounted on
        /dev/sdb1          15152   136     15016   1% /mnt/1
    
    Write 10 MiB of data to it:
    
        # dd if=/dev/zero bs=1M count=10 of=/mnt/1/file_10M
        10+0 records in
        10+0 records out
        1048760 bytes (10 MB, 10 MiB) copied, 0.0415676 s, 252 MB/s
    
    Query the file system free space from the kernel and by reading the on
    disk dmap figure:
    
        # df -k /mnt/1
        Filesystem     1K-blocks  Used Available Use% Mounted on
        /dev/sdb1          15152 10376      4776  69% /mnt/1
        # echo -e 'dmap\nx\nquit' | jfs_debugfs /dev/sdb1 | fgrep dn_nfree
        [2] dn_nfree:           0x00000000eaa   [10] dn_agwidth:        1
    
        # sync
        # echo -e 'dmap\nx\nquit' | jfs_debugfs /dev/sdb1 | fgrep dn_nfree
        [2] dn_nfree:           0x00000000eaa   [10] dn_agwidth:        1
    
        # umount /mnt/1
        # echo -e 'dmap\nx\nquit' | jfs_debugfs /dev/sdb1 | fgrep dn_nfree
        [2] dn_nfree:           0x000000004aa   [10] dn_agwidth:        1
    
    The kernel reports the updated usage straight away, but the on disk dmap
    record doesn't get updated even by sync, only after unmounting.
    
    This is the same fix as was previously done for EXT2/3/4 [2].
    
    [1] Linux jfs_statfs() function
        https://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux.git/tree/fs/jfs/super.c?h=v3.10#n142
    
    [2] 3828019030f981cc5b3411badc40704f5525fdb3
        Read file system size for mounted ext2/3/4 from superblock (#683255)
    
    Closes !50 - Calculate JFS size accurately

2019-11-05  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Calculate unmounted JFS size accurately (!50)
    
    Create the smallest possible JFS (16 MiB) and GParted will report
    1.2 MiB of unallocated space.  This is because the size of the Aggregate
    Disk Map (dmap) was used as the size of the file system.  However after
    reading the source code to mkfs.jfs, it separately accounts for the size
    of the Log (Journal) and the FSCK Working Space.  The size of a JFS is
    the sum of these 3 components added together.
    
    Using the minimum 16 MiB JFS as an example:
    
        # jfs_debugfs /dev/sdb1
        jfs_debugfs version 1.1.15, 04-Mar-2011
    
        Aggregate Block Size: 4096
    
        > superblock
        [1] s_magic:            'JFS1'          [15] s_ait2.addr1:      0x00
        [2] s_version:          1               [16] s_ait2.addr2:      0x00000018
        [3] s_size:     0x0000000000007660           s_ait2.address:    24
        [4] s_bsize:            4096            [17] s_logdev:          0x00000000
        [5] s_l2bsize:          12              [18] s_logserial:       0x00000000
        [6] s_l2bfactor:        3               [19] s_logpxd.len:      256
        [7] s_pbsize:           512             [20] s_logpxd.addr1:    0x00
        [8] s_l2pbsize:         9               [21] s_logpxd.addr2:    0x00000f00
        [9] pad:                Not Displayed        s_logpxd.address:  3840
        [10] s_agsize:          0x00002000      [22] s_fsckpxd.len:     52
        [11] s_flag:            0x10200900      [23] s_fsckpxd.addr1:   0x00
                                JFS_LINUX       [24] s_fsckpxd.addr2:   0x00000ecc
                JFS_COMMIT      JFS_GROUPCOMMIT      s_fsckpxd.address: 3788
                                JFS_INLINELOG   [25] s_time.tv_sec:     0x5dbbdfa0
                                                [26] s_time.tv_nsec:    0x00000000
                                                [27] s_fpack:           'small_jfs'
        [12] s_state:           0x00000000
                     FM_CLEAN
        [13] s_compress:        0
        [14] s_ait2.len:        4
    
        display_super: [m]odify or e[x]it: x
        > dmap
    
        Block allocation map control page at block 16
    
        [1] dn_mapsize:         0x00000000ecc   [9] dn_agheigth:        0
        [2] dn_nfree:           0x00000000eaa   [10] dn_agwidth:        1
        [3] dn_l2nbperpage:     0               [11] dn_agstart:        341
        [4] dn_numag:           1               [12] dn_agl2size:       13
        [5] dn_maxlevel:        0               [13] dn_agfree:         type 'f'
        [6] dn_maxag:           0               [14] dn_agsize:         8192
        [7] dn_agpref:          0               [15] pad:               Not Displayed
        [8] dn_aglevel:         0
        display_dbmap: [m]odify, [f]ree count, [t]ree, e[x]it > x
        > quit
    
    Values of interest:
        s_size        - Aggregate size in device (s_pbsize) blocks
        s_bsize       - Aggregate block (aka file system allocation) size in
                        bytes
        s_pbsize      - Physical (device) block size in bytes
        s_logpxd.len  - Log (Journal) size in Aggregate (s_bsize) blocks
        s_fsckpxd.len - FSCK Working Space in Aggregate (s_bsize) blocks
        dn_nfree      - Number of free (s_bsize) blocks in Aggregate
    
    Calculation:
        file system size = s_size * s_pbsize
                         + s_logpxd.len * s_bsize
                         + s_fsckpxd.len * s_bsize
                         = 30304 * 512
                         + 256 * 4096
                         + 52 * 4096
                         =  16777216
                            (Exactly 16 MiB.  The size of the partition.)
        free space = dn_nfree * s_bsize
                   = 3754 * 4096
                   = 15376384
    
    Rewrite JFS usage querying code to use this updated calculation.
    
    [1] JFS Overview / How the Journaled File System cuts system restart
        times to the quick
        http://jfs.sourceforge.net/project/pub/jfs.pdf
    [2] JFS Layout / How the Journaled File systems handles the on-disk
        layout
        http://jfs.sourceforge.net/project/pub/jfslayout.pdf
    [3] mkfs.jfs source code
        http://jfs.sourceforge.net/project/pub/jfsutils-1.1.15.tar.gz
        mkfs/mkfs.c
        Selected lines from mkfs/mkfs.c
            create_aggregate(..., number_of_blocks, ..., logsize, ...)
                number_of_blocks -= fsck_wspace_length;
                aggr_superblock.s_size = number_of_blocks * (aggr_block_size / phys_block_size);
                aggr_superblock.s_bsize = aggr_block_size;
                aggr_superblock.s_pbsize = phys_block_size;
                PXDlength(&aggr_superblock.s_logpxd, logsize);
                PXDlength(&aggr_superblock.s_fsckpxd, fsck_wspace_length);
            main()
                number_of_bytes = bytes_on_device;
                number_of_blocks = number_of_bytes / agg_block_size;
                logsize = logsize_in_bytes / aggr_block_size;
                number_of_blocks -= logsize;
                create_aggregate(..., number_of_blocks, ..., logsize, ...);
    
    Closes !50 - Calculate JFS size accurately

2019-11-04  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Update name of the NILFS2 specific package
    
    Upstream NILFS project calls the package nilfs-utils [1][2].  Arch Linux
    / CentOS / Fedora / OpenSUSE use the upstream name.  However Debian /
    Ubuntu name it nilfs-tools [3] instead.
    
    Document the needed software as:
    
        nilfs-utils / nilfs-tools
    
    Upstream name first separated by slash from alternative names
    distributions use.
    
    [1] NILFS Download page
        https://nilfs.sourceforge.io/en/download.html
    [2] NILFS Public Git Repositories
        https://nilfs.sourceforge.io/en/git_repos.html
    [3] Debian package: nilfs-tools
        https://packages.debian.org/sid/nilfs-tools

2019-10-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add missing libuuid-devel build dependency for Fedora into README

2019-10-27  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Avoid crash reading JFS usage on Fedora 30 (!49)(#794947)
    
    Running JFS read usage test on Fedora 30 fails like this:
    
        $ ./test_SupportedFileSystems --gtest_filter='*ReadUsage/jfs'
    ...
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUsage/jfs
        unknown file: Failure
        C++ exception with description "std::bad_alloc" thrown in the test body.
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/jfs, where GetParam() = 17 (41833 ms)
    
    However the same test passes on Fedora 29, Fedora 31 Beta, CentOS 7,
    Debian 10 and Ubuntu 18.04 LTS.
    
    Also running GParted on Fedora 30 crashes just the same when reading JFS
    usage:
    
        # gparted
        GParted 1.0.0
        configuration --enable-libparted-dmraid --enable-online-resize
        libparted 3.2
        terminate called after throwing an instance of 'std::bad_alloc'
          what():  std::bad_alloc
        /usr/bin/gparted: line 202: 19218 Aborted                 (core dumped) $BASE_CMD
    
    Running jfs_debugfs to query the file system usage the same way GParted
    does produces an infinite amount of repeating output:
    
        # echo dm | jfs_debugfs /dev/sdb1
    
    So jfs_debugfs gets stuck in an infinite loop inside the dmap subcommand
    when it encounters EOF.  GParted and the read JFS usage test read this
    output until memory is exhausted and crash.  This is exactly what was
    happening in closed bug 794947.  Even installed jfsutils from Fedora 29
    on Fedora 30 and visa versa.  jfs_debugfs still produced an infinite
    amount of output on Fedora 30 and worked correctly on Fedora 29.  So
    it's not the build of jfsutils, but something in the OS that is making
    the difference!
    
    Anyway fix by providing the instruction to exit from the dmap
    subcommand, and quit from jfs_debugfs itself, like this:
    
        # echo -e 'dmap\nx\nquit' | jfs_debugfs /dev/sdb1
    
    Bug 794947 - gparted hangs when sees JFS partition on discovering
                 partitions
    Closes !49 - Add file system interface tests

2019-10-20  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Accept FS usage figures within significant unallocated threshold (!49)
    
    So far the read file system usage figures, read via the file system
    interface classes using file system specific tools, have been checked to
    the exact sector for:
         0 <= used <= size
         0 <= unused <= size
         unallocated = 0
         used + unused = size
    
    However for JFS and NTFS this fails like this:
    
        # ./test_SupportedFileSystems --gtest_filter='*ReadUsage/*' | fgrep ' ms'
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/btrfs (335 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/exfat (0 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/ext2 (38 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/ext3 (131 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/ext4 (32 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/f2fs (47 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/fat16 (19 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/fat32 (48 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/hfs (0 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/hfsplus (0 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/jfs, where GetParam() = 17 (73 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/linuxswap (20 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/luks (0 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/lvm2pv (410 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/minix (0 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/nilfs2 (226 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/ntfs, where GetParam() = 23 (56 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/reiser4 (49 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/reiserfs (139 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/udf (34 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/xfs (67 ms)
        [----------] 21 tests from My/SupportedFileSystemsTest (1726 ms total)
        [==========] 21 tests from 1 test case ran. (1726 ms total)
    
        # ./test_SupportedFileSystems --gtest_filter='*ReadUsage/jfs:*ReadUsage/ntfs'
        Running main() from test_SupportedFileSystems.cc
        Note: Google Test filter = *ReadUsage/jfs:*ReadUsage/ntfs
        [==========] Running 2 tests from 1 test case.
        [----------] Global test environment set-up.
        [----------] 2 tests from My/SupportedFileSystemsTest
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUsage/jfs
        test_SupportedFileSystems.cc:465: Failure
        Expected equality of these values:
          m_partition.sectors_unallocated
            Which is: 2472
          0
        test_SupportedFileSystems.cc:517: Failure
        Expected equality of these values:
          m_partition.sectors_used + m_partition.sectors_unused
            Which is: 521816
          m_partition.get_sector_length()
            Which is: 524288
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/jfs, where GetParam() = 17 (36 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUsage/ntfs
        test_SupportedFileSystems.cc:465: Failure
        Expected equality of these values:
          m_partition.sectors_unallocated
            Which is: 8
          0
        test_SupportedFileSystems.cc:517: Failure
        Expected equality of these values:
          m_partition.sectors_used + m_partition.sectors_unused
            Which is: 524280
          m_partition.get_sector_length()
            Which is: 524288
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/ntfs, where GetParam() = 23 (35 ms)
        [----------] 2 tests from My/SupportedFileSystemsTest (71 ms total)
    
        [----------] Global test environment tear-down
        [==========] 2 tests from 1 test case ran. (72 ms total)
        [  PASSED  ] 0 tests.
        [  FAILED  ] 2 tests, listed below:
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/jfs, where GetParam() = 17
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/ntfs, where GetParam() = 23
    
         2 FAILED TESTS
    
    So JFS is reporting 2472 unallocated sectors in a size of 524288 sectors
    and NTFS is reporting 8 unallocated sectors in the same size.  This
    exact issue is already solved for GParted so that it doesn't show a
    small amount of unallocated space by commits [1][2] from Bug 499202 [3].
    
    Fix the same way, use the accessors to the file system usage figures
    which don't show unallocated space when it is below the significant
    threshold.
    
    [1] b5c80f18a9ce27fda2b11e9b590d7f856209ac32
        Enhance calculation of significant unallocated space (#499202)
    
    [2] 7ebedc4bb3b81e85fb4c628a2a05308ada147d68
        Don't show intrinsic unallocated space (#499202)
    
    [3] Bug 499202 - gparted does not see the difference if partition size
                     differs from filesystem size
        https://bugzilla.gnome.org/show_bug.cgi?id=499202
    
    Closes !49 - Add file system interface tests

2019-10-14  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Skip Check MINIX file system interface test (!49)
    
    Checking a MINIX V3 file system fails like this:
    
        $ ./test_SupportedFileSystems --gtest_filter='*Check/minix'
    ...
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndCheck/minix
        test_SupportedFileSystems.cc:554: Failure
        Value of: m_fs_object->check_repair(m_partition, m_operation_detail)
          Actual: false
        Expected: true
        Operation details:
        mkfs.minix -3 '/home/centos/programming/c/gparted/tests/test_SupportedFileSystems.img'    00:00:00  (SUCCESS)
        87392 inodes
        262144 blocks
        Firstdatazone=5507 (5507)
        Zonesize=1024
        Maxsize=2147483647
    
        fsck.minix '/home/centos/programming/c/gparted/tests/test_SupportedFileSystems.img'    00:00:00  (ERROR)
        fsck.minix from util-linux 2.23.2
        bad magic number in super-block
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndCheck/minix, where GetParam() = 21 (182 ms)
    
    fsck.minix doesn't support checking MINIX V3 file systems until this
    commit, first included in util-linux 2.27 released 2015-09-07.
    
        https://git.kernel.org/pub/scm/utils/util-linux/util-linux.git/commit/?id=86a9f3dad58addb50eca9daa9d233827a005dad7
        fsck.minix: add minix v3 support
    
    CentOS 7 only includes util-linux 2.23.2 so is affected by this, however
    Ubuntu 18.04 LTS includes util-linux 2.31.1 so is not affected.
    
    Just always skip this test for now.  Plan to re-enable later when the
    oldest supported distributions and GitLab CI images include the needed
    util-linux release.
    
    Closes !49 - Add file system interface tests

2019-09-03  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Write new UUID to JFS before testing reading UUID (!49)
    
    Testing reading the UUID from a newly created JFS was failing like this:
    
        $ ./test_SupportedFileSystems --gtest_filter='*ReadUUID/jfs'
    ...
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUUID/jfs
        test_SupportedFileSystems.cc:552: Failure
        Expected: (m_partition.uuid.size()) >= (9U), actual: 0 vs 9
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/jfs, where GetParam() = 17 (57 ms)
    
    Mkfs.jfs creates a file system as version 1.  It does have a UUID and
    blkid can report it, but jfs_tune doesn't report it.
    
        $ touch -s 256M test_jfs.img
        $ mkfs.jfs -q test_jfs.img
        mkfs.jfs version 1.1.15, 04-Mar-2011
    
        Format completed successfully.
    
        262144 kilobytes total disk space.
        $ blkid test_jfs.img
        test_jfs.img: UUID="6b0bb46a-a240-47b4-89ab-1fe759aa572d" TYPE="jfs"
    
        $ jfs_tune -l test_jfs.img | egrep 'version|UUID'
        jfs_tune version 1.1.15, 04-Mar-2011
        JFS version:                1
    
        $ hexdump -C test_jfs.img
        00000000  00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  |................|
        *
        00008000  4a 46 53 31 01 00 00 00  58 f6 07 00 00 00 00 00  |JFS1....X.......|
    Version >---------------- ^^ ^^ ^^ ^^
    ...
        00008080  00 00 00 00 00 00 00 00  6b 0b b4 6a a2 40 47 b4  |........k..j.@G.|
        00008090  89 ab 1f e7 59 aa 57 2d  00 00 00 00 00 00 00 00  |....Y.W-........|
    UUID >-------------------------------- ^^ ^^ ^^ ^^ ^^ ^^ ^^ ^^
                  ^^ ^^ ^^ ^^ ^^ ^^ ^^ ^^
    
    However writing a new UUID to the JFS also updates the version to 2 and
    allows jfs_tune to report the UUID.
    
        $ jfs_tune -U random test_jfs.img
        jfs_tune version 1.1.15, 04-Mar-2011
        UUID updated successfully.
    
        $ blkid test_jfs.img
        test_jfs.img: UUID="6374ec58-3568-4ffb-bea9-ff76bf5c192f" TYPE="jfs"
    
        $ jfs_tune -l test_jfs.img | egrep 'version|UUID'
        jfs_tune version 1.1.15, 04-Mar-2011
        JFS version:            2
        File system UUID:       6374ec58-3568-4ffb-bea9-ff76bf5c192f
        External log UUID:      00000000-0000-0000-0000-000000000000
    
        $ hexdump -C test_jfs.img
        00000000  00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  |................|
        *
        00008000  4a 46 53 31 02 00 00 00  58 f6 07 00 00 00 00 00  |JFS1....X.......|
    Version >---------------- ^^ ^^ ^^ ^^
    ...
        00008080  00 00 00 00 00 00 00 00  63 74 ec 58 35 68 4f fb  |........ct.X5hO.|
        00008090  be a9 ff 76 bf 5c 19 2f  00 00 00 00 00 00 00 00  |...v.\./........|
    New UUID >---------------------------- ^^ ^^ ^^ ^^ ^^ ^^ ^^ ^^
                  ^^ ^^ ^^ ^^ ^^ ^^ ^^ ^^
    
    Therefore change the CreateAndReadUUID test for JFS to also write a new
    UUID so that it also updates the version to 2, thus allowing jfs_tune to
    report the UUID and the test pass.
    
    Note that GParted doesn't encounter this problem because it used blkid
    by default to report the UUID and only falls back to using the file
    system interface method which calls jfs_tune when blkid is not
    available.
    
    Closes !49 - Add file system interface tests

2019-08-05  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Accept reading shorter UUIDs from FAT16/32 file systems (!49)
    
    The tests were failing like this:
    
        $ ./test_SupportedFileSystems --gtest_filter='*CreateAndReadUUID/fat16'
    ....
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUUID/fat16
        test_SupportedFileSystems.cc:552: Failure
        Expected equality of these values:
          m_partition.uuid.size()
            Which is: 9
          36U
            Which is: 36
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/fat16, where GetParam() = 13 (45 ms)
    
    This is because the test was expecting a full 36 character UUID as used
    by Linux file systems.  Also accept shorter 9 character "UUID"s as used
    by FAT16/32 file systems.
    
    Closes !49 - Add file system interface tests

2019-10-14  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Create loop devices for NILFS2 read and write FS interface tests (!49)
    
    For NILFS2 the read and write tests which use nilfs-tune all fail using
    an image file, even when run as root, however the other tests succeed.
    Selected output from the test program:
    
        # ./test_SupportedFileSystems --gtest_filter='*/nilfs2' | fgrep ' ms'
        [       OK ] My/SupportedFileSystemsTest.Create/nilfs2 (22 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/nilfs2, where GetParam() = 22 (31 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadLabel/nilfs2, where GetParam() = 22 (30 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/nilfs2, where GetParam() = 22 (30 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndWriteLabel/nilfs2, where GetParam() = 22 (37 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndWriteUUID/nilfs2, where GetParam() = 22 (39 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndCheck/nilfs2 (0 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndRemove/nilfs2 (0 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndGrow/nilfs2 (386 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndShrink/nilfs2 (345 ms)
        [----------] 10 tests from My/SupportedFileSystemsTest (920 ms total)
        [==========] 10 tests from 1 test case ran. (920 ms total)
    
    nilfs-tune fails like this when given an image file:
        # truncate -s 256M test.img
        # mkfs.nilfs2 test.img
        mkfs.nilfs2 (nilfs-utils 2.2.7)
        Start writing file system initial data to the device
               Blocksize:4096  Device:test.img  Device Size:268435456
        File system initialization succeeded !!
        # nilfs-tune -l test.img
        nilfs-tune 2.2.7
        nilfs-tune: test.img: cannot open NILFS
        # echo $?
        1
    
    However using nilfs-tune via a loop device works:
        # losetup --show --find /dev/loop0
        /dev/loop0
        # nilfs-tune -l /dev/loop0
        nilfs-tune 2.2.7
        Filesystem volume name:   (none)
        Filesystem UUID:          fc49912c-4d39-4672-8610-1e1185d0db5f
        Filesystem magic number:  0x3434
        Filesystem revision #:    2.0
        Filesystem features:      (none)
        Filesystem state:         valid
        Filesystem OS type:       Linux
        Block size:               4096
    ...
    
    So nilfs-tune only works with block devices.  Fix by making these tests
    require a loop device and therefore make them root only.  Now these
    tests are skipped as non-root user and pass as root.
    
    Closes !49 - Add file system interface tests

2019-10-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Create loop devices for online resized file system tests (!49)
    
    File systems BTRFS, JFS, NILFS2 and XFS can only be resized while
    mounted, but only root can mount file systems.  Therefore these tests
    fail.  Also BTRFS resize uses 'btrfs filesystem show' to discover the
    devid, which also fails as described in the previous commit message.
    
    Note that root can mount a file system image directly, but that it
    implicitly creates loop device:
        # truncate -s 256M test.img
        # mkfs.xfs test.img
        # mount test.img /mnt/1
    
        # fgrep /mnt/1 /proc/mounts
        /dev/loop0 /mnt/1 xfs rw,seclabel,relatime,attr2,inode64,noquota 0 0
        # losetup -a
        /dev/loop0: [64768]:35826659 (/root/test.img)
    
    Therefore make these tests root only and require an explicit loop
    device.  Now these file system resize tests succeed as root and are
    skipped as non-root.
    
    Closes !49 - Add file system interface tests

2019-10-09  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Create loop devices for BTRFS read file system interface tests (!49)
    
    For BTRFS the read (and resize) tests fail when using an image file,
    however the create, write and check tests pass.  Selected output from
    the test program:
    
        $ ./test_SupportedFileSystems --gtest_filter='*/btrfs' | fgrep ' ms'
        [       OK ] My/SupportedFileSystemsTest.Create/btrfs (43 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/btrfs, where GetParam() = 7 (95 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadLabel/btrfs, where GetParam() = 7 (158 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/btrfs, where GetParam() = 7 (164 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndWriteLabel/btrfs (164 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndWriteUUID/btrfs (132 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndCheck/btrfs (129 ms)
        [       OK ] My/SupportedFileSystemsTest.CreateAndRemove/btrfs (0 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndGrow/btrfs, where GetParam() = 7 (155 ms)
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndShrink/btrfs, where GetParam() = 7 (97 ms)
        [----------] 10 tests from My/SupportedFileSystemsTest (1137 ms total)
        [==========] 10 tests from 1 test case ran. (1137 ms total)
    
    The read operations fail because 'btrfs filesystem show' doesn't work on
    am image file:
        $ truncate -s 256M test.img
        $ mkfs.btrfs test.img
        btrfs-progs v4.9.1
        See http://btrfs.wiki.kernel.org for more information.
    
        Label:              (null)
        UUID:               de1624ae-39bb-4796-aee4-7ee1fa24c06a
        Node side:          16384
        Sector size:        4096
        Filesystem size:    256.00MiB
        Block group profiles:
          Data:             single
          Metadata:         DUP
          System:           DUP
        SSD detected:       no
        Incompat features:  extref, skinny-metadata
        Number of devices:  1
        Devices:
            ID       SIZE  PATH
             1  256.00MiB  test.img
        $ btrfs filesystem show test.img
        ERROR: not a valid btrfs filesystem: /home/centos/programming/c/gparted/tests/test.img
        $ echo $1
        1
    
    Querying a BTRFS image file also fails as root:
        $ su
        Password:
        # btrfs filesystem show test.img
        ERROR: not a valid btrfs filesystem: /home/centos/programming/c/gparted/tests/test.img
        # echo $1
        1
    
    However querying the BTRFS via a loop device succeeds:
        # losetup --show --find test.img
        /dev/loop0
        # btrfs filesystem show /dev/loop0
        Label: none  uuid: de1624ae-39bb-4796-aee4-7ee1fa24c06a
                Total devices 1 FS bytes used 112.00KiB
                devid    1 size 256.00MiB used 88.00MiB path /root/test.img
    
    There must be some kernel level BTRFS file system device discovery
    happening because now after creating a loop device for the image file,
    the BTRFS can be shown via the image file directly:
        # btrfs filesystem show test.img
        Label: none  uuid: de1624ae-39bb-4796-aee4-7ee1fa24c06a
                Total devices 1 FS bytes used 112.00KiB
                devid    1 size 256.00MiB used 88.00MiB path /root/test.img
    
    Anyway for the BTRFS reading tests make them required a loop device and
    therefore root only.  Now these tests are skipped as non-root user and
    pass as root.
    
    Addressing BTRFS resizing test failures will be handled in a following
    commit.
    
    Closes !49 - Add file system interface tests

2019-08-30  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Create loop devices for LVM2 PV file system interface tests (!49)
    
    Creating an LVM2 PV as a non-root user on an image file fails like this:
        $ truncate -s 256M test.img
        $ lvm pvcreate `pwd`/test.img
          WARNING: Running as a non-root user. Functionality may be unavailable.
          /run/lvm/lvmetad.socket: access failed: Permission denied
          WARNING: Failed to connect to lvmetad. Falling back to device scanning.
          /run/lock/lvm/P_orphans:aux: open failed: Permission denied
          Can't get lock for orphan PVs.
        $ echo $?
        5
    
    Trying the same as root also fails:
        # truncate -s 256M test.img
        # lvm pvcreate `pwd`/test.img
          Device /root/test.img not found.
        # echo $?
        5
    
    LVM seems strongly predicated on only using block devices [1].  LVM can
    use loop devices though, but loop devices can only be created by root.
        # truncate -s 256M test.img
        # losetup -f --show `pwd`/test.img
        /dev/loop0
        # lvm pvcreate /dev/loop0
          Physical volume "/dev/loop0" successfully created.
        # echo $?
        0
    
    Make the LVM2 PV tests require user root and use loop device over the
    test image.  Tests for the other file system types still directly uses
    the image file.  This makes the LVM2 PV tests pass when run as root, or
    successfully skipped when run as non-root.
    
    [1] lvmconfig --typeconfig default --withcomments --withspace | less
        From the "devices" section of the commented default configuration,
        LVM uses block devices found below /dev, devices provided by udev
        and/or found in sysfs.
    
    Closes !49 - Add file system interface tests

2019-10-16  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Prevent file system tests core dumping in GitLab CI Ubuntu image (!49)
    
    With the previous commit, execution of test_SupportedFileSystems is
    failing in the GitLab CI Ubuntu image.  Fragment from file
    tests/test-suite.log:
    
        FAIL: test_SupportedFileSystems
        ===============================
    
        Terminate called after throwing an instance of 'Glib::ConvertError'
        Aborted (core dumped)
        FAIL test_SupportedFileSystems (exit status: 134)
    
    This core dump can be re-created locally by (1) removing modprobe from
    the PATH, and (2) executing the test program in the C locale.
    
        $ LC_ALL=C ./test_SupportedFileSystems
        Running main() from test_SupportedFileSystems.cc
        terminate called after throwing an instance of 'Glib::ConvertError'
        Aborted
        $ echo $?
        134
    
    Backtrace from gdb:
        (gdb) backtrace
        #0  0x00007f4f93002337 in __GI_raise (sig=sig@entry=6)
            at ../nptl/sysdeps/unix/sysv/linux/raise.c:55
        #1  0x00007f4f93003a28 in __GI_abort () at abort.c:90
        #2  0x00007f4f93b2e7d5 in __gnu_cxx::__verbose_terminate_handler() ()
            at ../../../../libstdc++-v3/libsupc++/vterminate.cc:95
        #3  0x00007f4f93b2c746 in __cxxabiv1::__terminate(void (*)()) (handler=<optimized out>)
            at ../../../../libstdc++-v3/libsupc++/eh_terminate.cc:38
        #4  0x00007f4f93b2c773 in std::terminate() ()
            at ../../../../libstdc++-v3/libsupc++/eh_terminate.cc:48
        #5  0x00007f4f93b2c993 in __cxxabiv1::__cxa_throw(void*, std::type_info*, void (*)(void*))
            (obj=0x260d4b0, tinfo=0x7f4f966c1930 <typeinfo for Glib::ConvertError>, dest=0x7f4f96486fa0 <Glib::ConvertError::~ConvertError()>)
            at ../../../../libstdc++-v3/libsupc++/eh_throw.cc:87
        #6  0x00007f4f96486e27 in Glib::ConvertError::throw_func(_GError*) (gobject=0x260bf90) at convert.cc:329
        #7  0x00007f4f9649b5d7 in Glib::Error::throw_exception(_GError*) (gobject=0x260bf90) at error.cc:175
        #8  0x00007f4f964a7155 in Glib::operator<<(std::ostream&, Glib::ustring const&)
            (os=warning: RTTI symbol not found for class 'std::ostream' ..., utf8_string=...) at ustring.cc:1430
        #9  0x000000000044d66f in GParted::Utils::execute_command(Glib::ustring const&, char const*, Glib::ustring&, Glib::ustring&, bool)
            (command=..., input=input@entry=0x0, output=..., error=..., use_C_locale=use_C_locale@entry=true)
            at ../src/Utils.cc:688
        #10 0x000000000044dae9 in GParted::Utils::kernel_supports_fs(Glib::ustring const&)
            (use_C_locale=true, error=..., output=..., command=...)
            at ../src/Utils.cc:659
        #11 0x000000000044dae9 in GParted::Utils::kernel_supports_fs(Glib::ustring const&) (fs=...)
            at ../src/Utils.cc:480
        #12 0x0000000000460008 in GParted::jfs::get_filesystem_support() (this=0x25e8e60)
            at ../src/jfs.cc:59
        #13 0x00000000004464f9 in GParted::SupportedFileSystems::find_supported_filesystems() (this=0x25e8690)
            at ../src/SupportedFileSystems.cc:120
        #14 0x0000000000412360 in GParted::SupportedFileSystemsTest::setup_supported_filesystems() ()
            at test_SupportedFileSystems.cc:278
        #15 0x00000000004151b0 in GParted::SupportedFileSystemsTest::get_supported_fstypes() ()
            at test_SupportedFileSystems.cc:256
        #16 0x00000000004152c0 in GParted::gtest_MySupportedFileSystemsTest_EvalGenerator_() ()
            at test_SupportedFileSystems.cc:495
        #17 0x000000000041c7d6 in testing::internal::ParameterizedTestCaseInfo<GParted::SupportedFileSystemsTest>::RegisterTests()
            (this=0x2528ac0) at ../lib/gtest/include/gtest/internal/gtest-param-util.h:549
        #18 0x0000000000479fb5 in testing::internal::UnitTestImpl::RegisterParameterizedTests() (this=0x25288d0)
            at ./include/gtest/internal/gtest-param-util.h:709
        #19 0x0000000000479fb5 in testing::internal::UnitTestImpl::RegisterParameterizedTests()
            (this=this@entry=0x2528800) at ./src/gtest.cc:2658
        #20 0x000000000048a001 in testing::internal::UnitTestImpl::PostFlagParsingInit() (this=0x2528800)
            at ./src/gtest.cc:4980
        #21 0x000000000049e399 in testing::internal::InitGoogleTestImpl<char>(int*, char**)
            (argc=argc@entry=0x7ffe9d208a3c, argv=argv@entry=0x7ffe9d208b38) at ./src/gtest.cc:5934
        #22 0x000000000048d285 in testing::InitGoogleTest(int*, char**)
            (argc=argc@entry=0x7ffe9d208a3c, argv=argv@entry=0x7ffe9d208b38) at ./src/gtest.cc:5952
        #23 0x0000000000410404 in main(int, char**) (argc=1, argv=0x7ffe9d208b38)
            at test_SupportedFileSystems.cc:557
    
    The test program runs when executed in my locale and produces these
    messages:
    
        $ ./test_SupportedFileSystems
        Running main() from test_SupportedFileSystems.cc
        Failed to execute child process “modprobe” (No such file or directory)
        Failed to execute child process “modprobe” (No such file or directory)
        [==========] Running 210 tests from 1 test case.
    ...
    
    So the test program is aborting when trying to print the failed to
    execute child process message, but only in the C locale.
    
    This doesn't affect the CentOS GitLab CI image because that installs the
    kmod package with modprobe by default, however the Ubuntu image doesn't
    have the kmod package.
    
    Fix this by explicitly installing the kmod package into both the CentOS
    and Ubuntu GitLab CI images.
    
    Closes !49 - Add file system interface tests

2019-08-05  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Extend tests to all fully supported file systems (!49)
    
    Extend testing to all fully supported file systems, those with an
    implemented FileSystem derived class.
    
    Note that in main() GParted threading needs to now be initialised before
    InitGoogleTest() because it calls INSTANTIATE_TEST_CASE_P() which in
    turn calls get_supported_fstypes() which eventually constructs all the
    individual file system interface objects and discovers available
    support, some of which use execute_command().  Example call chain:
        InitGoogleTest()
          INSTANTIATE_TEST_CASE_P()
            get_supported_fstypes()
              setup_supported_filesystems()
                {SupportedFileSystems}->find_supported_filesystems()
                  {btrfs}->get_filesystem_support()
                    Utils::execute_command()
    
    In the CentOS 7 GitLab CI image the EPEL (Extra Packages for Enterprise
    Linux) repository is added to provide f2fs-tools and ntfsprogs.
    
    23 of 210 tests fail on CentOS 7 and 22 on Ubuntu 18.04 LTS.  The
    following commits will resolve these test failures.
    
        $ ./test_SupportedFileSystems
        Running main() from test_SupportedFileSystems.cc
        [==========] Running 210 tests from 1 test case.
        [----------] Global test environment set-up.
        [----------] 210 tests from My/SupportedFileSystemsTest
    ...
        [----------] 210 tests from My/SupportedFileSystemsTest (11066 ms total)
    
        [----------] Global test environment tear-down
        [==========] 210 tests from 1 test case ran. (11067 ms total)
        [  PASSED  ] 187 tests.
        [  FAILED  ] 23 tests, listed below:
        [  FAILED  ] My/SupportedFileSystemsTest.Create/lvm2pv, where GetParam() = 20
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/btrfs, where GetParam() = 7
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/jfs, where GetParam() = 17
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/lvm2pv, where GetParam() = 20
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/nilfs2, where GetParam() = 22
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUsage/ntfs, where GetParam() = 23
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadLabel/btrfs, where GetParam() = 7
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadLabel/nilfs2, where GetParam() = 22
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/btrfs, where GetParam() = 7
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/fat16, where GetParam() = 13
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/fat32, where GetParam() = 14
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/jfs, where GetParam() = 17
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndReadUUID/nilfs2, where GetParam() = 22
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndWriteLabel/nilfs2, where GetParam() = 22
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndWriteUUID/nilfs2, where GetParam() = 22
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndCheck/lvm2pv, where GetParam() = 20
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndCheck/minix, where GetParam() = 21
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndRemove/lvm2pv, where GetParam() = 20
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndGrow/btrfs, where GetParam() = 7
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndGrow/lvm2pv, where GetParam() = 20
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndGrow/xfs, where GetParam() = 27
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndShrink/btrfs, where GetParam() = 7
        [  FAILED  ] My/SupportedFileSystemsTest.CreateAndShrink/lvm2pv, where GetParam() = 20
    
        23 FAILED TESTS
    
    Closes !49 - Add file system interface tests

2019-08-04  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Print file system types in parameterised test names (!49)
    
    Until now the parameterised test values are printed as part of the test
    names as just 0, 1, etc. like this:
    
        $ ./test_SupportedFileSystems
        Running main() from test_SupportedFileSystems.cc
        [==========] Running 20 tests from 1 test case.
        [----------] Global test environment set-up.
        [----------] 20 tests from My/SupportedFileSystemsTest
        [ RUN      ] My/SupportedFileSystemsTest.Create/0
        [       OK ] My/SupportedFileSystemsTest.Create/0 (48 ms)
        [ RUN      ] My/SupportedFileSystemsTest.Create/1
        [       OK ] My/SupportedFileSystemsTest.Create/1 (11 ms)
    
    Provide the file system types as the names for the parameterised test
    values [1].  Now the test names are printed like this:
    
        $ ./test_SupportedFileSystems
        Running main() from test_SupportedFileSystems.cc
        [==========] Running 20 tests from 1 test case.
        [----------] Global test environment set-up.
        [----------] 20 tests from My/SupportedFileSystemsTest
        [ RUN      ] My/SupportedFileSystemsTest.Create/ext2
        [       OK ] My/SupportedFileSystemsTest.Create/ext2 (51 ms)
        [ RUN      ] My/SupportedFileSystemsTest.Create/linuxswap
        [       OK ] My/SupportedFileSystemsTest.Create/linuxswap (11 ms)
    
    Also use these Google Test name friendly ASCII alphanumeric only names
    everywhere the file system type needs to be reported in this test
    program.
    
    [1] Specifying Names for Value-Parameterized Test Parameters
        https://github.com/google/googletest/blob/v1.8.x/googletest/docs/advanced.md#specifying-names-for-value-parameterized-test-parameters
    
    Closes !49 - Add file system interface tests

2019-08-02  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add testing of linux-swap using Value-Parameterised Google Tests (!49)
    
    Use Google Test Value-Parameterised to call every test for both ext2
    and linux-swap.
        https://github.com/google/googletest/blob/v1.8.x/googletest/docs/advanced.md#value-parameterized-tests
    
    Running the test now looks like this:
    
        $ ./test_SupportedFileSystems
        Running main() from test_SupportedFileSystems.cc
        [==========] Running 20 tests from 1 test case.
        [----------] Global test environment set-up.
        [----------] 20 tests from My/SupportedFileSystemsTest
        [ RUN      ] My/SupportedFileSystemsTest.Create/0
        [       OK ] My/SupportedFileSystemsTest.Create/0 (97 ms)
        [ RUN      ] My/SupportedFileSystemsTest.Create/1
        [       OK ] My/SupportedFileSystemsTest.Create/1 (15 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUsage/0
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/0 (106 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUsage/1
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUsage/1 (14 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadLabel/0
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadLabel/0 (95 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadLabel/1
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadLabel/1 (23 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUUID/0
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUUID/0 (99 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndReadUUID/1
        [       OK ] My/SupportedFileSystemsTest.CreateAndReadUUID/1 (22 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndWriteLabel/0
        [       OK ] My/SupportedFileSystemsTest.CreateAndWriteLabel/0 (102 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndWriteLabel/1
        [       OK ] My/SupportedFileSystemsTest.CreateAndWriteLabel/1 (22 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndWriteUUID/0
        [       OK ] My/SupportedFileSystemsTest.CreateAndWriteUUID/0 (101 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndWriteUUID/1
        [       OK ] My/SupportedFileSystemsTest.CreateAndWriteUUID/1 (21 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndCheck/0
        [       OK ] My/SupportedFileSystemsTest.CreateAndCheck/0 (153 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndCheck/1
        test_SupportedFileSystems.cc:424: Skip test.  check not supported or support not found
        [       OK ] My/SupportedFileSystemsTest.CreateAndCheck/1 (0 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndRemove/0
        test_SupportedFileSystems.cc:437: Skip test.  remove not supported or support not found
        [       OK ] My/SupportedFileSystemsTest.CreateAndRemove/0 (0 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndRemove/1
        test_SupportedFileSystems.cc:437: Skip test.  remove not supported or support not found
        [       OK ] My/SupportedFileSystemsTest.CreateAndRemove/1 (0 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndGrow/0
        [       OK ] My/SupportedFileSystemsTest.CreateAndGrow/0 (266 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndGrow/1
        [       OK ] My/SupportedFileSystemsTest.CreateAndGrow/1 (32 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndShrink/0
        [       OK ] My/SupportedFileSystemsTest.CreateAndShrink/0 (111 ms)
        [ RUN      ] My/SupportedFileSystemsTest.CreateAndShrink/1
        [       OK ] My/SupportedFileSystemsTest.CreateAndShrink/1 (28 ms)
        [----------] 20 tests from My/SupportedFileSystemsTest (1311 ms total)
    
        [----------] Global test environment tear-down
        [==========] 20 tests from 1 test case ran. (1342 ms total)
        [  PASSED  ] 20 tests.
    
    Closes !49 - Add file system interface tests

2019-09-18  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Switch to testing ext2 interface via SupportedFilesystems class (!49)
    
    Replace directly using ext2 derived FileSystem interface class with
    using the SupportedFileSystems class.  This is a step in getting ready
    for testing all the GParted file system interface classes in one go.
    
    Closes !49 - Add file system interface tests

2019-07-16  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Split FILESYSTEMS and FILESYSTEM_MAP into separate module (!49)
    
    GParted_Core::FILESYSTEMS and ::FILESYSTEM_MAP and the methods that
    query and manipulate them are self-contained.  Therefore move them into
    a separate SupportedFileSystems module.
    
    Also having a single class maintaining all FileSystem interface objects
    will make testing all the file system types much easier as there will be
    no need to duplicate this functionality in the test.
    
    Closes !49 - Add file system interface tests

2019-07-27  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add offline ext2 resizing tests (!49)
    
    Closes !49 - Add file system interface tests

2019-07-26  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add simple ext2 write tests: label, UUID, check and remove (!49)
    
    Closes !49 - Add file system interface tests

2019-08-27  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Reload Partition object after FS creation in read tests (!49)
    
    Here are the errors reported in the deliberately broken
    CreateAndReadLabel test from the previous commit message:
    
        [ RUN      ] ext2Test.CreateAndReadLabel
        test_ext2.cc:311: Failure
        Value of: m_partition.get_messages().empty()
          Actual: false
        Expected: true
        Partition messages:
        e2label: No such file or directory while trying to open /does_not_exist/test_ext2.img
        Couldn't find valid filesystem superblock.
    
        [  FAILED  ] ext2Test.CreateAndReadLabel (77 ms)
    
    Even though the test was deliberately broken by setting the wrong path
    for the file system image and the e2label command failed, apparently
    testing for the expected label still passed.  What happened was that the
    desired "TEST_LABEL" has to be in the Partition object and then the file
    system was created.  Then reading the file system label failed, however
    "TEST_LABEL" was already set in the Partition object so it matched.
    Reading the label is unique among the read actions of usage, label and
    UUID as the others don't need to be set before the file system is
    created.  GParted doesn't encounter this issue because when refreshing
    devices it creates new blank Partition objects and then performs the
    read actions to populate them.
    
    Fix by resetting the Partition object back to only containing basic
    information before all the reading file system information tests, even
    though it is only needed in the read label case.  This also better
    reflects how GParted works.
    
    Now with the same deliberate brokenness the test also reports the label
    does not match it's expected value:
    
        $ ./test_ext2 --gtest_filter='ext2Test.CreateAndReadLabel'
        Running main() from test_ext2.cc
        Note: Google Test filter = ext2Test.CreateAndReadLabel
        [==========] Running 1 test from 1 test case.
        [----------] Global test environment set-up.
        [----------] 1 test from ext2Test
        [ RUN      ] ext2Test.CreateAndReadLabel
        test_ext2.cc:322: Failure
        Expected equality of these values:
          fs_label
            Which is: "TEST_LABEL"
          m_partition.get_filesystem_label().c_str()
            Which is: ""
        test_ext2.cc:272: Failure
        Value of: m_partition.get_messages().empty()
          Actual: false
        Expected: true
        Partition messages:
        e2label: No such file or directory while trying to open /does_not_exist/test_ext2.img
        Couldn't find valid filesystem superblock.
    
        [  FAILED  ] ext2Test.CreateAndReadLabel (70 ms)
        [----------] 1 test from ext2Test (70 ms total)
    
        [----------] Global test environment tear-down
        [==========] 1 test from 1 test case ran. (75 ms total)
        [  PASSED  ] 0 tests.
        [  FAILED  ] 1 test, listed below:
        [  FAILED  ] ext2Test.CreateAndReadLabel
    
         1 FAILED TEST
    
    Closes !49 - Add file system interface tests

2019-07-26  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add ext2 reading tests: usage, label and UUID (!49)
    
    The file system reading methods report errors into Partition messages
    because they are used as part of the GParted refresh, rather than
    reporting errors into OperationDetails used when applying operations.
    Therefore test for no messages for success and print the messages on
    failure.
    
    For example, temporarily breaking the read label test code by setting
    the wrong file system image name produces this:
    
        $ ./test_ext2 --gtest_filter='ext2Test.CreateAndReadLabel'
        Running main() from test_ext2.cc
        Note: Google Test filter = ext2Test.CreateAndReadLabel
        [==========] Running 1 test from 1 test case.
        [----------] Global test environment set-up.
        [----------] 1 test from ext2Test
        [ RUN      ] ext2Test.CreateAndReadLabel
        test_ext2.cc:311: Failure
        Value of: m_partition.get_messages().empty()
          Actual: false
        Expected: true
        Partition messages:
        e2label: No such file or directory while trying to open /does_not_exist/test_ext2.img
        Couldn't find valid filesystem superblock.
    
        [  FAILED  ] ext2Test.CreateAndReadLabel (77 ms)
        [----------] 1 test from ext2Test (77 ms total)
    
        [----------] Global test environment tear-down
        [==========] 1 test from 1 test case ran. (85 ms total)
        [  PASSED  ] 0 tests.
        [  FAILED  ] 1 test, listed below:
        [  FAILED  ] ext2Test.CreateAndReadLabel
    
         1 FAILED TEST
        $ echo $?
        1
    
    Closes !49 - Add file system interface tests

2019-10-25  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Strip XML markup from the printed operation details (!49)
    
    As seen in the first commit message, operation detail text is XML
    encoded.  This makes it harder to read, especially commands which often
    have single quotes encoded as &apos;.   For example:
    
        <b><i>mkfs.ext2 -F -L &apos;&apos; &apos;/home/centos/programming/c/gparted/tests/test_ext2.img&apos;</i></b>
    
    Strip this encoding when printing the operation details.  Now the same
    example looks like:
    
        mkfs.ext2 -F -L '' '/home/centos/programming/c/gparted/tests/test_ext2.img'
    
    Closes !49 - Add file system interface tests

2019-09-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Run test program under xvfb-run to satisfy need for an X11 display (!49)
    
    Running test_ext2 in GitLab Continuous Integration environment fails like
    this:
        (test_ext2:6338): Gtk-WARNING **: 09:06:17.576: cannot open display:
        Running main() from test_ext2.cc
    
    Obviously the GitLab CI environment doesn't have an X11 display, but
    unfortunately this test case code requires one.
    Utils::execute_command() calls Gtk::Main::run() so requires a Gtk::Main
    object constructing and therefore an X11 display, even though this
    program never displays anything graphical.  The call chain is:
        main()                       test_ext2.cc
          Gtk::Main::Main()          gtkmm/gtk/src/main.ccg
            Gtk::Main::init()        [1]
              gtk_init()             gtk/gtk/gtkmain.c [2]
    which exits with a non-zero exit status when the DISPLAY environment
    variable is unset.
    
    Looked at deriving from Gtk::Main class and writing a replacement init()
    method which calls gtk_init_check() instead of gtk_init() but
    Gtk::Main::instance_ is a private member so not accessible in a derived
    class.
    
    Tried using Glib::MainLoop instead of Gtk::Main, but that doesn't
    initialise everything that Gtk::Main(), so the program crashes.
    
    Therefore use xvfb-run [3][4] to run this test program against a virtual
    X11 display when a real display isn't available.  Coded execution of
    xvfb-run into this test program so that it can simply be executed on the
    command line like the other test programs, without having to remember to
    run "xvfb-run ./test_ext2 ...".
    
    [1] Gtk::Main::init()
        https://gitlab.gnome.org/GNOME/gtkmm/blob/3.10.1/gtk/src/main.ccg#L287
    [2] gtk_init()
        https://gitlab.gnome.org/GNOME/gtk/blob/3.10.9/gtk/gtkmain.c#L1000
    [3] how to run gtk app on linux without an x server
        https://superuser.com/questions/624918/how-to-run-gtk-app-on-linux-without-an-x-server
    [4] Using GTK without DISPLAY
        https://stackoverflow.com/questions/11694278/using-gtk-without-display
    
    Closes !49 - Add file system interface tests

2019-07-17  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add initial create ext2 only FileSystem interface class test (!49)
    
    This is the first step of adding testing of the derived FileSystem
    interface classes which call the file system specific executables.
    Rather than mocking command execution and returned output the tests run
    the real commands, effectively making this integration testing.
    
    Test case setup determines the file system supported actions using
    get_filesystem_support() and individual tests are skipped if a feature
    is not supported, just as GParted does for it's actions.
    
    Each test creates it's own sparse image file and a fresh file system,
    performs a test on one FileSystem interface call and deletes the image
    file.  This makes each test independent and allows them to run as a
    non-root user, provided the file system command itself doesn't require
    root.  Errors reported for a failed interface call will include the
    GParted OperationDetails, which in turn includes the file system
    specific command used and stdout and stderr from it's execution.
    
    For example, temporarily breaking the test code to create a 10 KiB image
    file instead of 256 MiB one produces this:
    
        $ ./test_ext2
        Running main() from test_ext2.cc
        [==========] Running 1 test from 1 test case.
        [----------] Global test environment set-up.
        [----------] 1 test from ext2Test
        [ RUN      ] ext2Test.Create
        test_ext2.cc:199: Failure
        Value of: s_ext2_obj->create(m_partition, m_operation_detail)
          Actual: false
        Expected: true
        Operation details:
        <b><i>mkfs.ext2 -F -L &apos;&apos; &apos;/home/centos/programming/c/gparted/tests/test_ext2.img&apos;</i></b>    00:00:00  (ERROR)
        <i></i>
        <i>mke2fs 1.42.9 (28-Dec-2013)
        /home/centos/programming/c/gparted/tests/test_ext2.img: Not enough space to build proposed filesystem while setting up superblock
        </i>
    
        [  FAILED  ] ext2Test.Create (25 ms)
        [----------] 1 test from ext2Test (25 ms total)
    
        [----------] Global test environment tear-down
        [==========] 1 test from 1 test case ran. (30 ms total)
        [  PASSED  ] 0 tests.
        [  FAILED  ] 1 test, listed below:
        [  FAILED  ] ext2Test.Create
    
         1 FAILED TEST
        $ echo $?
        1
    
    Also as Utils:: and FileSystem::execute_command() are needed, this
    requires linking with GParted_Core for GParted_Core::mainthread and
    therefore with most of the non-UI classes in gpartedbin.
    
    Closes !49 - Add file system interface tests

2019-06-27  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename enumeration to MENU_LABEL_FILESYSTEM
    
    To match the renaming performed as part of Bug 741424 "Add support for
    GPT partition names".  In particular this is most closely similar to:
        d480800600be714a0e706b51a147d329d8280e52
        Rename enum to OPERATION_LABEL_FILESYSTEM (#741424)

2019-09-29  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Print OS details in the GitLab CI (!48)
    
    Just a simple debugging aid to have the OS details printed in the GitLab
    CI output.
    
    Closes !48 - Remain with CentOS 7 for GitLab CI

2019-09-29  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remain with CentOS 7 for GitLab CI (!48)
    
    When GParted GitLab Continuous Integration was setup, CentOS 7 image was
    used for a slow moving distribution and Ubuntu as a different, faster
    moving distribution.
    
    CentOS 8 has recently been released [1].  To avoid automatically
    switching to it when an official CentOS 8 docker image is made available
    [2], explicitly specify the CentOS 7 image.
    
    [1] Release for CentOS Linux 8 and CentOS Streams (2019-09-24)
        https://lists.centos.org/pipermail/centos-announce/2019-September/023449.html
    
    [2] Docker Official Images, The official build of CentOS
        https://hub.docker.com/_/centos/
    
    Closes !48 - Remain with CentOS 7 for GitLab CI

2019-10-02  Marek Černocký <marek.cernocky@advantech.com>

    Updated Czech help translation

2019-10-02  Marek Černocký <marek@manet.cz>

    Updated Czech translation

2019-09-19  Jordi Mas <jmas@softcatala.org>

    Update Catalan translation

2019-08-22  Anders Jonsson <anders.jonsson@norsjovallen.se>

    Update Swedish translation

2019-08-13  Jordi Mas <jmas@softcatala.org>

    Update Catalan translation

2019-08-13  Asier Sarasua Garmendia <asier.sarasua@gmail.com>

    Update Basque translation

2019-08-11  Daniel Șerbănescu <daniel@serbanescu.dk>

    Update Romanian translation

2019-07-22  Mathias L. Baumann <github@supradigital.org>

    Fix invalid substitution in de.po (!47)
    
    Fixes the error:
      (gpartedbin:995): glibmm-WARNING **: 09:11:54.522: invalid
      substitution "%2" in fmt string "%2 Operationen stehen momentan aus."
    
    Closes !47 - Fix invalid substitution in de.po

2019-06-29  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Erase correct key in unit test PasswordRAMStoreTest.TooLongPassword
    
    Was attempting to erase the wrong key "key-long" for the test.  It
    should be erasing "key-too-long".  Fix this.  Given that that line in
    the test was to erase a non-existent key and confirm failure; the test
    passed before with the wrong non-existent key, and still passes with the
    right non-existent key.  Clearly a cut and paste error as a result of
    copying the previous LongPassword test when initially added in:
        c6657aab9efe8cefece2017bee4bef9ece607e73
        Add unit tests for PasswordRAMStore module (#795617)

2019-07-06  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Drop use of long ago removed udevsettle
    
    Separate udevsettle command was merged into udevadm back in udev 117
    (released 2007-11-13) by:
        https://github.com/systemd/systemd/commit/225cb03bd851adc6d269b13bdf2b1bfded2b96b9
        udevadm: merge all udev tools into a single binary
    
    The oldest supported distributions have these much newer versions of
    udev:
      Distro             EOL        udevadm -V
      Debian 8           2020-Apr   215 (combined systemd and udev)
      RHEL / CentOS 7    2024-Jun   219 (combined systemd and udev)
      Ubuntu 16.04 LTS   2021-Apr   229 (combined systemd and udev)

2019-07-12  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Order internally detected signatures by increasing offset (!46)(#16)
    
    Along with the previous patch "Avoid reading the same sector multiple
    times in a row (!46)(#16)" internal detection of file system signatures
    now reads the minimum number of sectors in increasing order.
    
    As the code still considers the sector size, it now also reads less
    sectors from devices with larger sectors to get all the signatures.  So
    on a 512 byte sector device it maximally seeks to and reads from these
    byte offsets:
        0, 512, 1024, 65536
    and on a 4096 byte sector device, only from these byte offsets:
        0, 65536
    
    Closes !46 - Whole device FAT32 file system reports device busy warning
                 from mlabel
    Closes #16 - "invalid argument for seek()" error on very small (<=40KiB)
                 drives

2019-07-12  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Avoid reading the same sector multiple times in a row (!46)(#16)
    
    GParted internal file system detection is reading the same sector
    multiple times in a row.  Add an optimisation to only read a sector if
    it is different to the previously read sector.
    
    Closes !46 - Whole device FAT32 file system reports device busy warning
                 from mlabel
    Closes #16 - "invalid argument for seek()" error on very small (<=40KiB)
                 drives

2019-07-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Just pass sector size to detect_filesystem_internal() (!46)(#16)
    
    After the previous commit the lp_device structure pointer parameter is
    only used to provide sector_size.  Just pass that instead.
    
    Closes !46 - Whole device FAT32 file system reports device busy warning
                 from mlabel
    Closes #16 - "invalid argument for seek()" error on very small (<=40KiB)
                 drives

2019-07-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Switch to POSIX open() in detect_filesystem_internal() (!46)(#16)
    
    For every partitioned device that GParted scans it triggers a set of
    udev change events from it's internal file system signature detection
    function.  This is the sequence of events:
    
      gparted    |set_devices_thread(pdevices)  pdevices->["/dev/sdb"]
      gparted    |  ped_device_get("/dev/sdb")
      libparted  |      open("/dev/sdb", O_RDONLY) = 8
      libparted  |      close(8)
      gparted    |  useable_device(lp_device)  lp_device->path="/dev/sdb"
      gparted    |    open("/dev/sdb", O_RDONLY|O_NONBLOCK) = 8
      gparted    |    read(8, ...)
      gparted    |    close(8)
      gparted    |  set_device_from_disk(device, device_path="/dev/sdb")
      gparted    |    get_device(device_path="/dev/sdb", ..., flush=true)
      gparted    |      ped_device_get()
      gparted    |      flush_device(lp_device)  lp_device->path="/dev/sdb"
      gparted    |        ped_device_open()
      libparted  |          open("/dev/sdb", O_RDWR) = 8
      gparted    |        ped_device_sync()
      gparted    |        ped_device_close()
      libparted  |          close(8)
      udev(async)|            KERNEL remove /devices/.../sdb/sdb1 (block)
      udev(async)|            KERNEL remove /devices/.../sdb/sdb2 (block)
      udev(async)|            KERNEL change /devices/.../sdb (block)
      udev(async)|            KERNEL add    /devices/.../sdb/sdb1 (block)
      udev(async)|            KERNEL add    /devices/.../sdb/sdb2 (block)
      udev(async)|            UDEV   remove /devices/.../sdb/sdb1 (block)
      udev(async)|            UDEV   remove /devices/.../sdb/sdb2 (block)
      udev(async)|            UDEV   change /devices/.../sdb (block)
      udev(async)|            UDEV   add    /devices/.../sdb/sdb1 (block)
      udev(async)|            UDEV   add    /devices/.../sdb/sdb2 (block)
      gparted    |        settle_device()
      gparted    |          Utils::execute_command("udevadm settle --timeout=1")
      gparted    |    detect_filesystem(lp_device, NULL, ...)  lp_device->path="/dev/sdb"
      gparted    |      detect_filesystem_internal(lp_device, NULL)  lp_device->path="/dev/sdb"
      gparted    |        ped_device_open()
      libparted  |          open("/dev/sdb", O_RDWR) = 8
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_close()
      libparted  |          close(8)
      udev(async)|            KERNEL remove /devices/.../sdb/sdb1 (block)
      udev(async)|            KERNEL remove /devices/.../sdb/sdb2 (block)
      udev(async)|            KERNEL change /devices/.../sdb (block)
      udev(async)|            KERNEL add    /devices/.../sdb/sdb1 (block)
      udev(async)|            KERNEL add    /devices/.../sdb/sdb2 (block)
      udev(async)|            UDEV   remove /devices/.../sdb/sdb1 (block)
      udev(async)|            UDEV   remove /devices/.../sdb/sdb2 (block)
      udev(async)|            UDEV   change /devices/.../sdb (block)
      udev(async)|            UDEV   add    /devices/.../sdb/sdb1 (block)
      udev(async)|            UDEV   add    /devices/.../sdb/sdb2 (block)
      gparted    |    get_disk(lp_device, lp_disk, strict=false)
      gparted    |      ped_disk_new(lp_device)  lp_device->path="/dev/sdb"
      libparted  |        open("/dev/sdb", O_RDWR) = 8
      libparted  |        close(8)
      udev(async)|          KERNEL remove /devices/.../sdb/sdb1 (block)
      udev(async)|          KERNEL remove /devices/.../sdb/sdb2 (block)
      udev(async)|          KERNEL change /devices/.../sdb (block)
      udev(async)|          KERNEL add    /devices/.../sdb/sdb1 (block)
      udev(async)|          KERNEL add    /devices/.../sdb/sdb2 (block)
      udev(async)|          UDEV   remove /devices/.../sdb/sdb1 (block)
      udev(async)|          UDEV   remove /devices/.../sdb/sdb2 (block)
      udev(async)|          UDEV   change /devices/.../sdb (block)
      udev(async)|          UDEV   add    /devices/.../sdb/sdb1 (block)
      udev(async)|          UDEV   add    /devices/.../sdb/sdb2 (block)
      gparted    |      settle_device()
      gparted    |        Utils::execute_command("udevadm settle --timeout=1")
      gparted    |    set_device_partitions()
      gparted    |      detect_filesystem()
      gparted    |      set_partition_label_and_uuid(partition)  partition.get_path()="/dev/sdb1"
      gparted    |        read_label()
      gparted    |          ext2::read_label()
      gparted    |            Utils::execute_command("e2label /dev/sdb1")
    
    Note that the udev block device change events triggered in
    detect_filesystem_internal() occur before the waited for ones in the
    second commit "Wait for udev to recreate /dev/PTN entries when querying
    partition FSs (!46)" in get_disk() so these were already waited for.
    
    The call chain is:
        set_devices_thread()
            set_device_from_disk()
                detect_filesystem()
                    detect_filesystem_internal()
                        ped_device_open()
                        ped_device_read()
                        ped_device_close()
    
    This occurs because file system detection is performed on whole disk
    devices, but the device contains a partition table, so blkid won't
    report any content GParted accepts as a file system, so it tries it's
    own internal detection.
    
    Fix this by changing detect_filesystem_internal() to use POSIX open(),
    read() and close() so the file can be opened read-only and udev change
    events aren't triggered.
    
    Note that when using detect_filesystem_internal() on a partition this
    also changes the device it reads from.  Before it used libparted which
    always reads from the whole disk device, now it reads from the partition
    device.  This doesn't matter because GParted ensures the data is
    consistent between them [2] and blkid reads from each partition device
    which GParted already uses.
    
    As the new code avoids using the libparted API, and just skips to the
    next signature on lseek() and read() errors, it therefore won't generate
    libparted exceptions such as this when scanning very small drives:
        Invalid argument during seek for read on /dev/PTN
    
    [1] f8faee637787329c07771e495c9b26abc9ac1603
        Avoid whole disk FAT being detected as MSDOS partition table
        (#743181)
    
    [2] 3bea067596e3e2d6513cda2a66df1b3e4fa432fb
        Flush devices when scanning to prevent reading stale signatures
        (#723842)
    
    Closes !46 - Whole device FAT32 file system reports device busy warning
                 from mlabel
    Closes #16 - "invalid argument for seek()" error on very small (<=40KiB)
                 drives

2019-07-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Pass unmodified parameter to useable_device() as const (!46)
    
    GParted_Core::useable_device() doesn't change the pointed to PedDevice
    structure.  Pass it as const so the compiler enforces this.
    
    Closes !46 - Whole device FAT32 file system reports device busy warning
                 from mlabel

2019-07-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Switch to POSIX open() in useable_device() (!46)
    
    For every device that GParted scans, it determines if it can be used by
    attempting to read the first sector.  This is the sequence of events,
    as reported in the previous two commit messages:
    
      gparted    |set_devices_thread(pdevices)  pdevices->["/dev/sdb"]
      ...
      gparted    |  useable_device(lp_device)  lp_device->path="/dev/sdb"
      gparted    |    ped_device_open()
      libparted  |      open("/dev/sdb", O_RDWR) = 8
      gparted    |    ped_device_read()
      gparted    |    ped_device_close()
      libparted  |      close(8)
      udev(async)|        KERNEL change /devices/.../sdb (block)
      ...
      udev(async)|        UDEV   change /devices/.../sdb (block)
    
    Note that these udev block device change events occur before the ones
    waited for in the first commit "Wait for udev change on /dev/DISK when
    querying whole device FS (!46)" so these were already waited for.
    
    So because libparted only opens devices read-write this triggers a set
    of udev change events for the whole block device, and if the device is
    partitioned, also remove and re-add events for all the partitions.
    
    Switch to using POSIX open(), read() and close() calls so read-only
    access can be specified to avoid the unnecessary udev change events.
    
    Closes !46 - Whole device FAT32 file system reports device busy warning
                 from mlabel

2019-07-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Wait for udev to recreate /dev/PTN entries when querying partition FSs (!46)
    
    After the previous fix, on my CentOS 7 VM, GParted is now often
    reporting a warning that the /dev/PTN entry is missing when reading the
    label of the file system in the first partition.  This happens
    regardless of the file system type.
    
    Example error for EXT4:
        e2label: No such file or directory while trying to open /dev/sdb1
        Couldn't find valid file system superblock.
    
    Example error for XFS:
        /dev/sdb1: No such file or directory
        fatal error -- couldn't initialize XFS library
    
    As with the case in the previous commit, GParted gets the label via
    blkid instead.
    
    Again with debugging and sleeping in GParted, stracing the GParted
    thread GParted_Core::set_devices_thread() and using 'udevadm monitor' to
    watch udev events the following sequence of events is observed:
    
      gparted    |set_devices_thread(pdevices)  pdevices->["/dev/sdb"]
      gparted    |  ped_device_get("/dev/sdb")
      libparted  |      open("/dev/sdb", O_RDONLY) = 8
      libparted  |      close(8)
      gparted    |  useable_device(lp_device)  lp_device->path="/dev/sdb"
      gparted    |    ped_device_open()
      libparted  |      open("/dev/sdb", O_RDWR) = 8
      gparted    |    ped_device_read()
      gparted    |    ped_device_close()
      libparted  |      close(8)
      udev(async)|        KERNEL remove /devices/.../sdb/sdb1 (block)
      udev(async)|        KERNEL remove /devices/.../sdb/sdb2 (block)
      udev(async)|        KERNEL change /devices/.../sdb (block)
      udev(async)|        KERNEL add    /devices/.../sdb/sdb1 (block)
      udev(async)|        KERNEL add    /devices/.../sdb/sdb2 (block)
      udev(async)|        UDEV   remove /devices/.../sdb/sdb1 (block)
      udev(async)|        UDEV   remove /devices/.../sdb/sdb2 (block)
      udev(async)|        UDEV   change /devices/.../sdb (block)
      udev(async)|        UDEV   add    /devices/.../sdb/sdb1 (block)
      udev(async)|        UDEV   add    /devices/.../sdb/sdb2 (block)
      gparted    |  set_device_from_disk(device, device_path="/dev/sdb")
      gparted    |    get_device(device_path="/dev/sdb", ..., flush=true)
      gparted    |      ped_device_get()
      gparted    |      flush_device(lp_device)  lp_device->path="/dev/sdb"
      gparted    |        ped_device_open()
      libparted  |          open("/dev/sdb", O_RDWR) = 8
      gparted    |        ped_device_sync()
      gparted    |        ped_device_close()
      libparted  |          close(8)
      udev(async)|            KERNEL remove /devices/.../sdb/sdb1 (block)
      udev(async)|            KERNEL remove /devices/.../sdb/sdb2 (block)
      udev(async)|            KERNEL change /devices/.../sdb (block)
      udev(async)|            KERNEL add    /devices/.../sdb/sdb1 (block)
      udev(async)|            KERNEL add    /devices/.../sdb/sdb2 (block)
      udev(async)|            UDEV   remove /devices/.../sdb/sdb1 (block)
      udev(async)|            UDEV   remove /devices/.../sdb/sdb2 (block)
      udev(async)|            UDEV   change /devices/.../sdb (block)
      udev(async)|            UDEV   add    /devices/.../sdb/sdb1 (block)
      udev(async)|            UDEV   add    /devices/.../sdb/sdb2 (block)
      gparted    |        settle_device()
      gparted    |          Utils::execute_command("udevadm settle --timeout=1")
      gparted    |    detect_filesystem(lp_device, NULL, ...)  lp_device->path="/dev/sdb"
      gparted    |      detect_filesystem_internal(lp_device, NULL)  lp_device->path="/dev/sdb"
      gparted    |        ped_device_open()
      libparted  |          open("/dev/sdb", O_RDWR) = 8
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_read()
      gparted    |        ped_device_close()
      libparted  |          close(8)
      udev(async)|            KERNEL remove /devices/.../sdb/sdb1 (block)
      udev(async)|            KERNEL remove /devices/.../sdb/sdb2 (block)
      udev(async)|            KERNEL change /devices/.../sdb (block)
      udev(async)|            KERNEL add    /devices/.../sdb/sdb1 (block)
      udev(async)|            KERNEL add    /devices/.../sdb/sdb2 (block)
      udev(async)|            UDEV   remove /devices/.../sdb/sdb1 (block)
      udev(async)|            UDEV   remove /devices/.../sdb/sdb2 (block)
      udev(async)|            UDEV   change /devices/.../sdb (block)
      udev(async)|            UDEV   add    /devices/.../sdb/sdb1 (block)
      udev(async)|            UDEV   add    /devices/.../sdb/sdb2 (block)
      gparted    |    get_disk(lp_device, lp_disk, strict=false)
      gparted    |      ped_disk_new(lp_device)  lp_device->path="/dev/sdb"
      libparted  |        open("/dev/sdb", O_RDWR) = 8
      libparted  |        close(8)
      udev(async)|          KERNEL remove /devices/.../sdb/sdb1 (block)
      udev(async)|          KERNEL remove /devices/.../sdb/sdb2 (block)
      udev(async)|          KERNEL change /devices/.../sdb (block)
      udev(async)|          KERNEL add    /devices/.../sdb/sdb1 (block)
      udev(async)|          KERNEL add    /devices/.../sdb/sdb2 (block)
      udev(async)|          UDEV   remove /devices/.../sdb/sdb1 (block)
      udev(async)|          UDEV   remove /devices/.../sdb/sdb2 (block)
      udev(async)|          UDEV   change /devices/.../sdb (block)
      udev(async)|          UDEV   add    /devices/.../sdb/sdb1 (block)
      udev(async)|          UDEV   add    /devices/.../sdb/sdb2 (block)
      gparted    |    set_device_partitions()
      gparted    |      detect_filesystem()
      gparted    |      set_partition_label_and_uuid(partition)  partition.get_path()="/dev/sdb1"
      gparted    |        read_label()
      gparted    |          ext2::read_label()
      gparted    |            Utils::execute_command("e2label /dev/sdb1")
    
    So in this case for a partitioned drive, libparted ped_disk_new() is
    opening and closing the device read-write and triggering the udev remove
    and add partition block special entries exactly when the label is trying
    to be read from the first partition, causing the device missing error.
    The call chain is:
        set_devices_thread()
            set_device_from_disk()
                get_disk()
                    ped_disk_new()
    
    Looking at the source for ped_disk_new() [1] it is calling
    ped_device_open() and ped_device_close(), hence why it is opening the
    device read-write and triggering the udev events.
    
    Looking back at commit "Wait for udev to recreate /dev/PTN entries when
    calibrating (#762941)" [2] and re-testing it, the udev events were also
    caused by ped_disk_new() with this call chain:
        apply_operation_to_disk()
            calibrate_partition()
                get_disk()
                    ped_disk_new()
    
    Fix this probe case and keep the fix for the previous calibrate case by
    moving the waiting for udev events from calibrate_partition() into
    get_disk(), right after ped_disk_new().  The maximum wait time is
    shortened to the shorter 1 second probing timeout to avoid the longer
    10 second apply timeout in this probing case.  The calibrate case commit
    message said "The longest I have seen udev take to do this is 0.80
    seconds in a VM".
    
    [1] parted/libparted/disk.c:ped_disk_new()
        http://git.savannah.gnu.org/cgit/parted.git/tree/libparted/disk.c?id=v3.2#n169
    
    [2] fd9013d5f6971e9282f019903d6e148e367718bf
        Wait for udev to recreate /dev/PTN entries when calibrating
        (#762941)
    
    Closes !46 - Whole device FAT32 file system reports device busy warning
                 from mlabel

2019-07-09  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Wait for udev change on /dev/DISK when querying whole device FS (!46)
    
    GParted nearly always shows this warning against a whole disk device
    FAT32 file system on my development VMs:
        plain floppy: device "/dev/sdb" busy (Resource temporarily
        unavailable): Cannot initialize '::'
        mlabel: Cannot initialize drive
    However GParted does get the label via blkid instead.  Occasionally
    everything works correctly and there is no warning.
    
    Never found a similar error for any other file system on a whole disk
    device.  The timing never seems to clash.
    
    Remember that when a writable file descriptor of a disk device is
    closed, udev events are triggered which update the kernel and /dev
    entries for any partition changes.  (This is in addition to coding which
    has always existed in the partitioning tools, including fdisk and
    parted, to inform the kernel, but not create /dev entries, of partition
    changes).
    
    With debugging and sleeping in GParted, stracing the GParted thread
    GParted_Core::set_devices_thread() and using 'udevadm monitor' to watch
    udev events the following sequence of events is observed:
    
      gparted    |set_devices_thread(pdevices)  pdevices->["/dev/sdb"]
      gparted    |  ped_device_get("/dev/sdb")
      libparted  |      open("/dev/sdb", O_RDONLY) = 8
      libparted  |      close(8)
      gparted    |  useable_device(lp_device)  lp_device->path="/dev/sdb"
      gparted    |    ped_device_open()
      libparted  |      open("/dev/sdb", O_RDWR) = 8
      gparted    |    ped_device_read()
      gparted    |    ped_device_close()
      libparted  |      close(8)
      udev(async)|        KERNEL change /devices/.../sdb (block)
      udev(async)|        KERNEL change /devices/.../sdb (block)
      udev(async)|        UDEV   change /devices/.../sdb (block)
      udev(async)|        UDEV   change /devices/.../sdb (block)
      gparted    |  set_device_from_disk(device, device_path="/dev/sdb")
      gparted    |    get_device(device_path="/dev/sdb", ..., flush=true)
      gparted    |      ped_device_get()
      gparted    |      flush_device(lp_device)  lp_device->path="/dev/sdb"
      gparted    |        ped_device_open()
      libparted  |          open("/dev/sdb", O_RDWR) = 8
      gparted    |        ped_device_sync()
      gparted    |        ped_device_close()
      libparted  |          close(8)
      udev(async)|            KERNEL change /devices/.../sdb (block)
      udev(async)|            KERNEL change /devices/.../sdb (block)
      udev(async)|            UDEV   change /devices/.../sdb (block)
      udev(async)|            UDEV   change /devices/.../sdb (block)
      gparted    |    set_device_one_partition()
      gparted    |      set_partition_label_and_uuid()
      gparted    |        read_label()
      gparted    |          fat16::read_label()
      gparted    |            Utils::execute_command("mlabel -s :: -i /dev/sdb")
    
    This sequence of events only shows which close()s by libparted trigger
    udev events.  It does not show that processing those events are
    asynchronous and overlap with GParted executing mlabel, causing the
    device busy error.
    
    As libparted's ped_device_open() doesn't offer a way to specify that a
    device will only be used for reading, it always opens it read-write
    [1][2].  Hence this sequence in GParted_Core::flush_device():
        ped_device_open()
        ped_device_sync()
        ped_device_close()
    always triggers udev change events on the whole disk device.  Fix by
    waiting for those udev events to complete.
    
    [1] libparted documentation, PedDevice, ped_device_open()
        https://www.gnu.org/software/parted/api/group__PedDevice.html#ga7c87bd06e76553c8ff3262b5e6ca256
    
    [2] parted/libparted/arch/linux.c:linux_open()
        http://git.savannah.gnu.org/cgit/parted.git/tree/libparted/arch/linux.c?id=v3.2#n1628
    
    Closes !46 - Whole device FAT32 file system reports device busy warning
                 from mlabel

2019-07-18  Rafael Fontenelle <rafaelff@gnome.org>

    Update Brazilian Portuguese translation

2019-04-01  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Drop use of long ago removed udevinfo
    
    The last distribution to include the separate 'udevinfo' command was
    RHEL / CentOS 5 with udev 095.  All supported distributions have much
    newer versions of udev and instead have the 'udevadm' command.

2019-06-18  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Switch to faster minfo and mdir to read FAT16/32 usage (#569921)
    
    A user reported that GParted was slow to refresh on FAT32 file systems:
    "can take very long, up to several minutes; can be reproduced by running
    dosfsck manually".  This is because the file system was large and almost
    full, and GParted performs a file system check just to to report the
    file system usage.
    
    Created a 4 GiB FAT32 file system and almost filled it with 4 KiB files,
    just over 970,000 files.
    
        # df -k /mnt/2
        Filesystem     1K-blocks     Used Available Used% Mounted on
        /dev/sdb2        4186108 39155384    270724   94% /mnt/2
        # df -i /mnt/2
        Filesystem     Inodes IUsed IFree IUse% Mounted on
        /dev/sdb2           0     0     0     - /mnt/2
        # find /mnt/2 -type f -print | wc -l
        971059
        # find /mnt/2 -type d -print | wc -l
        1949
    
    Testing performance of the current fsck.fat:
    
        # time fsck.fat -n -v /dev/sdb2 | \
        > egrep 'bytes per logical sector|bytes per cluster|sectors total|clusters$'
               512 bytes per logical sector
              4096 bytes per cluster
           8388608 sectors total
        /dev/sdb2: 973008 files, 978846/1046527 clusters
    
        real    0m11.552s
        user    0m2.183s
        sys     0m7.547s
    
    Free sectors in the file system according to fsck.fat:
        (1046527 - 978846) * 4096 / 512 = 541448 sectors
    
    Repeating this test while also using 'blktrace /dev/sdb2' and Ctrl-C
    around the test in a separate terminal, reports these numbers of I/Os
    being performed:
        Read requests   Read bytes
               15,563      165 MiB
    
    Prior to this commit [1] from 0.0.9, GParted used libparted's
    ped_file_system_get_resize_constraint() to report the minimum size to
    which a FAT* file system can be resized.  Use this test program [2] to
    performance test this method:
    
        # time ./fscons /dev/sdb2
        dev=/dev/sdb2
        sector_size=512
        min_size=7909522
        max_size=8388608
    
        real    0m2.673s
        user    0m0.070s
        sys     0m1.834s
    
    Free sectors in the file system according to libparted
    ped_file_system_get_resize_constraint():
        8388608 - 7909522 = 479086 sectors
    
    blktrace reports these numbers of I/Os being performed:
        Read requests   Read bytes
                7,821       71 MiB
    
    So using libparted resize constraint is a bit faster but is still
    reading too much data and is really too slow.  Also when testing GParted
    using this libparted method against a corrupted FAT32 file system, on
    every refresh, one popup dialog is displayed for each error libparted
    detects with the file system, each of which needs acknowledgement.
    Example popup:
    
                         Libparted Error
        \DIRNAME\FILENAME.EXT is 107724k, but is has 1920
        clusters (122880k).
    
                                     [ Cancel ][ Ignore ]
    
    There could be a huge number of such errors in a corrupted file system.
    Not really suitable for use by GParted.
    
    Test the performance of mtools' minfo command to report the file system
    figures:
    
        # time minfo -i /dev/sdb2 :: | \
        > egrep 'sector size:|cluster size:|small size:|big size:|free clusters='
        sector size: 512 bytes
        cluster size: 8 sectors
        small size: 0 sectors
        big size: 8388608 sectors
        free clusters=67681
    
        real    0m0.013s
        user    0m0.004s
        sys     0m0.019s
    
    Free sectors in the file system according to minfo:
        67681 * 8 = 541448 sectors
    
    blktrace reports these numbers of I/Os being performed by minfo:
        Read requests   Read bytes
                    1       16 KiB
    
    This matches with minfo just reading information from the BPB (BIOS
    Parameter Block) [3] from sector 0 and the FS Information Sector [4]
    usually in sector 1.  Note that the free cluster figure reported by
    minfo comes from the FS Information Sector because it only reports it
    for FAT32 file systems, not for FAT16 file systems.  Scanning the File
    Allocation Table (FAT) [5] to count free clusters is exactly what mdir,
    without the '-f' (fast) flag, does.  Test the performance of mdir:
    
        # export MTOOLS_SKIP_CHECK=1
        # time mdir -i /dev/sdb2 ::/ | fgrep 'bytes free'
                                277 221 376 bytes free
    
        real    0m0.023s
        user    0m0.011s
        sys     0m0.023s
    
    Free sectors in the file system according to mdir:
        277221376 / 512 = 541448 sectors
    
    blktrace reports these number of I/Os being performed by mdir:
        Read requests   Read bytes
                    5      448 KiB
    
    So minfo and mdir together provide the needed information and are 2 to 3
    orders of magnitude faster because they only read the needed BPB and FAT
    data from the drive.  Use these together to read the file system usage.
    
    [1] 61cd0ce77879e4af84280ddcf77959ae55885ba4
        lots of stuff and cleanups, including fixing getting used/unused
        space of hfs/hfs+/fat16/fat32
    
    [2] fscons.c
    /* FILE:     fscons.c
     * SYNOPSIS: Report libparted's FS resize limits.
     * BUILD:    gcc -o fscons fscons.c -lparted -lparted-fs-resize
     */
    
    int main(int argc, const char *argv[])
    {
        PedDevice* dev = NULL;
        PedDisk* tab = NULL;
        PedPartition* ptn = NULL;
        PedFileSystem* fs = NULL;
        PedConstraint* cons = NULL;
    
        if (argc != 2)
        {
            fprintf(stderr, "Usage: fscons BLOCKDEV\n");
            exit(1);
        }
    
        dev = ped_device_get(argv[1]);
        if (dev == NULL)
        {
            fprintf(stderr, "ped_device_get(\"%s\") failed\n", argv[1]);
            exit(1);
        }
        printf("dev=%s\n", dev->path);
        printf("sector_size=%ld\n", dev->sector_size);
    
        tab = ped_disk_new(dev);
        if (tab == NULL)
        {
            fprintf(stderr, "ped_disk_new(dev) failed\n");
            exit(1);
        }
    
        ptn = ped_disk_get_partition_by_sector(tab, 0);
        if (ptn == NULL)
        {
            fprintf(stderr, "ped_disk_get_partition(tab, 0) failed\n");
            exit(1);
        }
    
        fs = ped_file_system_open(&ptn->geom);
        if (fs == NULL)
        {
            fprintf(stderr, "ped_file_system_open(&ptn->geom) failed\n");
            exit(1);
        }
    
        cons = ped_file_system_get_resize_constraint(fs);
        if (cons == NULL)
        {
            fprintf(stderr, "ped_file_system_get_resize_constraint(fs) failed\n");
            exit(1);
        }
        printf("min_size=%ld\n", cons->min_size);
        printf("max_size=%ld\n", cons->max_size);
    
        ped_constraint_destroy(cons);
        ped_file_system_close(fs);
        ped_disk_destroy(tab);
        ped_device_destroy(dev);
    
        return 0;
    }
    
    [3] Design of the FAT file system, BIOS Parameter Block
        https://en.wikipedia.org/wiki/Design_of_the_FAT_file_system#BIOS_Parameter_Block
    
    [4] Design of the FAT file system, FS Information Sector
        https://en.wikipedia.org/wiki/Design_of_the_FAT_file_system#FS_Information_Sector
    
    [5] Design of the FAT file system, File Allocation Table
        https://en.wikipedia.org/wiki/Design_of_the_FAT_file_system#File_Allocation_Table
    
    Bug 569921 - dosfsck -n delays device scan

2019-06-22  Goran Vidović <trebelnik2@gmail.com>

    Update Croatian translation

2019-06-19  Balázs Úr <balazs@urbalazs.hu>

    Update Hungarian translation

2019-06-19  Daniel Mustieles <daniel.mustieles@gmail.com>

    Updated Spanish translation

2019-06-16  Piotr Drąg <piotrdrag@gmail.com>

    Update Polish translation

2019-06-11  Curtis Gedak <gedakc@gmail.com>

    Add missing window title to Help Contents dialog (!45)
    
    When GParted is configured with `--disable-doc` the help documentation
    is neither built, nor installed.
    
    With this configuration the Help -> Contents menu displays a message
    dialog indicating the "Documentation is not available".
    
    On GNOME 3 no title is shown; however, on some other graphic toolkits
    / window managers an unspecified title is shown.
    
    For example on GParted Live with Fluxbox the following is displayed:
    
                             Unnamed
                             -------
    
                   Documentation is not available
    
          This build of gparted is configured without documentation.
          Documentation is available at the project web site.
          https://gparted.org
    
                               OK
    
    To address the unspecified title on non-GNOME 3 graphic toolkits, add
    a title that works with and without GNOME 3.
    
    Closes !45 - Add missing window title to Help Contents dialog

2019-05-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add missing Device.h include into GParted_Core and Win_GParted
    
    The files GParted_Core.h, GParted_Core.cc and Win_GParted.cc all use the
    Device type but don't include Device.h for it's definition.  Include it.

2019-05-21  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Replace partition boundary trimming with bug error messages (#48)
    
    All the dialogs which compose new or modified partition boundaries
    create those partitions within the boundaries of the device.  Therefore
    trimming the partition boundaries to device boundaries never happens.
    So replace this trimming with bug error reports.
    
    Also add bug prefixes to the other error messages in
    GParted_Core::valid_partition() too.
    
    Closes #48 - Error when moving locked LUKS-encrypted partition

2019-05-22  Mike Fleetwood <mike.fleetwood@googlemail.com>

    White space layout update in snap_to_mebibyte/cylinder() (#48)
    
    The previous commit moved the code from GParted_Core to
    Dialog_Base_Partition class without making a single formatting change to
    ensure the code was guaranteed to work the same within that larger
    commit.  Now reformat the code to current layout standards.  Making it a
    separate commit simplifies the effort for both changes and improves
    bisectability.
    
    Additionally to be sure there were no code changes,
    Dialog_Base_Partition.cc was compiled to assembler code with and without
    this change applied and the resultant assembler code compared.  There
    were no differences in the generated assembler code.
    
    Start with the make generated g++ command for compiling
    Dialog_Base_Partition.o; (1) remove the '-g' flag as inserted debugging
    directives do differ; and (2) replace '-c -o Dialog_Base_Partition.o'
    with '-S -o Dialog_Base_Partition.s' to produce assembler output instead
    of object code.
    
    Closes #48 - Error when moving locked LUKS-encrypted partition

2019-05-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Snap partition boundaries before dialogs update FS usage (#48)
    
    Move snap_to_*() method calls from the point when all operations are
    added to the list, to earlier when Resize/Move, Paste (into new) and
    Create New dialogs are composing the new partition objects.  In
    particular for the Resize/Move operation, to just before updating the
    file system usage.
    
    This change finally resolves this bug.
    
    Because of the dialog call chains into Dialog_Base_Partition,
    snap_to_alignment() must be added into:
    * Dialog_Base_Partition::prepare_new_partition() for the Resize/Move and
      Paste (into new) dialogs; and
    * Dialog_Partition_New::Get_New_Partition() for the Create New dialog.
    
    Closes #48 - Error when moving locked LUKS-encrypted partition

2019-05-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Pass the current device down to Dialog_Base_Partition class (#48)
    
    The current device has to be passed to the dialog constructors and then
    on to the Dialog_Base_Constructor.  Note that the Dialog_Partition_New
    constructor is already passed the current device, however it still needs
    to pass it on to Dialog_Base_Constructor.
    
    This is ready so that snap_to_*() methods can access the current device
    when they are called from within these dialogs.
    
    * Pass Parameter to Base Class Constructor while creating Derived class
      Object
      https://stackoverflow.com/questions/16585856/pass-parameter-to-base-class-constructor-while-creating-derived-class-object
    
    Closes #48 - Error when moving locked LUKS-encrypted partition

2019-05-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Update file system usage last in prepare_new_partition() (#48)
    
    Move setting of the new_partition object file system usage to after
    everything else, specifically after free_space_before and strict_start.
    This is because snap_to_*() use free_space_before and strict_start and
    snap_to_alignment() is going to be called before the file system usage
    is updated to avoid the error in this bug report.
    
    Closes #48 - Error when moving locked LUKS-encrypted partition

2019-05-09  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove unused error reporting from snap_to_*() (#48)
    
    None of the snap_to_*() methods report any errors so remove the unused
    error parameter and return value.
    
    Closes #48 - Error when moving locked LUKS-encrypted partition

2019-05-08  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Separate partition alignment from validation (#48)
    
    PATCHSET OVERVIEW
    
    A user had 2 adjacent partitions which were aligned to multiples of
    33553920 bytes (32 MiB - 512 bytes), not MiB or cylinders.  As far as
    GParted is concerned this is not aligned.  The second partition
    contained closed LUKS encrypted data.  Recreate this setup with:
    
        # truncate -s 200G /tmp/disk.img
        # losetup -f --show /tmp/disk.img
        /dev/loop0
        # sfdisk -u S /dev/loop0 << EOF
        65535 2162655 83
        2228190 78904140 83
        EOF
        # partprobe /dev/loop0
        # echo -n badpassword | cryptsetup luksFormat /dev/loop0p2 -
    
    When trying to move the second LUKS encrypted partition to the right by
    any amount, with the default MiB alignment, GParted displays this error
    dialog and fails to even queue the operation:
    
        Could not add this operation to the list
        A partition with used sectors (78907392) greater than its
        length (78905344) is not valid
        [                       OK                               ]
    
    Overview of the steps involved:
    
    1. The Resize/Move dialog composed a new partition to start a whole
       multiple of MiB after the end of the previous non-aligned partition.
       The new partition also had it's size increased to a whole multiple of
       MiB, to 78907392 sectors (38529 MiB) which was 1.59 MiB larger than
       before.  Neither the start or end of the new partition are aligned at
       this point.
    
    2. Win_GParted::activate_resize() applied the change back to the closed
       LUKS partition object, additionally making the used sectors equal to
       the partition size.
       (To match the fact that when opened the LUKS mapping it will
       automatically fill the new larger partition size).
    
    3. GParted_Core::snap_to_mebibyte() then aligned the partition start and
       end to whole MiB boundaries, reducing the partition size in the
       process to 78905344 (38528 MiB).
    
    4. GParted_Core::snap_to_alignment() reported the error saying that it
       couldn't add the operation to the list because it was invalid to have
       the file system used sectors larger than the partition size.
    
    Fix this by having the snap to alignment adjustments applied before the
    dialogs update any associated file system usage.  Specifically the
    Resize/Move, Paste (into new) and Create New dialogs as these are the
    only ones which either create or modify partition boundaries.
    Validation done by snap_to_alignment() will continue to occur at the
    current point when the operation is added to the list.
    
    THIS COMMIT
    
    snap_to_alignment() is doing two different jobs, it is (1) optionally
    adjusting the new partition boundaries for MiB or Cylinder alignment;
    and (2) checking that the partition boundaries and file system usage are
    valid.
    
    Split those into two different functions (1) snap_to_alignment() and
    (2) valid_partition().  For now valid_partition() still calls
    snap_to_alignment() so there is no functional change with this commit.
    
    Closes #48 - Error when moving locked LUKS-encrypted partition

2019-06-09  Daniel Șerbănescu <daniel@serbanescu.dk>

    Update Romanian translation

2019-06-06  Wolfgang Stöggl <c72578@yahoo.de>

    Update German translation

2019-06-03  Balázs Úr <balazs@urbalazs.hu>

    Update Hungarian translation

2019-05-22  Félix Piédallu <felix@piedallu.me>

    Fix test (dentry->d_name is invalidated by closedir...) (!41)
    
    We have to copy the dentry->d_name before calling closedir().  If not,
    the string points to nothing and the test fails (It does not fail all
    the time, but only by chance).
    
    Confirmed using valgrind.  Selected output from running the unit test
    under valgrind:
    
      $ valgrind --track-origins=yes ./test_blockSpecial
      ==25110== Memcheck, a memory error detector
      ...
      ==25110== Command: ./test_BlockSpecial
      ==25110==
      Running main() from src/gtest_main.cc
      [==========] Running 26 tests from 1 test case.
      [----------] Global test environment set-up.
      [----------] 26 tests from BlockSpecialTest
      ...
      [ RUN      ] BlockSpecialTest.NamedBlockSpecialObjectBySymlinkMatches
      ==25110== Invalid read of size 1
      ==25110==    at 0x4C2C9B2: strlen (vg_replace_strmem.c:458)
      ==25110==    by 0x40E7C4: length (char_traits.h:259)
      ==25110==    by 0x40E7C4: append (basic_string.h:1009)
      ==25110==    by 0x40E7C4: operator+<char, std::char_traits<char>, std::allocator<char> > (basic_string.h:2468)
      ==25110==    by 0x40E7C4: get_link_name (test_BlockSpecial.cc:156)
      ==25110==    by 0x40E7C4: GParted::BlockSpecialTest_NamedBlockSpecialObjectBySymlinkMatches_Test::TestBody() (test_BlockSpecial.cc:247)
      ...
      =25110==  Address 0x1231ea93 is 115 bytes inside a block of size 32,816 free'd
      ==25110==    at 0x4C2ACBD: free (vg_replace_malloc.c:530)
      ==25110==    by 0x9F773AC: closedir (in /usr/lib64/libc-2.17.so)
      ==25110==    by 0x40E7AC: get_link_name (test_BlockSpecial.cc:153)
      ==25110==    by 0x40E7AC: GParted::BlockSpecialTest_NamedBlockSpecialObjectBySymlinkMatches_Test::TestBody() (test_BlockSpecial.cc:247)
      ...
      ==25110==  Block was alloc'd at
      ==25110==    at 0x4C29BC3: malloc (vg_replace_malloc.c:299)
      ==25110==    by 0x9F77280: __alloc_dir (in /usr/lib64/libc-2.17.so)
      ==25110==    by 0x40E746: get_link_name (test_BlockSpecial.cc:134)
      ==25110==    by 0x40E746: GParted::BlockSpecialTest_NamedBlockSpecialObjectBySymlinkMatches_Test::TestBody() (test_BlockSpecial.cc:247)
      ...
      ==25110== Invalid read of size 1
      ==25110==    at 0x4C2E220: memcpy@@GLIBC_2.14 (vg_replace_strmem.c:1022)
      ==25110==    by 0x953A997: std::string::append(char const*, unsigned long) (in /usr/lib64/libstdc++.so.6.0.19)
      ==25110==    by 0x40E7D2: append (basic_string.h:1009)
      ==25110==    by 0x40E7D2: operator+<char, std::char_traits<char>, std::allocator<char> > (basic_string.h:2468)
      ==25110==    by 0x40E7D2: get_link_name (test_BlockSpecial.cc:156)
      ==25110==    by 0x40E7D2: GParted::BlockSpecialTest_NamedBlockSpecialObjectBySymlinkMatches_Test::TestBody() (test_BlockSpecial.cc:247)
      ...
      ==25110==  Address 0x1231ea93 is 115 bytes inside a block of size 32,816 free'd
      ==25110==    at 0x4C2ACBD: free (vg_replace_malloc.c:530)
      ==25110==    by 0x9F773AC: closedir (in /usr/lib64/libc-2.17.so)
      ==25110==    by 0x40E7AC: get_link_name (test_BlockSpecial.cc:153)
      ==25110==    by 0x40E7AC: GParted::BlockSpecialTest_NamedBlockSpecialObjectBySymlinkMatches_Test::TestBody() (test_BlockSpecial.cc:247)
      ...
      ==25110==  Block was alloc'd at
      ==25110==    at 0x4C29BC3: malloc (vg_replace_malloc.c:299)
      ==25110==    by 0x9F77280: __alloc_dir (in /usr/lib64/libc-2.17.so)
      ==25110==    by 0x40E746: get_link_name (test_BlockSpecial.cc:134)
      ==25110==    by 0x40E746: GParted::BlockSpecialTest_NamedBlockSpecialObjectBySymlinkMatches_Test::TestBody() (test_BlockSpecial.cc:247)
      ...
      [       OK ] BlockSpecialTest.NamedBlockSpecialObjectBySymlinkMatches (50 ms)
    
    Selected lines from test_BlockSpecial.cc:
    
      132  static std::string get_link_name()
      133  {
      134          DIR * dir = opendir( "/dev/disk/by-id" );
      ...
      141          bool found = false;
      142          struct dirent * dentry;
      143          // Silence GCC [-Wparentheses] warning with double parentheses
      144          while ( ( dentry = readdir( dir ) ) )
      145          {
      146                  if ( strcmp( dentry->d_name, "." )  != 0 &&
      147                       strcmp( dentry->d_name, ". " ) != 0    )
      148                  {
      149                          found = true;
      150                          break;
      151                  }
      152          }
      153          closedir( dir );
      154
      155          if ( found )
      156                  return std::string( "/dev/disk/by-id/" ) + dentry->d_name;
    
    So the memory referred to by dentry was allocated on line 134, freed on
    153 and accessed after freed on 156.
    
    Closes !41 - Fix test (dentry->d_name is invalidated by closedir...)

2019-05-29  Curtis Gedak <gedakc@gmail.com>

    Fix link typo in French translation of GParted help manual

2019-05-29  Curtis Gedak <gedakc@gmail.com>

    Append -git to version for continuing development

2019-05-29  Curtis Gedak <gedakc@gmail.com>

    ==========   gparted-1.0.0   ==========

2019-05-29  Curtis Gedak <gedakc@gmail.com>

    Update copyright years

2019-05-28  Claude Paroz <claude@2xlibre.net>

    Update French translation

2019-05-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Fix reading NTFS usage after resize (#57)
    
    After an NTFS file system has been resized the command GParted currently
    uses to read the file system usage fails like this:
    
        # ntfsinfo --mft /dev/sdb1
        Volume is scheduled for check.
        Please boot into Windows TWICE, or use the 'force' option.
        NOTE: If you had not scheduled check and last time accessed this volume
        using ntfsmount and shutdown system properly, then init scripts in your
        distribution are broken. Please report to your distribution developers
        (NOT to us!) that init scripts kill ntfsmount or mount.ntfs-fuse during
        shutdown instead of proper umount.
        Failed to open '/dev/sdb1'.
    
    Fix by added the '--force' flag as described in the error message.
    
    Closes #57 - NTFS Resize results in Partition Information Warning on
                 Refresh

2019-05-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Report errors correctly on failure to read NTFS usage (#57)
    
    GParted uses ntfsinfo to read the NTFS file system usage.  However when
    ntfsinfo fails with a non-zero exit status GParted reports stdout twice,
    rather than stdout and stderr.  Correct this.
    
    Closes #57 - NTFS Resize results in Partition Information Warning on
                 Refresh

2019-05-26  Anders Jonsson <anders.jonsson@norsjovallen.se>

    Update Swedish translation

2019-05-26  Anders Jonsson <anders.jonsson@norsjovallen.se>

    Update Swedish translation

2019-05-25  Trần Ngọc Quân <vnwildman@gmail.com>

    Updated Vietnamese translation
    
    Signed-off-by: Trần Ngọc Quân <vnwildman@gmail.com>

2019-05-22  Jiri Grönroos <jiri.gronroos@iki.fi>

    Update Finnish translation

2019-05-22  Claude Paroz <claude@2xlibre.net>

    Update French translation

2019-05-22  Rafael Fontenelle <rafaelff@gnome.org>

    Update Brazilian Portuguese translation

2019-05-22  Sveinn í Felli <sv1@fellsnet.is>

    Update Icelandic translation

2019-05-03  Luca Bacci <luca.bacci982@gmail.com>

    Set the xalign property for Gtk::Labels (!40)
    
    With the same case as from the previous commit, the very long "Mounted
    on ..." text is now wrapped, but the text may not be left justified.
    Slowly adjust the dialog width and see how the text wrapping is updated
    to fit the size adjustment but the text is centred rather than left
    justified.
    
    This is because setting the halign property to Gtk::ALIGN_START does not
    guarantee left alignment of text for wrapped or ellipsized Gtk::Labels.
    
    Use the xalign property instead.
    
    To set the xalign property there is a method in the GtkMisc (Gtk::Misc)
    base class:
    
      gtk_misc_set_alignment (Gtk::Misc::set_alignment)
    
    However, GtkMisc (Gtk::Misc) was deprecated in Gtk 3.14 (Gtkmm 3.14)
    and in Gtk 3.16 (gtkmm 3.16) set_alignment() was replaced with the
    introduction of two new methods:
    
      gtk_label_set_xalign (Gtk::Label::set_xalign)
      gtk_label_set_yalign (Gtk::Label::set_yalign)
    
    Add a check for Gtkmm method Gtk::Label::set_xalign() in configure.ac
    and use it when available.
    
    References:
    
    [1] Gtk3 Reference Documentation - gtk_misc_set_alignment()
        https://developer.gnome.org/gtk3/stable/GtkMisc.html#gtk-misc-set-alignment
        "gtk_misc_set_alignment has been deprecated since version 3.14 and
        should not be used in newly-written code. Use GtkWidget's alignment
        ("halign" and "valign") and margin properties or GtkLabel's
        "xalign" and "yalign" properties."
    
    [2] Gtkmm 3.16 Gtk::Misc Class Reference, set_alignment() method
        https://developer.gnome.org/gtkmm/3.16/classGtk_1_1Misc.html#a52b2675874cf46a3097938756b9fe9e8
    
    [3] GNOME BugZilla - EmptyBoxes: instructions_label's alignment is off
        https://bugzilla.gnome.org/show_bug.cgi?id=735841
    
    [4] Gtk commit from 2014-09-16:
        GtkLabel: add x/yalign properties
        https://gitlab.gnome.org/GNOME/gtk/commit/d39424fc
    
    [5] Gtk3 Reference Documentation - gtk_label_set_xalign()
        https://developer.gnome.org/gtk3/stable/GtkLabel.html#gtk-label-set-xalign
    
    [6] Gtkmm 3.16 Gtk::Label Class Reference, set_xalign() method
        https://developer.gnome.org/gtkmm/3.16/classGtk_1_1Label.html#acee7d4e87d7cc14080a7b8ded5f84e5e
    
    Closes !40 - Limit wrapping labels

2019-05-01  Luca Bacci <luca.bacci982@gmail.com>

    Set a default max_width_chars for wrapping Gtk::Labels (!40)
    
    Opening the Partition Information dialog for a file system mounted on a
    very long mount point, or on openSUSE which mounts the OS from 10 btrfs
    subvolumes from the same partition, will cause the dialog to be very
    wide as the "Mounted on ..." text is not wrapped.
    
    Back in Gtk2, when width_chars / max_width_chars were not set, wrapping
    labels had a default width beyond which text wrapped onto a new line
    [1].
    
    For Gtk3 this default width was first reworked a bit [2], and then was
    removed for the very early Gtk3 3.0.10 release [3].
    
    It is recommended that applications explicitly set default values,
    otherwise wrapping labels never wrap when requesting their natural
    allocation.
    
    References:
    
    [1] Gtk 2.24.32 source code - gtk/gtklabel.c:2975
        https://gitlab.gnome.org/GNOME/gtk/blob/2.24.32/gtk/gtklabel.c#L2975
            "This long string gives a good enough length for any line to
            have."
    
    [2] Gtk commit from 2010-04-21:
        https://gitlab.gnome.org/GNOME/gtk/commit/680d7762baabb71aa77aeec793e3c70a2013d3b8
        Make sure not to base the minimum size on "max-width-chars", only
        the natural size.
            "This string is just about long enough."
    
    [3] Gtk commit from 2011-04-17:
        https://gitlab.gnome.org/GNOME/gtk/commit/c8ce1106c11361f8b47dd4e9a08db571c7d66d82
        label: Don't try to guess a label's size
    
        People should use window default sizes or label
        width-chars/max-width-chars to find the ideal layout for a label
        instead of relying on magic.
    
    Closes !40 - Limit wrapping labels

2019-05-01  Luca Bacci <luca.bacci982@gmail.com>

    Request natural width in Gtk::ScrolledWindows for Gtk >= 3.22 (!39)
    
    Before Gtk 3.22 GtkScrolledWindow propagated natural size to its
    Children and so on to descendants.  In Gtk 3.22 this was changed to
    always request the minimum size.  This was done because it is believed
    to be a safer default (gives a better behaviour) in case of dynamic
    content inside the scrolled window, that is, content that may change
    allocated size. [1][2][3]
    
    When the scrolled window content is not dynamic the natural size is
    preferable because it gives a better looking layout and without any
    downside.
    
    In the case of GParted content which is not dynamic, so request the
    scrolled windows to allocate children at natural sizes for Gtk >= 3.22.
    
    The benefits of natural size allocation are evident in presence of
    wrapping labels (for example inside the "Partition Info" dialog), that
    with the minimum size request likely end up taking a very small width.
    
    References:
    
    [1] Gtk commit from 2016-08-31:
        GtkScrolledWindow: Make propagation of natural child sizes optional
        https://gitlab.gnome.org/GNOME/gtk/commit/0984d1622d022bf67207f985f7842b6299818e20
        "Making propagation of child natural sizes mandatory (or default,
        even) was evidently a mistake as this causes dynamic content in a
        scrolled window to resize it's parent when the scrolled window is
        competing for space with an adjacent widget."
    
    [2] Gtk 3.22 Reference Documentation -
        gtk_scrolled_window_set_propagate_natural_width
        https://developer.gnome.org/gtk3/3.22/GtkScrolledWindow.html#gtk-scrolled-window-set-propagate-natural-width
    
    [3] Gtkmm 3.24 Gtk::ScrolledWindow Class Reference,
        set_propagate_natural_width() method
        https://developer.gnome.org/gtkmm/3.24/classGtk_1_1ScrolledWindow.html#a2d4cb945688ecb8739efd70b18742779
    
    [4] Gtkmm 3.21.6 NEWS
        https://gitlab.gnome.org/GNOME/gtkmm/blob/3.21.6/NEWS
        "ScrolledWindow: Added get/set_propagate_natural_height/width() and
        the properties."
    
    Closes !39 - Always request natural size inside Gtk::ScrolledWindow

2019-05-10  Rafael Fontenelle <rafaelff@gnome.org>

    Update Brazilian Portuguese translation

2019-05-01  Yuras Shumovich <shumovichy@gmail.com>

    Update Belarusian translation

2019-04-30  Seong-ho Cho <shcho@gnome.org>

    Update Korean translation

2018-05-09  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Replace deprecated get_vbox() with get_content_area() (!25)
    
    get_vbox() was deprecated in gtkmm 3.1.6 [1][2].  Switch to the
    get_content_area() replacement.  Note that GParted already requires
    gtkmm >= 3.4 as set in configure.ac.
    
    [1] Gtkmm 3.1.6 NEWS
        https://gitlab.gnome.org/GNOME/gtkmm/blob/3.1.6/NEWS
        "Dialog: Deprecate get_vbox(), replacing with get_content_area(),
        to match the C function name."
    
    [2] Gtkmm commit from 2011-06-13:
        Dialog: Deprecate get_vbox(), replacing with get_content_area().
        https://git.gnome.org/browse/gtkmm/commit/?id=5ccc289fa8e9b046c07f5ea234f5ced8c6356fc1
    
    Closes !25 - Modern Gtk3 - part 1

2019-03-13  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Grid for Dialog_Partition_Info (!25)
    
    Gtk::Table was deprecated in Gtk 3.4.0.  Replace with Gtk::Grid.
    
    This commit makes the change for Dialog_Partition_Info.
    
    Closes !25 - Modern Gtk3 - part 1

2019-03-07  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Grid for Win_GParted pt2 (!25)
    
    Gtk::Table was deprecated in Gtk 3.4.0.  Replace with Gtk::Grid.
    
    This commit makes the change for Win_GParted / pt2.
    
    Closes !25 - Modern Gtk3 - part 1

2019-03-06  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Grid for Win_GParted pt1 (!25)
    
    Gtk::Table was deprecated in Gtk 3.4.0.  Replace with Gtk::Grid.
    
    This commit makes the change for Win_GParted / pt1.
    
    Closes !25 - Modern Gtk3 - part 1

2019-03-06  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Grid for Dialog_Base_Partition (!25)
    
    Gtk::Table was deprecated in Gtk 3.4.0.  Replace with Gtk::Grid.
    
    This commit makes the change for Dialog_Base_Partition.
    
    Closes !25 - Modern Gtk3 - part 1

2019-03-06  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Grid for Dialog_Partition_New (!25)
    
    Gtk::Table was deprecated in Gtk 3.4.0 [1].  Replace with Gtk::Grid.
    Note that the meaning of the attachment parameters changed between
    Gtk::Table::attach() [2] from left, right, top, bottom and
    Gtk::Grid::attach() [3] to left, top, width, height.
    
    This commit makes the change for Dialog_Base_Partition.
    
    [1] Gtkmm 3.4 NEWS file (actually first included in gtkmm 3.3.2
        unstable)
        https://gitlab.gnome.org/GNOME/gtkmm/blob/3.4.0/NEWS#L162
            * Deprecate Gtk::Table in favour of Gtk::Grid.
    
    [2] Gtkmm 3.4 Gtk::Table Class Reference, attach() method
        https://developer.gnome.org/gtkmm/3.4/classGtk_1_1Table.html#a28b6926e68337a51ba29f2b4dd69f087
            Deprecated: 3.4: Use Gtk::Grid::attach() with Gtk:Grid.  Note
            that the attach argument differ between those two function.
    
    [3] Gtkmm 3.4 Gtk::Grid Class Reference, attach() method
        https://developer.gnome.org/gtkmm/3.4/classGtk_1_1Grid.html#a9c425e95660daff60a77fc0cafc18115
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Separator (!25)
    
    Gtk::HSeparator was deprecated in Gtkmm 3.2.  Replace with plain
    Gtk::Separator.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Paned (!25)
    
    Gtk::HPaned and Gtk::VPaned were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Paned.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for Dialog_Progress (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for Dialog_Progress.cc.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for Dialog_Rescue_Data (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for Dialog_Rescue_Data.cc.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for DialogPasswordEntry (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for DialogPasswordEntry.cc.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for Dialog_Partition_Name (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for Dialog_Partition_Name.cc.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for Dialog_FileSystem_Label (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for Dialog_FileSystem_Label.cc.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for DialogFeatures (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for DialogFeatures.cc.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for Dialog_DiskLabel (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for Dialog_DiskLabel.cc.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for Dialog_Partition_Info (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for Dialog_Partition_Info.{h,cc}.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for Dialog_Base_Partition (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for Dialog_Base_Partition.{h,cc}.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for HBoxOperations (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2.  Replace with
    plain Gtk::Box.
    
    This commit makes the change for HBoxOperations.{h,cc}.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-27  Luca Bacci <luca.bacci982@gmail.com>

    Use Gtk::Box for Win_GParted (!25)
    
    Gtk::HBox and Gtk::VBox were deprecated in Gtkmm 3.2 [1].  Replace with
    plain Gtk::Box.
    
    This commit makes the change for Win_GParted.{h,cc}.
    
    [1] Gtkmm 3.2.0 NEWS file (actually first included in gtkmm 3.1.6
        unstable)
        https://gitlab.gnome.org/GNOME/gtkmm/blob/3.2.0/NEWS#L91
            Gtk:
            * All H* or V* specialized classes have been deprecated, to
              match the deprecations in the GTK+ C API.  You should now
              set the orientation instead.
              This includes HBox, VBox, HButtonBox, VButtonBox, HPaned,
              VPaned, HScale, VScale, HSeparator, VSeparator, HScrollbar and
              VScrollbar.
    
    Closes !25 - Modern Gtk3 - part 1

2019-02-20  Luca Bacci <luca.bacci982@gmail.com>

    Use Gdk::RGBA (!25)
    
    The Gdk::RGBA data type was introduced to replace Gdk::Color in
    Gtkmm 3.0 [1], with Gdk::Color being deprecated in Gtkmm 3.10 [2].
    
    With this commit we make the change to Gdk::RGBA data type which is the
    modern replacement to Gdk::Color.  Gdk::RGBA can be used almost as a
    drop in replacement because it keeps most of the Gdk::Color interface.
    
    Also, this commit removes the C Gtk call introduced during the
    port-to-gtk3 patchset by commit:
        53793527668a344fe54ceb61a1afdc39c24c5c45
        repare-for-gtk3: Prepare for removal of Gtk::Widget::modify_fg() (#7)
    
    [1] Gtkmm 3.0.1 NEWS file
        https://gitlab.gnome.org/GNOME/gtkmm/blob/3.0.1/NEWS#L48
            * RGBA replaces Color, though Color still exists because it is
              used by TextView.  We hope to deprecated Color completely in
              gtkmm 3.2.
    
    [2] Gtkmm 3.10.0 NEWS file
        https://gitlab.gnome.org/GNOME/gtkmm/blob/3.10.0/NEWS#L127
            Gdk:
            * Deprecate Color.
    
    Closes !25 - Modern Gtk3 - part 1

2019-04-20  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Update includes in DialogFeatures.h and .cc
    
    Mostly add, but also remove, #includes so both DialogFeatures.h and .cc
    include exactly the header files each needs to get the definitions they
    use.
    
    Header file #include guards are there to specifically enable this.

2019-04-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename method to DialogFeatures::load_one_filesystem()
    
    To better reflect that it is loading the supported actions for one file
    system into the treeview, just like it's parent load_filesystems() is
    initiating the loading for all the file systems.

2019-04-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Fix available Partition menu options not being updated on rescan (!38)
    
    Select a partition and look at the available actions in the Partition
    menu.  Then add or remove some commands which that particular file
    system uses and rescan to detect those changes.  Open the Partition menu
    again.  It doesn't reflect the changes of supported actions seen in the
    File System Support dialog.  Select a different partition and then
    select the original partition again.  Now the available actions in the
    Partition menu reflect the changes of supported actions.
    
    Have been testing by adding and removing /sbin/e2label to add and
    remove EXT2/3/4 file system labelling support just because that feature
    has existed for a very long time and EXT2/3/4 are displayed near the top
    of the File System Support dialog.  Tested this minor issue existed as
    far back as GParted 0.3.7.
    
    Fix by simply also refreshing the valid operations to update the
    Partition menu after updating the found file system specific commands.
    
    Closes !38 - Fixes for minor issues with File System Support rescanning

2019-04-17  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Fix File System Support dialog not showing changes after rescan (!38)
    
    Open the File System Support dialog, either add or remove some file
    system specific commands used by GParted and press the
    [Rescan For Supported Actions] button.  The supported actions don't
    change.  However after just closing and reopening the dialog, the
    supported actions do reflect the added or removed file system specific
    commands.
    
    Bisected to this commit:
        4d6d46466478f656ce2ebb3c6b5a88cf0657667f
        Display "other" in the File System Support dialog (!13)
    
    The problem is that commit made a subset copy of the
    GParted_Core::FILESYSTEMS vector, obtained from get_filesystems(), so
    when the rescan ran and the FILESYSTEMS vector was updated with new
    supported actions, the dialog still displayed the original subset copy,
    so didn't reflect the changed supported actions.
    
    Fix by passing a reference to the GParted_Core::FILESYSTEMS vector,
    obtained from get_filesystems(), and perform the necessary filtering
    inside the dialog, like before the above faulty commit.  Additionally
    finding and adding "other" file system to the end of the list.
    
    Closes !38 - Fixes for minor issues with File System Support rescanning

2019-04-15  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Stop checking for 'ntfslabel --new-serial' support
    
    The oldest supported distributions have these versions of ntfs-3g /
    ntfsprogs.
    
      Distro             EOL        ntfs-3g / ntfsprogs
    - Debian 8           2020-Jun   2014.2.16AR.2
    - RHEL / CentOS 7    2024-Jun   2017.3.23
    - Ubuntu 14.04 LTS   2019-Apr   2013.1.13AR.1
    
    The oldest version of ntfs-3g / ntfsprogs on Ubuntu 14.04 LTS includes
    support for the --new-serial option.
    
        $ ntfslabel -V
    
        ntfslabel v2013.1.13AR.1 (libntfs-3g) - Display, or set, the label for an NTFS Volume.
    
        $ ntfslabel --help | grep -- --new-serial
                --new-serial   Set a new serial number
    
    Therefore it is no longer necessary to check for this option as it is
    always available.  The worst case scenario is that some how an old
    version of ntfslabel is used which doesn't support this option.  In such
    a case GParted goes from not supporting changing the UUID to claiming
    support, but presumably it would fail with an error reporting unknown
    option when applied.  Arguably better from an end user support point of
    view.

2019-04-14  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Consolidate common if have ntfsresize command conditions

2019-04-14  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Switch to faster ntfsinfo to read NTFS usage (#47)
    
    A user reported GParted was slow to refresh and timing ntfsresize to
    query his file systems found that it was taking 4.7 seconds and 9.2
    seconds for sizes 31.7 GiB and 49 GiB NTFS file systems respectively.
    Almost 14 seconds just to read the usage.
    
    Created a 4 GiB NTFS and filled it with as many 4 KiB files as possible,
    just over 800,000 files.
    
        # df -k /mnt/2
        Filesystem     1K-blocks    Used Available Use% Mounted on
        /dev/sdb2        4194300 4193860       440 100% /mnt/2
        # df -i /mnt/2
        Filesystem     Inodes  IUsed IFree IUse% Mounted on
        /dev/sdb2      819640 808591 11049   99% /mnt/2
    
    Testing perform of ntfsresize:
    
        # time ntfsresize --info --force --no-progress-bar /dev/sdb2 | \
        > egrep 'Current volume size|resize at|Cluster size'
        Cluster size       : 4096 bytes
        Current volume size: 4294963712 bytes (4295 MB)
        You might resize at 4294516736 bytes (freeing 450560 bytes).
    
        real    0m5.231s
        user    0m2.072s
        sys     0m3.014s
    
    Computation of figures:
        Clusters per volume = 4294963712 / 4096 = 1048575.125
        Free clusters = (4294963712 - 4294516736) / 4096 = 109.125
    
    Testing performance of ntfscluster, as used before this commit [1] from
    GParted 0.3 in 2006:
    
        # time ntfscluster --force /dev/sdb2 | \
        > egrep 'bytes per cluster|bytes per volume|clusters per volume|clusters of free space'
        ...
        bytes per cluster       : 4096
        bytes per volume        : 4294963200
        clusters per volume     : 131071
        clusters of free space  : 110
    
        real    0m4.243s
        user    0m1.629s
        sys     0m2.587s
    
    Note that the clusters per volume figure reported by ntfscluster is
    wrong.  4294963200 / 4096 = 1048575, not 131071.
    
    Testing performance using ntfsinfo:
    
        # time ntfsinfo --mft /dev/sdb2 | \
        egrep 'Cluster Size|Volume Size in Clusters|Free Clusters'
                Cluster Size: 4096
                Volume Size in Clusters: 1048575
                Free Clusters: 110 (0.0%)
    
        real    0m0.022s
        user    0m0.012s
        sys     0m0.018s
    
    Repeating the above tests while also using 'btrace /dev/sdb2' and Ctrl-C
    around each test via a separate terminal, reports these numbers of I/Os
    being performed:
      Command      Read requests   Read bytes
    - ntfsresize           2,695     1116 MiB
    - ntfscluster          2,685     1116 MiB
    - ntfsinfo                13     2208 KiB
    No wonder that ntfsresize and ntfscluster take a long time, they read
    just over 1 GiB of data from the 4 GiB file system, where as ntfsinfo
    only reads just over 2 MiB.
    
    Switch to using ntfsinfo to report file system usage.
    
    [1] 9d956594d6acf0d983ae9105df2f3772194a5404
        replaced ntfscluster with ntfsresize (see #350789)
    
    Closes #47 - GParted is slow refreshing NTFS file systems

2019-04-17  Daniel Mustieles <daniel.mustieles@gmail.com>

    Updated Spanish translation

2019-04-17  Daniel Mustieles <daniel.mustieles@gmail.com>

    Update Spanish translation

2019-04-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Prefer enum to string comparison in set_partition_type()

2019-04-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Stop trying unneeded alternative libparted linux-swap names
    
    With that same commit in parted 1.9 [1], libparted only recognised these
    linux-swap names via deprecated aliases:
        linux-swap(old)
        linux-swap(new)
    but does accept this name as a current alias:
        linux-swap
    for:
        linux-swap(v1)
    
    Demonstration:
        # parted -v
        parted (GNU parted) 2.1
        ...
    
        # parted /dev/sdc mkfs yes 1 "linux-swap(new)" unit s print
        ...
        [0] filesys.c:148 (ped_file_system_type_get(): File system alias linux-swap(new) is deprecated
        ...
        Number  Start  End       Size      Type     File system     Flags
         1      2048s  2099199s  2097152s  primary  linux-swap(v1)
    
        # parted /dev/sdc mkfs yes 1 "linux-swap" unit s print
        ...
        Number  Start  End       Size      Type     File system     Flags
         1      2048s  2099199s  2097152s  primary  linux-swap(v1)
    
    Again as GParted now requires libparted 2.2 or later:
    1) Stop using alternative "linux-swap(new)" name as that is deprecated
       by libparted.
    2) Also stop using alternative "linux-swap(v1)" name as that code is
       never used because libparted recognised the GParted "linux-swap"
       name as a current alias.
    
    [1] http://git.savannah.gnu.org/cgit/parted.git/commit/?id=cfafa4394998a11f871a0f8d172b13314f9062c2
        Rationalise linux-swap fs names, and add a "linux-swap" alias

2019-04-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Stop recognising retired libparted linux-swap names
    
    With this commit in parted 1.8.3 [1], libparted changed from reporting
    the name of Linux swap as:
        linux-swap
    to reporting either:
        linux-swap(old)
        linux-swap(new)
    Later with this commit in parted 1.9 [2], libparted stopped reporting
    those names and reported these instead:
        linux-swap(v0)
        linux-swap(v1)
    
    Demonstration:
        # mkswap /dev/sdc1
        Setting up swapspace version 1, size = 1048572 KiB
        no label, UUID=a2010834-003d-4bf2-9e94-58383fe20a26
        # blkid /dev/sdc1
        /dev/sdc1: UUID="a2010834-003d-4bf2-9e94-58383fe20a26" TYPE="swap"
        # parted -v
        parted (GNU parted) 2.1
        ...
        # parted /dev/sdc unit s print
        ...
        Number  Start  End       Size      Type     File system     Flags
         1      2048s  2099199s  2097152s  primary  linux-swap(v1)
    
    As GParted now requires libparted 2.2 or later [3], remove recognition
    for those no longer libparted reported linux-swap names.  Note that the
    "swap" name is reported by blkid.
    
    [1] http://git.savannah.gnu.org/cgit/parted.git/commit/?id=98a53fd115ca012edf226525b8d4be628454f99e
        Enable support for swsusp partitions, and the ability to
        differentiate between old and new versions of linux-swap partitions.
        Changed the swap_init signature and removed extra ped_geometry_read
        from _swap*_open.
    
    [2] http://git.savannah.gnu.org/cgit/parted.git/commit/?id=cfafa4394998a11f871a0f8d172b13314f9062c2
        Rationalise linux-swap fs names, and add a "linux-swap" alias
    
    [3] 8df975c7d1b5d69897f286bfc5574c51cf58c9d5
        Increase minimum required libparted to 2.2 (!22)

2019-04-13  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Set partition type when formatting to cleared (!36)
    
    Formatting a partition to cleared over the top of LVM2 PV leaves the
    "lvm" flag set on the partition; where as formatting with an actual file
    system over the top of an LVM2 PV clears the "lvm" flag.  This is true
    for both MSDOS and GPT partitioned drives.
    
    Fix by setting the partition type when formatting to cleared too.
    
    Closes !36 - Set partition type when clearing partition contents

2019-04-15  Stas Solovey <whats_up@tut.by>

    Update Russian translation

2019-04-14  Piotr Drąg <piotrdrag@gmail.com>

    Update Polish translation

2019-04-04  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove unnecessary #include from GParted_Core.cc

2019-04-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename Dialog_Progress member variable to m_curr_op
    
    Having a member variable named 't' which is used to share state in a
    Dialog_Progress object between on_signal_show() and on_cancel() methods
    is horrible.  Rename to something more meaningful.
    
    Also initialise m_curr_op in the constructor's initialisation list,
    rather than later when first used in on_signal_show().  Not strictly
    required, but avoids this POD (Plain Old Data) member variable being
    undefined in the Dialog_Progress object between construction and when
    on_signal_show() previously assigned to it for the first time and
    started using it.
    
    * C++ FAQ / Should my constructors use "initialization lists" or
      "assignment"?
      https://isocpp.org/wiki/faq/ctors#init-lists

2019-04-10  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename for loop counter variables to normative 'i' in Dialog_Progress
    
    Several for loops created counter variable t, hiding member variable of
    the same name.  Rename those loop counter variables to the normative
    name 'i'.
    
    * Why do most of us use 'i' as a loop counter variable?
      https://softwareengineering.stackexchange.com/questions/86904/why-do-most-of-us-use-i-as-a-loop-counter-variable

2019-04-07  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Use CSS to turn off table borders once in saved details HTML

2019-04-07  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename method to Dialog_Progress::write_operation_details()
    
    And update comment about replacing '\n' to reflect what the code
    actually does.

2019-04-05  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Additionally write partition information to saved details (#639176)
    
    Bug 639176 - Save partition layout to gparted_details.htm

2019-04-05  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Write starting device overview information to saved details (#639176)
    
    Writes the starting device overview information of all known devices to
    the top of the saved details HTML.  This is so that hopefully we don't
    need to additionally ask users for their disk layouts via 'fdisk -l',
    'parted print' and 'lsblk' when the saved details file is provided.
    
    Also moves the equals separators "==================" from below to
    above each operation so the each section is separated.
    
    Bug 639176 - Save partition layout to gparted_details.htm

2019-03-27  Luca Bacci <luca.bacci982@gmail.com>

    Ensure icon sizes (#39)
    
    Some icon themes only provide large icons for stock items.  This can
    cause problems like overly large icons appearing in the GParted UI.
    Found on Kubuntu 16.04 LTS with default breeze icon theme.
    
    Be compatible with these icon themes by forcing scaling of stock icons
    to the requested size.
    
    Icons are used either by Gtk::Image widgets, or Gtk::CellRendererPixbuf
    objects for comboboxes/treeviews.  For Gtk::Image widgets we add
    Utils::mk_image() that constructs Gtk::Image widgets and then sets the
    pixel-size property.  For Gtk::CellRendererPixbuf we add
    Utils::mk_pixbuf() that first loads a Gdk::Pixbuf and then scales if
    needed.
    
    Closes #39 - After GTK3 port icons are too big on KDE

2019-03-31  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Update distro specific package installation instructions
    
    - Back in Fedora 22 the distribution switched from using yum to dnf for
      package installation, while CentOS / RHEL continues to use yum.
      Separate out package instructions.
    
    - Update package dependencies for what is required on current versions
      of the documented distributions.

2019-03-31  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Also write "Root privileges are required ..." message to stderr (!34)
    
    To further help in diagnosing root authorisation issues by reporting the
    error message to the terminal too.  Also set a failure exit status when
    terminating with this error.
    
    Example:
        $ ./gpartedbin
        GParted 0.33.0-git
        configuration --enable-online-resize
        libparted 3.2
        Root privileges are required for running GParted
        $ echo $?
        1
    
    Closes !34 - Display more version and configuration information

2019-03-31  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Print new info before "Root privileges are required ..." dialog (!34)
    
    So that the new version and configuration information is displayed even
    if the gpartedbin executable is run as a non-root user.  To help with
    diagnosing root authorisation issues with the gparted shell wrapper
    script.
    
    Closes !34 - Display more version and configuration information

2019-03-30  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove now unused Dialog_Progress::signal_get_libparted_version (!34)
    
    ... and related GParted_Core::get_libparted_version() method.
    
    Closes !34 - Display more version and configuration information

2019-03-30  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Report the same information into saved operation details (!34)
    
    For consistency save the 3 same lines of information into the saved
    operation details.  None of the new 3 lines are subject to translation.
    As this information is really for our benefit when supporting users
    leaving them as English is OK.  Also "GParted" and "Libparted", as
    previously used, are proper nouns so they were never changed as part of
    any language translation.  See with:
        egrep -r '"(GParted|Libparted)"' po/
    
    Closes !34 - Display more version and configuration information

2019-03-30  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Display more version and configuration info to stdout when starting (!34)
    
    So that we might get more information from users when helping them.
    Starting GParted from the command line now looks like this:
        # ./gpartedbin
        GParted 0.33.0-git
        configuration --enable-online-resize
        libparted 3.2
    
    Closes !34 - Display more version and configuration information

2019-03-09  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename local variable to meaningful benchmark_copysize

2019-03-29  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Stop trying to access device '/dev/mapper/No RAID disks' (#786031)
    
    Running GParted on AltLinux with dmraid installed but with no configured
    RAID arrays produces this error:
        # gparted
        ...
        Could not stat device /dev/mapper/No RAID disks - No such file or directory.
    
    Most distributions use dmraid 1.0.0.rc16 which reports no raid disks
    like this:
        # dmraid -sa -c
        no raid disks
        # echo $?
        1
    
    However AltLinux had the slightly older version, dmraid 1.0.0.rc14,
    which reported no raid disks like this:
        # dmraid -sa -c
        No RAID disks
        # echo $?
        0
    
    So because dmraid 1.0.0.rc14 reported success, exit status 0, and the
    "No RAID disks" message was not in lower case, that text was considered
    a disk device in a DMRaid array.  Fix by checking for "no raid disks" in
    any case.
    
    Bug 786031 - Could not stat device /dev/mapper/No RAID disks - No such
                 file or directory

2019-03-28  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Pass constant parameter by reference to load_operations() (#788814)
    
    It is common C++ practice to pass a constant object by reference to
    avoid constructing a duplicate object for pass by value [1].
    
    [1] How to pass objects to functions in C++?
        https://stackoverflow.com/questions/2139224/how-to-pass-objects-to-functions-in-c/2139254#2139254
    
    Bug 788814 - gparted-0.30.0/include/HBoxOperations.h:37]: performance
                 problem

2019-03-26  Luca Bacci <luca.bacci982@gmail.com>

    Always show menu images (!32)
    
    There is a GtkSetting [1] that controls whether images in menus are
    shown or not.  On some distributions / desktops it is enabled by default
    and on others it is disabled by default.  To force show images in menus
    set the 'always-show-image' property to true in Gtk::ImageMenuItems [2].
    
    References:
    
    [1] Gtk3 Reference Documentation - Settings/gtk-menu-images
        https://developer.gnome.org/gtk3/stable/GtkSettings.html#GtkSettings--gtk-menu-images
    
    [2] Gtk3 Reference Documentation - GtkImageMenuItem
        https://developer.gnome.org/gtk3/stable/GtkImageMenuItem.html#gtk-image-menu-item-set-always-show-image
    
    Closes !32 - Always show menu images

2019-03-25  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Drop compose subdir (#46)
    
    It's no longer used so drop it.
    
    Closes #46 - Drop compose subdir

2019-03-25  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Replace String::ucompose() with Glibmm equivalent (#46)
    
    Glibmm has implemented a ustring::compose() set of methods [1] since
    Glibmm 2.16, circa 2008.  So replace String::ucompose().  Note that
    GParted already requires glibmm >= 2.32 as set in configure.ac.
    
    This commit just replaces all the method calls.  Edit created by:
        sed -i 's|String::ucompose *|Glib::ustring::compose|' src/*.cc
    
    [1] Glibmm Reference Manual, Glib::ustring Class, compose() method
        https://developer.gnome.org/glibmm/2.32/classGlib_1_1ustring.html#a64ff7ac3d9e9899c2910f1d831f8d500
    
    Closes #46 - Drop compose subdir

2019-03-23  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Recognise contribution by Antoine Viallon

2019-03-17  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Raise the maximum F2FS label size to 127 characters (!29)
    
    Fix to make mkfs.f2fs properly handle labels longer than 16 characters
    was included in f2fs-tools 1.2.0 [1].  The oldest supported
    distributions now include this release:
      Distro             EOL        f2fs-tools
    - Debian 8           2020-Jun   1.4.0
    - RHEL / CentOS 7    2024-Jun   1.4.1
    - SLES 12            2027-Oct   Unknown
    - Ubuntu 14.04 LTS   2019-Apr   1.2.0
    
    Note that on Ubuntu 14.04 LTS blkid from util-linux 2.20.1 is too old to
    recognise F2FS file systems, as 2.23 is required for F2FS support [2].
    
    mkfs.f2fs claims the maximum label length is less than 512 characters,
    but actually accepts 512 characters.
    
        # label=`head -c 1024 < /dev/zero | tr '\0' 'A'`
        # mkfs.f2fs -l `echo -n "$label" | cut -c1-513` /dev/sdb10
    
                F2FS-tools: mkfs.f2fs Ver: 1.4.0 (2014-09-18)
    
        Error: Volume Label should be less than      512 characters
    
        Usage: mkfs.f2fs [options] device [sectors]
        [options]:
          -a heap-based allocation [default:1]
          -d debug level [default:0]
          -e [extension list] e.g. "mp3,gif,mov"
          -l label
          -o overprovision ratio [default:5]
          -s # of segments per section [default:1]
          -z # of sections per zone [default:1]
          -t 0: nodiscard, 1: discard [default:1]
        sectors: number of sectors. [default: determined by device size]
        # echo $?
        1
    
        # mkfs.f2fs -l `echo -n "$label" | cut -c1-512` /dev/sdb10
    
                F2FS-tools: mkfs.f2fs Ver: 1.4.0 (2014-09-18)
    
        Info: Label = AAAAAAAAAAAA...[trimmed from 512 "A"s]...AAAAAAAAAAAA
        Info: sector size = 512
        Info: total sectors = 1048576 (in 512bytes)
        Info: zone aligned segment0 blkaddr: 256
        Info: Discarding device
        Info: This device doesn't support TRIM
        Info: format successful
        # echo $?
        0
    
        # blkid -V
        blkid from util-linux 2.25.2  (libblkid 2.25.0, 24-Oct-2014)
        # blkid /dev/sdb
        /dev/sdb10: LABEL="AAAAAAAAAAAA...[only 127 "A"s]...AAAAAAAAAAAA"
        UUID="f47f3fdc-dd91-4616-bb6d-0d643a884265" TYPE="f2fs"
        PARTUUID="3bb4bef8-9494-4e82-8dda-5d8edd9c60d9"
    
    As blkid only reports the first 127 characters and is the only command
    used for reading the label of an F2FS file system, use this as the new
    increased limit.
    
    [1] https://git.kernel.org/pub/scm/linux/kernel/git/jaegeuk/f2fs-tools.git/commit/?id=9799d6364dc93e1fd259d812d4a50ed984a6456b
        mkfs: handle labels longer than 16 characters
    
    [2] https://mirrors.edge.kernel.org/pub/linux/utils/util-linux/v2.23/v2.23-ReleaseNotes
        "add Flash-Friendly File System (f2fs) support  [Alejandro Martinez
        Ruiz]"
    
    Closes !29 - Enhance F2FS support

2019-03-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Drop fsck.f2fs -y option not available before f2fs-tools 1.10.0 (!29)
    
    On CentOS 7 with f2fs-tools 1.4.1, checking an F2FS file system fails
    like this:
        # fsck.f2fs -f -y -a /dev/sdb3
        Info: Force to fix corruption
        fsck.f2fs: invalid option -- 'y'
                Error: Unknown option ?
    
        Usage: fsck.f2fs [options] device
        [options]:
          -a check/fix potential corruption, reported by f2fs
          -d debug level default:0]
          -f check/fix entire partition
          -t show directory tree [-d -1]
        # echo $?
        1
    
    Turns out that the '-y' option was not available until f2fs-tools 1.10.0
    and is identical to the existing '-f' option anyway [1], which GParted
    already uses.  Just remove the '-y' option passed to fsck.f2fs.
    
    [1] https://git.kernel.org/pub/scm/linux/kernel/git/jaegeuk/f2fs-tools.git/commit/?id=55ee9e7202f84168f868d863da8ed1c4995a0e6d
        fsck.f2fs: add -y for generic fsck
    
    Closes !29 - Enhance F2FS support

2019-03-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Handle missing FS size information before f2fs-tools 1.5.0 (!29)
    
    Before this commit [1] first included in f2fs-tools 1.5.0, dump.f2fs
    didn't report the total space used by the file system.  This causes F2FS
    file system usage not be reported on older distributions, including
    RHEL/CentOS 7 and Debian 8.
    
    On CentOS 7:
        # rpm -q f2fs-tools
        f2fs-tools-1.4.1-2.el7.nux.x86_64
        # dump.f2fs -d 1 /dev/sdb3 | egrep 'sector size =|total.*sectors ='
        Info: sector size = 512
        Info: total sectors = 2097152 (in 512 bytes)
    
    On Fedora 28:
        # rpm -q f2fs-tools
        f2f2-tools-1.10.0-1.fc28.x86_64
        # dump.f2fs -d 1 /dev/sdb2 | egrep -a 'sector size =|total.*sectors ='
        Info: sector size = 512
        Info: total sectors = 3145728 (1536 MB)
        Info: total FS sectors = 2621440 (1280 MB)
    
    "total sectors" reports the size of the partition.
    "total FS sectors" reports the size of the file system.
    
    Cope with the file system size being missing.  Pass -1 as the file
    system size to partition.set_sector_usage() in this case.  Note that
    this means GParted won't be able to detect and report unallocated space
    within the partition when using f2fs-tools < 1.5.0.
    
    [1] https://git.kernel.org/pub/scm/linux/kernel/git/jaegeuk/f2fs-tools.git/commit/?id=fea6162a6db9af527648262d9fbb0335a0cc5460
        fsck.f2fs: show total sectors consumed by filesystem
    
    Closes !29 - Enhance F2FS support

2019-03-19  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Make F2FS usage parsing handle NULs in dump.f2fs output (!29)
    
    On Fedora 28 with f2fs-tools 1.10.0, dump.f2fs is producing NUL
    characters in it's output and this completely breaks the parsing code in
    f2fs::set_used_sectors().  Glib::Regex, as used by
    Utils::regexp_label(), just doesn't match any text after the first NUL
    character from the output.
    
        # dump.f2fs -d 1 /dev/sdb1
        Info: Debug level = 1
        Info: [/dev/sdb1] Disk Model: VBOX HARDDISK   1.0 ^@^@^@^@^@^@^@^...
        Info: Segments per section = 1
        Info: Sections per zone = 1
        Info: sector size = 512
        Info: total sectors = 2097152 (1024 MB)
        ...
    
    Grep thinks the output is binary too:
    
        # dump.f2fs -d 1 /dev/sdb1 | \
        > egrep 'valid_block_count|user_block_count|log_blocksize|sector size =|total FS sectors ='
        Binary file (standard input) matches
    
        # dump.f2fs -d 1 /dev/sdb1 | \
        > egrep --text 'valid_block_count|user_block_count|log_blocksize|sector size =|total FS sectors ='
        Info: sector size = 512
        log_blocksize                           [0x       c : 12]
        Info: total FS sectors = 2097152 (1024 MB)
        user_block_count                        [0x   36400 : 222208]
        valid_block_count                       [0x       2 : 2]
    
    Re-write set_used_sectors() using string find() and sscanf() to be
    similar to how a number of the other set_used_sectors() are written for
    other file systems.
    
    Closes !29 - Enhance F2FS support

2019-03-15  Antoine Viallon <antoine.viallon@gmail.com>

    Enhance F2FS support (!29)
    
    - Adds reading of file system usage
    - Adds resize (grow) support
    - Adds verify support
    
    Closes !29 - Enhance F2FS support

2019-02-18  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Go back to symbolic label widget alignment constants
    
    Now that GParted requires Gtk3 there is no need to use floating point
    numbers for compatibility with Gtk <= 2.22.  Replace with symbolic
    alignment constants.
    
    Relevant commit history:
    
    *   6efa6234012b5fa112af4db08e0b89238d53981a
        Add optional yalign argument to Utils::mk_label() method
    
    *   be2689ad25c104e3cb97e7d5d1f7627dbb137b19
        Stop using deprecated widget alignment enumerators (#652044)

2019-03-23  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Pass message parameters by reference to 2 Partition methods (#788813)
    
    Note that this almost certainly has no performance benefit what so ever
    because the methods are implicitly defined as inline [1][2] and the
    compiler will have simply inlined the method bodies thus avoiding having
    to construct copies of the passed parameters.
    
    Do this anyway as constant objects are typically passed by reference
    [3].  Also C++'s std::vector::push_back() [4] takes a const reference
    parameter so update the kind of equivalent push_back_message() to take
    a const reference parameter too.
    
    [1] C++ reference / inline specifier
        https://en.cppreference.com/w/cpp/language/inline
    
            A function defined entirely inside a class/struct/union
            definition, whether it's a member function or a non-member
            friend function, is implicitly an inline function.
    
    [2] When should I write the keyword 'inline' for a function/method?
        https://stackoverflow.com/questions/1759300/when-should-i-write-the-keyword-inline-for-a-function-method/1759575#1759575
    
    [3] How to pass objects to functions in C++?
        https://stackoverflow.com/questions/2139224/how-to-pass-objects-to-functions-in-c/2139254#2139254
    
    [4] C++ reference / std::vector::push
        https://en.cppreference.com/w/cpp/container/vector/push_back
    
            void push_back(const T& value);
    
    Bug 788813 - gparted-0.30.0/include/Partition.h:137]: performance
                 problem

2019-03-12  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Stop checking for 'btrfs filesystem label' support (!26)
    
    btrfs-progs 3.12 includes 'btrfs filesystem label /dev/PTN NEWLABEL'
    functionality so stop checking for this before enabling setting the
    label.
    
        $ btrfs version
        Btrfs v3.12
        $ btrfs filesystem label --help
        usage: btrfs filesystem label [<device>|<mount_point>] [<newlabel>]
    
            Get or change the label of a filesystem
    
            With one argument, get the label of filesystem on <device>.
            If <newlabel> is passed, set the filesystem label on <newlabel>.
    
        $ echo $?
        0
    
    Worst case scenario is that some how an old version of the btrfs command
    is used which doesn't support the labelling functionality.  Then this
    commit would change GParted from disallowing labelling of a btrfs, to
    allowing it, but presumably it would fail with an error from the btrfs
    command reporting so.  Arguably better from a support point of view.
    
    Closes !26 - Remove support for btrfs-progs < 3.12

2019-03-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Replace use of deprecated btrfsck (!26)
    
    In btrfs-progs 3.12, btrfsck is a hard link to the multi-tool btrfs
    executable.  When run as 'btrfsck' it just implements 'btrfs check'
    [1][2][3][4].
    
    In btrfs-progs 3.14.2 the btrfsck man page is re-added as a symlink to
    the btrfs-check man page and reports that btrfsck is deprecated [5].
    
    Therefore replace use of 'btrfsck' with 'btrfs check'.
    
    [1] https://git.kernel.org/pub/scm/linux/kernel/git/kdave/btrfs-progs.git/commit/?id=fac45410e9a783c187ae83d993d3bf3350d05149
        Btrfs-progs: Rename btrfsck.c -> cmds-check.c
    
    [2] https://git.kernel.org/pub/scm/linux/kernel/git/kdave/btrfs-progs.git/commit/?id=5956f752c66d5259bbb17a2dd47ee8c8cc0e5f4f
        Btrfs-progs: add btrfsck functionality to btrfs
    
    [3] https://git.kernel.org/pub/scm/linux/kernel/git/kdave/btrfs-progs.git/commit/?id=d5d2046ae3b216af22a8a37c940f2412ba519b6e
        Btrfs-progs: add btrfsck name detection to btrfs
    
    [4] https://git.kernel.org/pub/scm/linux/kernel/git/kdave/btrfs-progs.git/commit/?id=e31f6172aa1d6ec5d562f56086819a0f4bc8a914
        btrfs-progs: build btrsfck to keep compatibility
    
    [5] https://git.kernel.org/pub/scm/linux/kernel/git/kdave/btrfs-progs.git/commit/?id=fddeecb7d424d5bb1a93a19a5e537057a4a7f597
        btrfs-progs: doc: link btrfsck to btrfs-check
    
    Closes !26 - Remove support for btrfs-progs < 3.12

2019-03-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Stop using removed btrfsctl (!26)
    
    That commit [1] also removed btrfsctl from btrfs-progs 3.12 so also stop
    using it as a fallback.
    
    [1] https://git.kernel.org/pub/scm/linux/kernel/git/kdave/btrfs-progs.git/commit/?id=f243fcd1b2aa55ffadfbcc032c66dedbee56e79e
        Removing btrfsctl, btrfs-vol, btrfs-show
    
    Closes !26 - Remove support for btrfs-progs < 3.12

2019-03-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Finish removal of btrfs-show (!26)
    
    Remove use of btrfs-show from everywhere else in the btrfs module.
    
    Closes !26 - Remove support for btrfs-progs < 3.12

2019-03-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Stop using removed btrfs-show to read the label (!26)
    
    This commit [1] from btrfs-progs 3.12 removed the previously deprecated
    programs btrfsctl and btrfs-show.  As btrfs-progs 3.12 is now the
    minimum requirement, remove support for those removed programs.
    
    This commit is just removing the use of btrfs-show as a fallback to read
    the label.
    
    Note that 'btrfs-show /dev/PTN' didn't distinguish between a label of
    "none" and no label.  Hence the logic in btrfs::read_label() to do with
    matching the label "none", or matching the label with or without single
    quotes.  Unfortunately as identified in this commit [2]
    'btrfs filesystem show /dev/PTN' is subject to the same issue, but only
    when the file system is mounted and only for btrfs-progs 3.12.  This was
    fixed by this commit [3] from btrfs-progs 3.14.
    
    [1] https://git.kernel.org/pub/scm/linux/kernel/git/kdave/btrfs-progs.git/commit/?id=f243fcd1b2aa55ffadfbcc032c66dedbee56e79e
        Removing btrfsctl, btrfs-vol, btrfs-show
    
    [2] eca732fb0cefe35db76a7ac96145e2004e8eed08
        Update parsing of btrfs filesystem show for the label (#733601)
    
    [3] https://git.kernel.org/pub/scm/linux/kernel/git/kdave/btrfs-progs.git/commit/?id=a156b967ed9bd606afa8dc402451abcf07226c17
        btrfs-progs: make filesystem show by label work
    
    Closes !26 - Remove support for btrfs-progs < 3.12

2019-03-11  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove old workaround for btrfs resizing on Linux < 3.2 (!26)
    
    PATCHSET OVERVIEW
    
    The oldest supported distributions have these versions of the Linux
    kernel and btrfs-progs:
      Distro             EOL        kernel    btrfs-progs
    - RHEL / CentOS 7    2024-Jun   3.10.0    4.9.1
    - Ubuntu 14.04 LTS   2019-Apr   4.4.0     3.12
    - Debian 8           2020-Jun   3.16.0    3.17
    - SLES 12            2027-Oct   3.12.28   3.16
    
    Making the oldest supported packages be kernel 3.10 and btrfs-progs 3.12
    allows the btrfs support code to be simplified by removing backward
    compatibility.
    
    THIS CHANGE
    
    Remove old workaround for ignoring the error when resizing a btrfs to
    the same size on Linux kernel < 3.2.
    
    Also now that only exit status 0 is considered successful from btrfs
    resize, the EXEC_CHECK_STATUS flag to execute_command() can be used,
    rather than having to separately call set_status() afterwards.
    
    Relevant commit history:
    *   11d044dba0c07a5c51843beec6ff38f0c55303d8
        Don't ignore any errors resizing btrfs on Linux >= 3.2 (#669389)
    *   a580abbc30e88cb1895af342d43dcbb98183a9d5
        Use newer btrfs multi-tool control command first
    
    Closes !26 - Remove support for btrfs-progs < 3.12

2019-03-14  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Set title of Resize/Move dialog for an extended partition (#44)
    
    The title has never been set in this case, and defaulted to the name of
    the executable 'gpartedbin'.  Fix this.
    
    Closes #44 - Title not set in Resize/Move dialog for extended partitions

2019-03-03  Trần Ngọc Quân <vnwildman@gmail.com>

    Updated Vietnamese translation
    
    Signed-off-by: Trần Ngọc Quân <vnwildman@gmail.com>

2019-02-28  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Initialise local POD 'launched' variable in show_help()
    
    'launched' local POD (Plain Old Data) variable was left uninitialised,
    but was set in both the try and catch clauses.  Best practice is to
    initialise when defined, so do that instead.  Cosmetic change.

2019-02-28  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Rename Win_GParted method to show_help()
    
    It is not creating a dialog (a pop-up window managed by GParted code
    itself).  It is launching independent yelp program to display the help,
    so remove the "_dialog" from the name to avoid any possible confusion.

2019-02-27  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Restore specific error message on failure to launch yelp
    
    Originally, if the yelp command was not installed, attempting to display
    help produced an error dialog with this message:
        Failed to execute child process "yelp" (No such file or directory)
    
    However since this commit during the Gtk 3 port [1] the error message
    became this less useful one:
        Operation not supported
    
    Two attempts are made to display the GParted Manual, first using
    gtk_show_uri() and second by executing the yelp command directly.  Prior
    to the aforementioned commit [1] both methods returned the failure
    reason using the same 'error' variable.  Hence reported the message
    "Failed to execute child process "yelp" ..." from the second attempt.
    However that commit had to re-code the second method as part of the Gtk
    3 port and use a different error returning mechanism, thus the use of
    different variable 'e'.  But the dialog was left reporting the message
    from the original 'error' variable, thus reporting "Operation not
    supported" message from the first attempt using gtk_show_uri().
    
    Fix by again displaying the message from the second failure into the
    error dialog.  Also make it very clear there are two error returning
    variables by naming them 'error1' and 'error2_msg'.
    
    [1] 2953778a4c0e61d8fe49c7a6d707add8a9eb0634
        port-to-gtk3: Use Gdk::AppLaunchContext to launch yelp (#7)

2019-02-25  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Remove deprecated PKG_NAME from autogen.sh
    
    Use of PKG_NAME is deprecated in GNOME 3 and produced this warning:
    
        $ ./autogen.sh
        /usr/bin/gnome-autogen.sh
        /usr/bin/yelp-build
        ***Warning*** PKG_NAME is deprecated, you may remove it from autogen.sh
        ...
    
    Now that GParted is a GNOME 3 application with GNOME 3 yelp-tools
    managed documentation this is redundant and can be removed.  Previous
    further analysis:
    
        GNOME Bugzilla, Bug 743318, comment 18
        https://bugzilla.gnome.org/show_bug.cgi?id=743318#c18
        "
        PKG_NAME is still used in GNOME 2.28's gnome-autogen.sh in error
        messages.  (GNOME 3's gnome-autogen.sh queries it from configure.ac
        instead of requiring it to be set).
        "
    
    Also confirmed that it makes no difference by running ./autogen.sh with
    and without PKG_NAME being set.  The produced GParted build trees were
    the same.  Therefore the release and executable can't be affected.

2019-02-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Drop now unnecessary editing of xmllint command line in CI tests (!24)
    
    GNOME 3's yelp doesn't use scrollkeeper or the OMF catalog, so the
    constructed Makefile doesn't use xmllint to validate the scrollkeeper
    DTD file.  Therefore remove attempted sed edit of that line which no
    longer exists in the Makefile.
    
    Note that help/Makefile.am's @YELP_HELP_RULES@ automake macro expansion
    comes from /usr/share/aclocal/yelp.m4 [1].
    
    Commit which previously needed to add the sed edit:
        cbb25a2511ec9e355b4dbba288689bbc00b7af65
        Stop xmllint scrollkeeper-omf.dtd fetch failure breaking CI tests (#9)
    
    [1] Yelp > Yelp Tools > yelp.m4
        http://yelp.io/tools/yelp.m4.html
    
    Closes !24 - Port to GNOME 3 yelp-tools documentation infrastructure

2019-02-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Launch help from GParted using the new GNOME 3 help: prefix (!24)
    
    Update GParted to specify the GParted Manual using the new GNOME 3 way
    with the 'help:' prefix to avoid yelp reporting this error:
        Document Not Found
        The URI 'ghelp:gparted' does not point to a valid page.
    
    Closes !24 - Port to GNOME 3 yelp-tools documentation infrastructure

2019-02-24  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Allow GNOME 3 yelp to display the GParted Manual (!24)
    
    Now with GNOME 3 style help installed, running 'yelp help:gparted'
    results in this error being displayed in yelp:
        Page Not Found
        The requested page was not found in the document 'help:gparted'.
    
    Where as running 'yelp help:gparted/gparted' correctly displays the
    GParted Manual.
    
    Fix by renaming the article tag to the default 'index' that yelp is
    expecting when using the new GNOME 3 'help:' prefix.
    
    Closes !24 - Port to GNOME 3 yelp-tools documentation infrastructure

2019-02-23  Mike Fleetwood <mike.fleetwood@googlemail.com>

    Add use of new GNOME 3 yelp-tools documentation infrastructure (!24)
    
    Second part is to use yelp-tools to build and install the documentation.
    Have to rename the help Manual from help/C/gparted.xml to
    help/C/index.docbook in accordance with this note from the GNOME Goal:
